{-# OPTIONS_GHC -w #-}
{-# OPTIONS -fglasgow-exts -cpp #-}
{-# LANGUAGE ExistentialQuantification, Rank2Types #-}
module Language.SQL.SQLite.Syntax (
                                   lexModuleArgument,
                                   ParseError,
                                   readType,
                                   readMaybeType,
                                   readMaybeTypeSize,
                                   readTypeSizeField,
                                   readLikeType,
                                   readMaybeSwitchExpression,
                                   readCasePair,
                                   readEscape,
                                   readElse,
                                   readExpression,
                                   readMaybeUnique,
                                   readMaybeIfNotExists,
                                   readMaybeIfExists,
                                   readMaybeForEachRow,
                                   readMaybeTemporary,
                                   readMaybeCollation,
                                   readMaybeAscDesc,
                                   readMaybeAutoincrement,
                                   readMaybeSign,
                                   readMaybeColumn,
                                   readAlterTableBody,
                                   readColumnDefinition,
                                   readDefaultValue,
                                   readIndexedColumn,
                                   readColumnConstraint,
                                   readTableConstraint,
                                   readMaybeConstraintName,
                                   readTriggerTime,
                                   readTriggerCondition,
                                   readModuleArgument,
                                   readTriggerStatement,
                                   readQualifiedTableName,
                                   readOrderingTerm,
                                   readPragmaBody,
                                   readPragmaValue,
                                   readCreateTableBody,
                                   readInsertHead,
                                   readInsertBody,
                                   readUpdateHead,
                                   readDistinctness,
                                   readMaybeHaving,
                                   readMaybeAs,
                                   readCompoundOperator,
                                   readSelectCore,
                                   readResultColumn,
                                   readJoinSource,
                                   readSingleSource,
                                   readJoinOperation,
                                   readJoinConstraint,
                                   readMaybeIndexedBy,
                                   readFromClause,
                                   readWhereClause,
                                   readGroupClause,
                                   readOrderClause,
                                   readLimitClause,
                                   readWhenClause,
                                   readConflictClause,
                                   readForeignKeyClause,
                                   readForeignKeyClauseActionOrMatchPart,
                                   readForeignKeyClauseActionPart,
                                   readMaybeForeignKeyClauseDeferrablePart,
                                   readMaybeInitialDeferralStatus,
                                   readCommitHead,
                                   readMaybeTransaction,
                                   readMaybeTransactionType,
                                   readMaybeDatabase,
                                   readMaybeSavepoint,
                                   readMaybeReleaseSavepoint,
                                   readStatementList,
                                   readAnyStatement,
                                   readExplainableStatement,
                                   readExplain,
                                   readExplainQueryPlan,
                                   readAlterTable,
                                   readAnalyze,
                                   readAttach,
                                   readBegin,
                                   readCommit,
                                   readCreateIndex,
                                   readCreateTable,
                                   readCreateTrigger,
                                   readCreateView,
                                   readCreateVirtualTable,
                                   readDelete,
                                   readDeleteLimited,
                                   readDeleteOrDeleteLimited,
                                   readDetach,
                                   readDropIndex,
                                   readDropTable,
                                   readDropTrigger,
                                   readDropView,
                                   readInsert,
                                   readPragma,
                                   readReindex,
                                   readRelease,
                                   readRollback,
                                   readSavepoint,
                                   readSelect,
                                   readUpdate,
                                   readUpdateLimited,
                                   readUpdateOrUpdateLimited,
                                   readVacuum,
                                   readUnqualifiedIdentifier,
                                   readSinglyQualifiedIdentifier,
                                   readDoublyQualifiedIdentifier
        			  )
    where

import Control.Monad.Error
import Control.Monad.State
import Data.Char
import Data.Maybe
import Data.Word
import Numeric

import Language.SQL.SQLite.Types
import qualified Data.Array as Happy_Data_Array
import qualified GHC.Exts as Happy_GHC_Exts

-- parser produced by Happy Version 1.18.6

newtype HappyAbsSyn  = HappyAbsSyn HappyAny
#if __GLASGOW_HASKELL__ >= 607
type HappyAny = Happy_GHC_Exts.Any
#else
type HappyAny = forall a . a
#endif
happyIn108 :: (Type) -> (HappyAbsSyn )
happyIn108 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn108 #-}
happyOut108 :: (HappyAbsSyn ) -> (Type)
happyOut108 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut108 #-}
happyIn109 :: (MaybeType) -> (HappyAbsSyn )
happyIn109 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn109 #-}
happyOut109 :: (HappyAbsSyn ) -> (MaybeType)
happyOut109 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut109 #-}
happyIn110 :: (MaybeTypeSize) -> (HappyAbsSyn )
happyIn110 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn110 #-}
happyOut110 :: (HappyAbsSyn ) -> (MaybeTypeSize)
happyOut110 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut110 #-}
happyIn111 :: (TypeSizeField) -> (HappyAbsSyn )
happyIn111 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn111 #-}
happyOut111 :: (HappyAbsSyn ) -> (TypeSizeField)
happyOut111 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut111 #-}
happyIn112 :: (LikeType) -> (HappyAbsSyn )
happyIn112 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn112 #-}
happyOut112 :: (HappyAbsSyn ) -> (LikeType)
happyOut112 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut112 #-}
happyIn113 :: (Escape) -> (HappyAbsSyn )
happyIn113 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn113 #-}
happyOut113 :: (HappyAbsSyn ) -> (Escape)
happyOut113 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut113 #-}
happyIn114 :: (Expression) -> (HappyAbsSyn )
happyIn114 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn114 #-}
happyOut114 :: (HappyAbsSyn ) -> (Expression)
happyOut114 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut114 #-}
happyIn115 :: (Expression) -> (HappyAbsSyn )
happyIn115 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn115 #-}
happyOut115 :: (HappyAbsSyn ) -> (Expression)
happyOut115 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut115 #-}
happyIn116 :: (Expression) -> (HappyAbsSyn )
happyIn116 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn116 #-}
happyOut116 :: (HappyAbsSyn ) -> (Expression)
happyOut116 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut116 #-}
happyIn117 :: (Expression) -> (HappyAbsSyn )
happyIn117 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn117 #-}
happyOut117 :: (HappyAbsSyn ) -> (Expression)
happyOut117 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut117 #-}
happyIn118 :: (Expression) -> (HappyAbsSyn )
happyIn118 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn118 #-}
happyOut118 :: (HappyAbsSyn ) -> (Expression)
happyOut118 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut118 #-}
happyIn119 :: (Expression) -> (HappyAbsSyn )
happyIn119 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn119 #-}
happyOut119 :: (HappyAbsSyn ) -> (Expression)
happyOut119 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut119 #-}
happyIn120 :: (Expression) -> (HappyAbsSyn )
happyIn120 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn120 #-}
happyOut120 :: (HappyAbsSyn ) -> (Expression)
happyOut120 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut120 #-}
happyIn121 :: (Expression) -> (HappyAbsSyn )
happyIn121 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn121 #-}
happyOut121 :: (HappyAbsSyn ) -> (Expression)
happyOut121 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut121 #-}
happyIn122 :: (Expression) -> (HappyAbsSyn )
happyIn122 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn122 #-}
happyOut122 :: (HappyAbsSyn ) -> (Expression)
happyOut122 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut122 #-}
happyIn123 :: (Expression) -> (HappyAbsSyn )
happyIn123 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn123 #-}
happyOut123 :: (HappyAbsSyn ) -> (Expression)
happyOut123 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut123 #-}
happyIn124 :: (Expression) -> (HappyAbsSyn )
happyIn124 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn124 #-}
happyOut124 :: (HappyAbsSyn ) -> (Expression)
happyOut124 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut124 #-}
happyIn125 :: (Expression) -> (HappyAbsSyn )
happyIn125 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn125 #-}
happyOut125 :: (HappyAbsSyn ) -> (Expression)
happyOut125 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut125 #-}
happyIn126 :: (Expression) -> (HappyAbsSyn )
happyIn126 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn126 #-}
happyOut126 :: (HappyAbsSyn ) -> (Expression)
happyOut126 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut126 #-}
happyIn127 :: (Expression) -> (HappyAbsSyn )
happyIn127 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn127 #-}
happyOut127 :: (HappyAbsSyn ) -> (Expression)
happyOut127 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut127 #-}
happyIn128 :: (Expression) -> (HappyAbsSyn )
happyIn128 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn128 #-}
happyOut128 :: (HappyAbsSyn ) -> (Expression)
happyOut128 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut128 #-}
happyIn129 :: (Expression) -> (HappyAbsSyn )
happyIn129 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn129 #-}
happyOut129 :: (HappyAbsSyn ) -> (Expression)
happyOut129 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut129 #-}
happyIn130 :: (Expression) -> (HappyAbsSyn )
happyIn130 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn130 #-}
happyOut130 :: (HappyAbsSyn ) -> (Expression)
happyOut130 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut130 #-}
happyIn131 :: (Expression) -> (HappyAbsSyn )
happyIn131 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn131 #-}
happyOut131 :: (HappyAbsSyn ) -> (Expression)
happyOut131 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut131 #-}
happyIn132 :: (Expression) -> (HappyAbsSyn )
happyIn132 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn132 #-}
happyOut132 :: (HappyAbsSyn ) -> (Expression)
happyOut132 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut132 #-}
happyIn133 :: (Expression) -> (HappyAbsSyn )
happyIn133 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn133 #-}
happyOut133 :: (HappyAbsSyn ) -> (Expression)
happyOut133 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut133 #-}
happyIn134 :: (Expression) -> (HappyAbsSyn )
happyIn134 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn134 #-}
happyOut134 :: (HappyAbsSyn ) -> (Expression)
happyOut134 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut134 #-}
happyIn135 :: ([Expression]) -> (HappyAbsSyn )
happyIn135 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn135 #-}
happyOut135 :: (HappyAbsSyn ) -> ([Expression])
happyOut135 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut135 #-}
happyIn136 :: ([Expression]) -> (HappyAbsSyn )
happyIn136 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn136 #-}
happyOut136 :: (HappyAbsSyn ) -> ([Expression])
happyOut136 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut136 #-}
happyIn137 :: ([(UnqualifiedIdentifier, Expression)]) -> (HappyAbsSyn )
happyIn137 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn137 #-}
happyOut137 :: (HappyAbsSyn ) -> ([(UnqualifiedIdentifier, Expression)])
happyOut137 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut137 #-}
happyIn138 :: (MaybeSwitchExpression) -> (HappyAbsSyn )
happyIn138 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn138 #-}
happyOut138 :: (HappyAbsSyn ) -> (MaybeSwitchExpression)
happyOut138 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut138 #-}
happyIn139 :: ([CasePair]) -> (HappyAbsSyn )
happyIn139 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn139 #-}
happyOut139 :: (HappyAbsSyn ) -> ([CasePair])
happyOut139 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut139 #-}
happyIn140 :: (CasePair) -> (HappyAbsSyn )
happyIn140 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn140 #-}
happyOut140 :: (HappyAbsSyn ) -> (CasePair)
happyOut140 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut140 #-}
happyIn141 :: (Else) -> (HappyAbsSyn )
happyIn141 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn141 #-}
happyOut141 :: (HappyAbsSyn ) -> (Else)
happyOut141 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut141 #-}
happyIn142 :: (MaybeUnique) -> (HappyAbsSyn )
happyIn142 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn142 #-}
happyOut142 :: (HappyAbsSyn ) -> (MaybeUnique)
happyOut142 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut142 #-}
happyIn143 :: (MaybeIfNotExists) -> (HappyAbsSyn )
happyIn143 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn143 #-}
happyOut143 :: (HappyAbsSyn ) -> (MaybeIfNotExists)
happyOut143 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut143 #-}
happyIn144 :: (MaybeIfExists) -> (HappyAbsSyn )
happyIn144 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn144 #-}
happyOut144 :: (HappyAbsSyn ) -> (MaybeIfExists)
happyOut144 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut144 #-}
happyIn145 :: (MaybeForEachRow) -> (HappyAbsSyn )
happyIn145 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn145 #-}
happyOut145 :: (HappyAbsSyn ) -> (MaybeForEachRow)
happyOut145 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut145 #-}
happyIn146 :: (MaybeTemporary) -> (HappyAbsSyn )
happyIn146 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn146 #-}
happyOut146 :: (HappyAbsSyn ) -> (MaybeTemporary)
happyOut146 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut146 #-}
happyIn147 :: (MaybeCollation) -> (HappyAbsSyn )
happyIn147 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn147 #-}
happyOut147 :: (HappyAbsSyn ) -> (MaybeCollation)
happyOut147 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut147 #-}
happyIn148 :: (MaybeAscDesc) -> (HappyAbsSyn )
happyIn148 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn148 #-}
happyOut148 :: (HappyAbsSyn ) -> (MaybeAscDesc)
happyOut148 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut148 #-}
happyIn149 :: (MaybeAutoincrement) -> (HappyAbsSyn )
happyIn149 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn149 #-}
happyOut149 :: (HappyAbsSyn ) -> (MaybeAutoincrement)
happyOut149 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut149 #-}
happyIn150 :: (MaybeSign) -> (HappyAbsSyn )
happyIn150 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn150 #-}
happyOut150 :: (HappyAbsSyn ) -> (MaybeSign)
happyOut150 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut150 #-}
happyIn151 :: (MaybeColumn) -> (HappyAbsSyn )
happyIn151 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn151 #-}
happyOut151 :: (HappyAbsSyn ) -> (MaybeColumn)
happyOut151 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut151 #-}
happyIn152 :: (AlterTableBody) -> (HappyAbsSyn )
happyIn152 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn152 #-}
happyOut152 :: (HappyAbsSyn ) -> (AlterTableBody)
happyOut152 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut152 #-}
happyIn153 :: (ColumnDefinition) -> (HappyAbsSyn )
happyIn153 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn153 #-}
happyOut153 :: (HappyAbsSyn ) -> (ColumnDefinition)
happyOut153 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut153 #-}
happyIn154 :: ([ColumnDefinition]) -> (HappyAbsSyn )
happyIn154 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn154 #-}
happyOut154 :: (HappyAbsSyn ) -> ([ColumnDefinition])
happyOut154 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut154 #-}
happyIn155 :: (DefaultValue) -> (HappyAbsSyn )
happyIn155 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn155 #-}
happyOut155 :: (HappyAbsSyn ) -> (DefaultValue)
happyOut155 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut155 #-}
happyIn156 :: (IndexedColumn) -> (HappyAbsSyn )
happyIn156 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn156 #-}
happyOut156 :: (HappyAbsSyn ) -> (IndexedColumn)
happyOut156 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut156 #-}
happyIn157 :: ([IndexedColumn]) -> (HappyAbsSyn )
happyIn157 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn157 #-}
happyOut157 :: (HappyAbsSyn ) -> ([IndexedColumn])
happyOut157 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut157 #-}
happyIn158 :: (MaybeConstraintName) -> (HappyAbsSyn )
happyIn158 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn158 #-}
happyOut158 :: (HappyAbsSyn ) -> (MaybeConstraintName)
happyOut158 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut158 #-}
happyIn159 :: (ColumnConstraint) -> (HappyAbsSyn )
happyIn159 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn159 #-}
happyOut159 :: (HappyAbsSyn ) -> (ColumnConstraint)
happyOut159 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut159 #-}
happyIn160 :: ([ColumnConstraint]) -> (HappyAbsSyn )
happyIn160 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn160 #-}
happyOut160 :: (HappyAbsSyn ) -> ([ColumnConstraint])
happyOut160 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut160 #-}
happyIn161 :: (TableConstraint) -> (HappyAbsSyn )
happyIn161 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn161 #-}
happyOut161 :: (HappyAbsSyn ) -> (TableConstraint)
happyOut161 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut161 #-}
happyIn162 :: ([TableConstraint]) -> (HappyAbsSyn )
happyIn162 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn162 #-}
happyOut162 :: (HappyAbsSyn ) -> ([TableConstraint])
happyOut162 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut162 #-}
happyIn163 :: (CreateTableBody) -> (HappyAbsSyn )
happyIn163 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn163 #-}
happyOut163 :: (HappyAbsSyn ) -> (CreateTableBody)
happyOut163 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut163 #-}
happyIn164 :: (TriggerTime) -> (HappyAbsSyn )
happyIn164 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn164 #-}
happyOut164 :: (HappyAbsSyn ) -> (TriggerTime)
happyOut164 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut164 #-}
happyIn165 :: (TriggerCondition) -> (HappyAbsSyn )
happyIn165 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn165 #-}
happyOut165 :: (HappyAbsSyn ) -> (TriggerCondition)
happyOut165 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut165 #-}
happyIn166 :: (ModuleArgument) -> (HappyAbsSyn )
happyIn166 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn166 #-}
happyOut166 :: (HappyAbsSyn ) -> (ModuleArgument)
happyOut166 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut166 #-}
happyIn167 :: (()) -> (HappyAbsSyn )
happyIn167 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn167 #-}
happyOut167 :: (HappyAbsSyn ) -> (())
happyOut167 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut167 #-}
happyIn168 :: ([ModuleArgument]) -> (HappyAbsSyn )
happyIn168 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn168 #-}
happyOut168 :: (HappyAbsSyn ) -> ([ModuleArgument])
happyOut168 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut168 #-}
happyIn169 :: (TriggerStatement) -> (HappyAbsSyn )
happyIn169 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn169 #-}
happyOut169 :: (HappyAbsSyn ) -> (TriggerStatement)
happyOut169 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut169 #-}
happyIn170 :: ([TriggerStatement]) -> (HappyAbsSyn )
happyIn170 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn170 #-}
happyOut170 :: (HappyAbsSyn ) -> ([TriggerStatement])
happyOut170 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut170 #-}
happyIn171 :: (QualifiedTableName) -> (HappyAbsSyn )
happyIn171 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn171 #-}
happyOut171 :: (HappyAbsSyn ) -> (QualifiedTableName)
happyOut171 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut171 #-}
happyIn172 :: (OrderingTerm) -> (HappyAbsSyn )
happyIn172 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn172 #-}
happyOut172 :: (HappyAbsSyn ) -> (OrderingTerm)
happyOut172 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut172 #-}
happyIn173 :: ([OrderingTerm]) -> (HappyAbsSyn )
happyIn173 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn173 #-}
happyOut173 :: (HappyAbsSyn ) -> ([OrderingTerm])
happyOut173 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut173 #-}
happyIn174 :: (PragmaBody) -> (HappyAbsSyn )
happyIn174 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn174 #-}
happyOut174 :: (HappyAbsSyn ) -> (PragmaBody)
happyOut174 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut174 #-}
happyIn175 :: (PragmaValue) -> (HappyAbsSyn )
happyIn175 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn175 #-}
happyOut175 :: (HappyAbsSyn ) -> (PragmaValue)
happyOut175 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut175 #-}
happyIn176 :: (InsertHead) -> (HappyAbsSyn )
happyIn176 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn176 #-}
happyOut176 :: (HappyAbsSyn ) -> (InsertHead)
happyOut176 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut176 #-}
happyIn177 :: (InsertBody) -> (HappyAbsSyn )
happyIn177 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn177 #-}
happyOut177 :: (HappyAbsSyn ) -> (InsertBody)
happyOut177 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut177 #-}
happyIn178 :: (UpdateHead) -> (HappyAbsSyn )
happyIn178 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn178 #-}
happyOut178 :: (HappyAbsSyn ) -> (UpdateHead)
happyOut178 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut178 #-}
happyIn179 :: (Distinctness) -> (HappyAbsSyn )
happyIn179 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn179 #-}
happyOut179 :: (HappyAbsSyn ) -> (Distinctness)
happyOut179 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut179 #-}
happyIn180 :: (MaybeHaving) -> (HappyAbsSyn )
happyIn180 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn180 #-}
happyOut180 :: (HappyAbsSyn ) -> (MaybeHaving)
happyOut180 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut180 #-}
happyIn181 :: (MaybeAs) -> (HappyAbsSyn )
happyIn181 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn181 #-}
happyOut181 :: (HappyAbsSyn ) -> (MaybeAs)
happyOut181 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut181 #-}
happyIn182 :: (CompoundOperator) -> (HappyAbsSyn )
happyIn182 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn182 #-}
happyOut182 :: (HappyAbsSyn ) -> (CompoundOperator)
happyOut182 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut182 #-}
happyIn183 :: (SelectCore) -> (HappyAbsSyn )
happyIn183 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn183 #-}
happyOut183 :: (HappyAbsSyn ) -> (SelectCore)
happyOut183 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut183 #-}
happyIn184 :: ([(CompoundOperator, SelectCore)]) -> (HappyAbsSyn )
happyIn184 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn184 #-}
happyOut184 :: (HappyAbsSyn ) -> ([(CompoundOperator, SelectCore)])
happyOut184 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut184 #-}
happyIn185 :: (ResultColumn) -> (HappyAbsSyn )
happyIn185 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn185 #-}
happyOut185 :: (HappyAbsSyn ) -> (ResultColumn)
happyOut185 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut185 #-}
happyIn186 :: ([ResultColumn]) -> (HappyAbsSyn )
happyIn186 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn186 #-}
happyOut186 :: (HappyAbsSyn ) -> ([ResultColumn])
happyOut186 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut186 #-}
happyIn187 :: (JoinSource) -> (HappyAbsSyn )
happyIn187 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn187 #-}
happyOut187 :: (HappyAbsSyn ) -> (JoinSource)
happyOut187 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut187 #-}
happyIn188 :: ([(JoinOperation, SingleSource, JoinConstraint)]) -> (HappyAbsSyn )
happyIn188 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn188 #-}
happyOut188 :: (HappyAbsSyn ) -> ([(JoinOperation, SingleSource, JoinConstraint)])
happyOut188 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut188 #-}
happyIn189 :: (SingleSource) -> (HappyAbsSyn )
happyIn189 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn189 #-}
happyOut189 :: (HappyAbsSyn ) -> (SingleSource)
happyOut189 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut189 #-}
happyIn190 :: (JoinOperation) -> (HappyAbsSyn )
happyIn190 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn190 #-}
happyOut190 :: (HappyAbsSyn ) -> (JoinOperation)
happyOut190 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut190 #-}
happyIn191 :: (JoinConstraint) -> (HappyAbsSyn )
happyIn191 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn191 #-}
happyOut191 :: (HappyAbsSyn ) -> (JoinConstraint)
happyOut191 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut191 #-}
happyIn192 :: (MaybeIndexedBy) -> (HappyAbsSyn )
happyIn192 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn192 #-}
happyOut192 :: (HappyAbsSyn ) -> (MaybeIndexedBy)
happyOut192 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut192 #-}
happyIn193 :: (FromClause) -> (HappyAbsSyn )
happyIn193 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn193 #-}
happyOut193 :: (HappyAbsSyn ) -> (FromClause)
happyOut193 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut193 #-}
happyIn194 :: (Maybe FromClause) -> (HappyAbsSyn )
happyIn194 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn194 #-}
happyOut194 :: (HappyAbsSyn ) -> (Maybe FromClause)
happyOut194 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut194 #-}
happyIn195 :: (WhereClause) -> (HappyAbsSyn )
happyIn195 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn195 #-}
happyOut195 :: (HappyAbsSyn ) -> (WhereClause)
happyOut195 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut195 #-}
happyIn196 :: (Maybe WhereClause) -> (HappyAbsSyn )
happyIn196 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn196 #-}
happyOut196 :: (HappyAbsSyn ) -> (Maybe WhereClause)
happyOut196 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut196 #-}
happyIn197 :: (GroupClause) -> (HappyAbsSyn )
happyIn197 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn197 #-}
happyOut197 :: (HappyAbsSyn ) -> (GroupClause)
happyOut197 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut197 #-}
happyIn198 :: (Maybe GroupClause) -> (HappyAbsSyn )
happyIn198 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn198 #-}
happyOut198 :: (HappyAbsSyn ) -> (Maybe GroupClause)
happyOut198 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut198 #-}
happyIn199 :: (OrderClause) -> (HappyAbsSyn )
happyIn199 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn199 #-}
happyOut199 :: (HappyAbsSyn ) -> (OrderClause)
happyOut199 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut199 #-}
happyIn200 :: (Maybe OrderClause) -> (HappyAbsSyn )
happyIn200 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn200 #-}
happyOut200 :: (HappyAbsSyn ) -> (Maybe OrderClause)
happyOut200 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut200 #-}
happyIn201 :: (LimitClause) -> (HappyAbsSyn )
happyIn201 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn201 #-}
happyOut201 :: (HappyAbsSyn ) -> (LimitClause)
happyOut201 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut201 #-}
happyIn202 :: (Maybe LimitClause) -> (HappyAbsSyn )
happyIn202 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn202 #-}
happyOut202 :: (HappyAbsSyn ) -> (Maybe LimitClause)
happyOut202 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut202 #-}
happyIn203 :: (WhenClause) -> (HappyAbsSyn )
happyIn203 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn203 #-}
happyOut203 :: (HappyAbsSyn ) -> (WhenClause)
happyOut203 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut203 #-}
happyIn204 :: (Maybe WhenClause) -> (HappyAbsSyn )
happyIn204 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn204 #-}
happyOut204 :: (HappyAbsSyn ) -> (Maybe WhenClause)
happyOut204 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut204 #-}
happyIn205 :: (ConflictClause) -> (HappyAbsSyn )
happyIn205 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn205 #-}
happyOut205 :: (HappyAbsSyn ) -> (ConflictClause)
happyOut205 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut205 #-}
happyIn206 :: (Maybe ConflictClause) -> (HappyAbsSyn )
happyIn206 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn206 #-}
happyOut206 :: (HappyAbsSyn ) -> (Maybe ConflictClause)
happyOut206 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut206 #-}
happyIn207 :: (ForeignKeyClause) -> (HappyAbsSyn )
happyIn207 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn207 #-}
happyOut207 :: (HappyAbsSyn ) -> (ForeignKeyClause)
happyOut207 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut207 #-}
happyIn208 :: (ForeignKeyClauseActionOrMatchPart) -> (HappyAbsSyn )
happyIn208 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn208 #-}
happyOut208 :: (HappyAbsSyn ) -> (ForeignKeyClauseActionOrMatchPart)
happyOut208 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut208 #-}
happyIn209 :: ([ForeignKeyClauseActionOrMatchPart]) -> (HappyAbsSyn )
happyIn209 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn209 #-}
happyOut209 :: (HappyAbsSyn ) -> ([ForeignKeyClauseActionOrMatchPart])
happyOut209 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut209 #-}
happyIn210 :: (ForeignKeyClauseActionPart) -> (HappyAbsSyn )
happyIn210 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn210 #-}
happyOut210 :: (HappyAbsSyn ) -> (ForeignKeyClauseActionPart)
happyOut210 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut210 #-}
happyIn211 :: (MaybeForeignKeyClauseDeferrablePart) -> (HappyAbsSyn )
happyIn211 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn211 #-}
happyOut211 :: (HappyAbsSyn ) -> (MaybeForeignKeyClauseDeferrablePart)
happyOut211 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut211 #-}
happyIn212 :: (MaybeInitialDeferralStatus) -> (HappyAbsSyn )
happyIn212 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn212 #-}
happyOut212 :: (HappyAbsSyn ) -> (MaybeInitialDeferralStatus)
happyOut212 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut212 #-}
happyIn213 :: (CommitHead) -> (HappyAbsSyn )
happyIn213 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn213 #-}
happyOut213 :: (HappyAbsSyn ) -> (CommitHead)
happyOut213 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut213 #-}
happyIn214 :: (MaybeTransaction) -> (HappyAbsSyn )
happyIn214 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn214 #-}
happyOut214 :: (HappyAbsSyn ) -> (MaybeTransaction)
happyOut214 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut214 #-}
happyIn215 :: (MaybeTransactionType) -> (HappyAbsSyn )
happyIn215 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn215 #-}
happyOut215 :: (HappyAbsSyn ) -> (MaybeTransactionType)
happyOut215 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut215 #-}
happyIn216 :: (MaybeDatabase) -> (HappyAbsSyn )
happyIn216 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn216 #-}
happyOut216 :: (HappyAbsSyn ) -> (MaybeDatabase)
happyOut216 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut216 #-}
happyIn217 :: (MaybeSavepoint) -> (HappyAbsSyn )
happyIn217 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn217 #-}
happyOut217 :: (HappyAbsSyn ) -> (MaybeSavepoint)
happyOut217 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut217 #-}
happyIn218 :: (MaybeReleaseSavepoint) -> (HappyAbsSyn )
happyIn218 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn218 #-}
happyOut218 :: (HappyAbsSyn ) -> (MaybeReleaseSavepoint)
happyOut218 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut218 #-}
happyIn219 :: (StatementList) -> (HappyAbsSyn )
happyIn219 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn219 #-}
happyOut219 :: (HappyAbsSyn ) -> (StatementList)
happyOut219 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut219 #-}
happyIn220 :: ([AnyStatement]) -> (HappyAbsSyn )
happyIn220 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn220 #-}
happyOut220 :: (HappyAbsSyn ) -> ([AnyStatement])
happyOut220 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut220 #-}
happyIn221 :: (AnyStatement) -> (HappyAbsSyn )
happyIn221 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn221 #-}
happyOut221 :: (HappyAbsSyn ) -> (AnyStatement)
happyOut221 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut221 #-}
happyIn222 :: (ExplainableStatement) -> (HappyAbsSyn )
happyIn222 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn222 #-}
happyOut222 :: (HappyAbsSyn ) -> (ExplainableStatement)
happyOut222 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut222 #-}
happyIn223 :: (Explain) -> (HappyAbsSyn )
happyIn223 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn223 #-}
happyOut223 :: (HappyAbsSyn ) -> (Explain)
happyOut223 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut223 #-}
happyIn224 :: (ExplainQueryPlan) -> (HappyAbsSyn )
happyIn224 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn224 #-}
happyOut224 :: (HappyAbsSyn ) -> (ExplainQueryPlan)
happyOut224 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut224 #-}
happyIn225 :: (AlterTable) -> (HappyAbsSyn )
happyIn225 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn225 #-}
happyOut225 :: (HappyAbsSyn ) -> (AlterTable)
happyOut225 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut225 #-}
happyIn226 :: (Analyze) -> (HappyAbsSyn )
happyIn226 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn226 #-}
happyOut226 :: (HappyAbsSyn ) -> (Analyze)
happyOut226 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut226 #-}
happyIn227 :: (Attach) -> (HappyAbsSyn )
happyIn227 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn227 #-}
happyOut227 :: (HappyAbsSyn ) -> (Attach)
happyOut227 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut227 #-}
happyIn228 :: (Begin) -> (HappyAbsSyn )
happyIn228 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn228 #-}
happyOut228 :: (HappyAbsSyn ) -> (Begin)
happyOut228 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut228 #-}
happyIn229 :: (Commit) -> (HappyAbsSyn )
happyIn229 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn229 #-}
happyOut229 :: (HappyAbsSyn ) -> (Commit)
happyOut229 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut229 #-}
happyIn230 :: (CreateIndex) -> (HappyAbsSyn )
happyIn230 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn230 #-}
happyOut230 :: (HappyAbsSyn ) -> (CreateIndex)
happyOut230 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut230 #-}
happyIn231 :: (CreateTable) -> (HappyAbsSyn )
happyIn231 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn231 #-}
happyOut231 :: (HappyAbsSyn ) -> (CreateTable)
happyOut231 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut231 #-}
happyIn232 :: (CreateTrigger) -> (HappyAbsSyn )
happyIn232 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn232 #-}
happyOut232 :: (HappyAbsSyn ) -> (CreateTrigger)
happyOut232 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut232 #-}
happyIn233 :: (CreateView) -> (HappyAbsSyn )
happyIn233 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn233 #-}
happyOut233 :: (HappyAbsSyn ) -> (CreateView)
happyOut233 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut233 #-}
happyIn234 :: (CreateVirtualTable) -> (HappyAbsSyn )
happyIn234 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn234 #-}
happyOut234 :: (HappyAbsSyn ) -> (CreateVirtualTable)
happyOut234 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut234 #-}
happyIn235 :: (Delete) -> (HappyAbsSyn )
happyIn235 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn235 #-}
happyOut235 :: (HappyAbsSyn ) -> (Delete)
happyOut235 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut235 #-}
happyIn236 :: (DeleteLimited) -> (HappyAbsSyn )
happyIn236 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn236 #-}
happyOut236 :: (HappyAbsSyn ) -> (DeleteLimited)
happyOut236 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut236 #-}
happyIn237 :: (AnyStatement) -> (HappyAbsSyn )
happyIn237 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn237 #-}
happyOut237 :: (HappyAbsSyn ) -> (AnyStatement)
happyOut237 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut237 #-}
happyIn238 :: (Detach) -> (HappyAbsSyn )
happyIn238 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn238 #-}
happyOut238 :: (HappyAbsSyn ) -> (Detach)
happyOut238 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut238 #-}
happyIn239 :: (DropIndex) -> (HappyAbsSyn )
happyIn239 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn239 #-}
happyOut239 :: (HappyAbsSyn ) -> (DropIndex)
happyOut239 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut239 #-}
happyIn240 :: (DropTable) -> (HappyAbsSyn )
happyIn240 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn240 #-}
happyOut240 :: (HappyAbsSyn ) -> (DropTable)
happyOut240 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut240 #-}
happyIn241 :: (DropTrigger) -> (HappyAbsSyn )
happyIn241 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn241 #-}
happyOut241 :: (HappyAbsSyn ) -> (DropTrigger)
happyOut241 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut241 #-}
happyIn242 :: (DropView) -> (HappyAbsSyn )
happyIn242 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn242 #-}
happyOut242 :: (HappyAbsSyn ) -> (DropView)
happyOut242 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut242 #-}
happyIn243 :: (Insert) -> (HappyAbsSyn )
happyIn243 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn243 #-}
happyOut243 :: (HappyAbsSyn ) -> (Insert)
happyOut243 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut243 #-}
happyIn244 :: (Pragma) -> (HappyAbsSyn )
happyIn244 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn244 #-}
happyOut244 :: (HappyAbsSyn ) -> (Pragma)
happyOut244 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut244 #-}
happyIn245 :: (Reindex) -> (HappyAbsSyn )
happyIn245 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn245 #-}
happyOut245 :: (HappyAbsSyn ) -> (Reindex)
happyOut245 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut245 #-}
happyIn246 :: (Release) -> (HappyAbsSyn )
happyIn246 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn246 #-}
happyOut246 :: (HappyAbsSyn ) -> (Release)
happyOut246 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut246 #-}
happyIn247 :: (Rollback) -> (HappyAbsSyn )
happyIn247 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn247 #-}
happyOut247 :: (HappyAbsSyn ) -> (Rollback)
happyOut247 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut247 #-}
happyIn248 :: (Savepoint) -> (HappyAbsSyn )
happyIn248 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn248 #-}
happyOut248 :: (HappyAbsSyn ) -> (Savepoint)
happyOut248 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut248 #-}
happyIn249 :: (Select) -> (HappyAbsSyn )
happyIn249 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn249 #-}
happyOut249 :: (HappyAbsSyn ) -> (Select)
happyOut249 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut249 #-}
happyIn250 :: (Update) -> (HappyAbsSyn )
happyIn250 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn250 #-}
happyOut250 :: (HappyAbsSyn ) -> (Update)
happyOut250 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut250 #-}
happyIn251 :: (UpdateLimited) -> (HappyAbsSyn )
happyIn251 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn251 #-}
happyOut251 :: (HappyAbsSyn ) -> (UpdateLimited)
happyOut251 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut251 #-}
happyIn252 :: (AnyStatement) -> (HappyAbsSyn )
happyIn252 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn252 #-}
happyOut252 :: (HappyAbsSyn ) -> (AnyStatement)
happyOut252 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut252 #-}
happyIn253 :: (Vacuum) -> (HappyAbsSyn )
happyIn253 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn253 #-}
happyOut253 :: (HappyAbsSyn ) -> (Vacuum)
happyOut253 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut253 #-}
happyIn254 :: (UnqualifiedIdentifier) -> (HappyAbsSyn )
happyIn254 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn254 #-}
happyOut254 :: (HappyAbsSyn ) -> (UnqualifiedIdentifier)
happyOut254 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut254 #-}
happyIn255 :: ([UnqualifiedIdentifier]) -> (HappyAbsSyn )
happyIn255 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn255 #-}
happyOut255 :: (HappyAbsSyn ) -> ([UnqualifiedIdentifier])
happyOut255 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut255 #-}
happyIn256 :: (SinglyQualifiedIdentifier) -> (HappyAbsSyn )
happyIn256 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn256 #-}
happyOut256 :: (HappyAbsSyn ) -> (SinglyQualifiedIdentifier)
happyOut256 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut256 #-}
happyIn257 :: (DoublyQualifiedIdentifier) -> (HappyAbsSyn )
happyIn257 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyIn257 #-}
happyOut257 :: (HappyAbsSyn ) -> (DoublyQualifiedIdentifier)
happyOut257 x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOut257 #-}
happyInTok :: (Token) -> (HappyAbsSyn )
happyInTok x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyInTok #-}
happyOutTok :: (HappyAbsSyn ) -> (Token)
happyOutTok x = Happy_GHC_Exts.unsafeCoerce# x
{-# INLINE happyOutTok #-}


happyActOffsets :: HappyAddr
happyActOffsets = HappyA# "\xf1\x0a\xf1\x0a\xd4\x0a\x18\x08\xe9\x06\xa3\x0a\x92\x08\x55\x0a\xa2\x0a\x92\x08\x5b\x0a\xa1\x0a\xa0\x0a\x9e\x0a\xa2\x07\xb5\x0a\x83\x02\xbd\x0a\x16\x08\xb2\x0a\xe3\xff\xe7\x0a\xe0\x06\xe7\x0a\xad\x0a\xad\x0a\xad\x0a\x8c\x03\x65\x01\x00\x00\x23\x03\xe4\x0a\x92\x08\x85\x00\xc3\x03\xf6\x01\x27\x03\x43\x01\x51\x0a\x3f\x03\x8e\x0a\xcf\x01\x66\x01\x5a\x0a\x50\x08\xd7\x01\xd7\x01\x47\x03\x14\x00\x5f\x03\x8d\x0a\x46\x0a\x8c\x0a\x69\x0a\x73\x0a\x44\x0a\x68\x0a\x5c\x0a\xf4\x02\x36\x02\x86\x01\x78\x0a\x78\x02\x49\x0a\x65\x03\x9a\x0a\x48\x0a\xfc\x00\x10\x09\x10\x09\x22\x09\x8b\x0a\x85\x0a\x9d\x0a\xaa\x0a\xa4\x0a\x9f\x0a\x78\x02\x99\x0a\x98\x0a\x96\x0a\x94\x0a\x8f\x0a\x89\x0a\x88\x0a\x87\x0a\x83\x0a\x80\x0a\x7f\x0a\x7e\x0a\x7d\x0a\x93\x02\x4a\x0a\x43\x0a\x41\x0a\x3b\x0a\x38\x0a\x36\x0a\x2a\x0a\x2a\x0a\x2a\x0a\x27\x0a\xba\x0a\xba\x0a\xba\x0a\xba\x0a\x9c\x0a\x00\x00\x8a\x0a\x86\x0a\x02\x0a\x02\x0a\x02\x0a\x02\x0a\x00\x00\x9b\x0a\x00\x00\x00\x00\xff\x09\x24\x0a\x97\x0a\xfc\x09\x95\x0a\xfa\x09\x00\x00\xfa\x09\xcd\x01\xfa\x09\x93\x0a\xf8\x09\x01\x0a\xe6\x09\xfc\x00\xe6\x09\x7c\x0a\xd8\x09\x70\x0a\x0c\x0a\xd3\x09\xf6\x09\x00\x00\xd1\x09\xd0\x09\xbd\x09\xda\x09\xb9\x09\xc0\x09\xad\x09\xe8\x09\xac\x09\x03\x0a\x00\x00\x00\x00\xa7\x09\xca\x09\x96\x09\xc8\x09\x85\x09\xb6\x09\x84\x09\x61\x09\x5d\x09\x95\x07\x5d\x09\x95\x07\x5d\x09\x95\x07\x5d\x09\x3c\x09\x68\x09\x5a\x09\x00\x00\x00\x00\x5a\x09\x65\x03\x5a\x09\x90\x09\x48\x09\xc9\x09\x31\x09\x3e\x09\x2e\x09\x4c\x09\x2b\x09\x22\x09\x2b\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x25\x04\x25\x03\x2b\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa7\x07\xae\x08\x2b\x09\xa4\x09\x00\x00\x29\x09\x00\x00\xbe\x09\x28\x09\xb4\x00\x28\x09\x00\x00\x28\x09\x00\x00\x00\x00\x00\x00\x28\x09\x00\x00\x28\x09\x28\x09\x46\x00\x28\x09\x5e\x09\x78\x09\x27\x09\x00\x00\x8e\x09\x00\x00\x67\x02\x26\x09\xb5\x09\x1d\x01\x25\x09\xaa\x09\x23\x09\x67\x09\x21\x09\x92\x08\x21\x09\x9b\x09\x20\x09\x83\x09\x1e\x09\x7e\x09\x1d\x09\x92\x08\x1d\x09\xd7\x01\x1d\x09\x6e\x09\x40\x09\x18\x09\x92\x08\x79\x09\x17\x09\x00\x00\x35\x09\x33\x09\x00\x00\x3d\x04\x87\x07\x2d\x09\x15\x09\xcf\x01\xdb\x00\x15\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x4d\x02\x00\x00\x35\x00\x00\x00\x2c\x09\x52\x02\x86\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xcf\x01\x13\x09\x40\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x92\x08\x92\x08\x92\x08\xf2\x06\x92\x08\x71\x09\x00\x00\x00\x00\x00\x00\x70\x09\x92\x08\x00\x00\x6d\x09\x11\x09\x11\x09\x00\x00\x00\x00\x5f\x09\xfe\x08\x00\x00\x81\x09\xf8\x08\x92\x08\xf8\x08\x00\x00\x00\x00\xf8\x08\xf8\x08\x00\x00\x80\x09\xf6\x08\x63\x09\xf0\x08\xf0\x08\x7a\x09\xef\x08\x1c\x08\xed\x08\x00\x00\x00\x00\x00\x00\x00\x00\xed\x08\xc3\x03\xc3\x03\x3d\x09\xec\x08\x3e\x04\xec\x08\x5a\x03\xec\x08\x00\x00\x00\x00\x00\x00\x00\x00\xec\x08\x6c\x09\xeb\x08\x0b\x09\x09\x09\x45\x05\xe9\x08\x00\x00\x00\x00\x02\x09\xe3\x08\x6f\x09\x32\x01\xe1\x08\x68\x07\xe1\x08\xe1\x08\x39\x09\x15\x08\xdf\x08\x00\x00\x00\x00\x92\x08\x00\x00\x00\x00\x00\x00\x00\x00\xdf\x08\x6a\x09\xde\x08\x32\x09\xe0\x08\xdd\x08\x00\x00\xdd\x08\xdd\x08\x00\x00\xdd\x08\x00\x00\x00\x00\xdd\x08\x66\x09\xdb\x08\x00\x00\x00\x00\xdb\x08\x1b\x09\xd7\x08\x12\x09\xd1\x08\xf4\x08\xca\x08\x00\x00\xca\x08\xca\x08\x92\x08\xca\x08\x92\x08\x00\x00\xca\x08\xca\x08\x92\x08\xca\x08\x00\x00\x00\x00\x00\x00\x4d\x03\x00\x00\xca\x08\x0a\x08\xca\x08\xf9\x07\x00\x00\xca\x08\xca\x08\xe6\x07\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xd5\x08\x00\x00\x0f\x09\x00\x00\xd9\x08\x00\x00\x5b\x09\x5b\x09\x00\x00\x3b\x09\x00\x00\x00\x00\x83\x02\x00\x00\x3a\x09\x54\x09\xe0\x06\xe2\x08\xea\x08\xdc\x08\x2f\x09\xe7\x08\xe5\x08\x2a\x09\x00\x00\x00\x00\x45\x09\x00\x00\x00\x00\x00\x00\x00\x00\x14\x09\xe6\x08\xab\x01\x3f\x09\x83\x02\x24\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xe3\x07\x92\x08\x00\x00\x00\x00\xd9\x07\x00\x00\x00\x00\x00\x00\x6b\x01\x00\x00\xb3\x08\x92\x08\xa5\x08\x0e\x09\x0a\x09\x00\x00\x00\x00\x00\x00\x5e\x01\x00\x00\x92\x08\x92\x08\x92\x08\x92\x08\x92\x08\x92\x08\x08\x09\xcf\x08\x92\x08\x92\x08\x92\x08\x92\x08\x92\x08\x92\x08\x92\x08\x92\x08\x92\x08\x92\x08\x92\x08\x92\x08\x92\x08\x92\x08\x92\x08\x00\x00\xc8\x08\x00\x00\x92\x08\x92\x08\xf2\x08\xd4\x01\xce\x08\x1f\x09\x47\x03\x01\x09\xff\x08\x54\x03\x00\x00\xd6\x08\xd3\x08\x00\x00\x3c\x04\xcd\x08\x00\x00\xcb\x08\x00\x00\x00\x00\x19\x09\x00\x00\x00\x00\x19\x09\x00\x00\x00\x00\x92\x08\x92\x08\x81\x00\x00\x00\x80\x06\xfb\x08\x36\x02\x36\x02\x00\x00\x00\x00\x00\x00\x00\x00\xc7\x08\x00\x00\x00\x00\x00\x00\x00\x00\x16\x09\x00\x00\x9c\x08\x00\x00\x9e\x08\xb7\x08\xd3\x02\x8f\x08\xb9\x08\xb9\x08\xb9\x08\xb9\x08\x31\x02\x0c\x09\x00\x00\x07\x09\x84\x08\x00\x00\x87\x08\x7c\x08\x72\x08\x05\x09\x05\x09\x05\x09\x05\x09\x2b\x05\x05\x09\x85\x00\x00\x00\x05\x09\x82\x08\x00\x00\x50\x08\xc8\x06\x81\x08\x7f\x08\x36\x01\x7e\x08\x04\x09\x00\x00\x00\x00\x03\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x03\x09\x03\x09\x7a\x08\x00\x00\x95\x08\x00\x00\xa2\x01\x00\x00\x00\x00\x00\x00\x43\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x65\x08\x65\x08\x65\x08\xa3\x08\xa3\x08\xa3\x08\x00\x00\xd4\x08\xe3\xff\xf9\x08\xf9\x08\xf9\x08\xf9\x08\xf9\x08\xa2\x08\x22\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x48\x00\xf7\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf3\x08\xf1\x08\x00\x00\xd2\x08\x6f\x01\x00\x00\xd7\x07\x00\x00\x00\x00\x00\x00\x90\x08\x00\x00\x00\x00\x00\x00\xcf\x01\x00\x00\xb9\x01\x00\x00\x8a\x00\x00\x00\x68\x08\x92\x08\xbe\x06\x00\x00\x00\x00\x55\x03\x00\x00\xe4\x08\xe4\x08\xe4\x08\xa0\x04\xa0\x04\xe5\x07\xe5\x07\xe5\x07\xe5\x07\xe3\x03\xe3\x03\xe3\x03\xe3\x03\xd0\x08\x00\x00\xdb\x03\xdb\x03\xdb\x03\xdb\x03\x4b\x02\xc2\x08\x00\x00\x00\x00\x00\x00\x00\x00\xc2\xff\x00\x00\xc5\x08\xcc\x08\xc9\x08\xc6\x08\xc1\x08\xc4\x08\x20\x04\xda\x08\x00\x00\xa3\x07\x00\x00\x89\x01\x00\x00\x00\x00\x0e\x08\xc0\x08\x92\x08\x00\x00\xd8\x08\xec\xff\xd8\x08\xbf\x08\xbb\x08\x92\x08\x00\x00\x00\x00\x83\x02\x5f\x08\x00\x00\x00\x00\x92\x08\x00\x00\x00\x00\x33\x07\x00\x00\x00\x00\x00\x00\x00\x00\x92\x08\x00\x00\xb1\x07\xb4\x08\x00\x00\x00\x00\xb0\x08\x00\x00\x56\x08\xaf\x08\xbd\x08\xbd\x08\x00\x00\x93\x07\x00\x00\x00\x00\x8c\x07\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x85\x07\x00\x00\x92\x08\x00\x00\x00\x00\xac\x08\xc3\x08\x00\x00\xbe\x08\xbc\x08\x00\x00\xba\x08\x00\x00\x6f\x08\xcc\x07\x00\x00\x00\x00\x05\x07\xba\x06\x9f\x08\x00\x00\x34\x08\x14\x00\x00\x00\x00\x00\x00\x00\x00\x00\x92\x08\x00\x00\x00\x00\x81\x07\x00\x00\x00\x00\x00\x00\xb8\x08\x24\x08\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb6\x08\xb6\x08\xb6\x08\xb6\x08\x00\x00\x00\x00\x40\x08\xec\x00\x00\x00\x00\x00\x1a\x08\x8a\x07\x00\x00\x00\x00\x00\x00\x7f\x00\x9d\x08\x7f\x00\x7f\x00\xec\x00\xb1\x08\x3a\x08\x92\x08\x00\x00\x00\x00\x5c\x08\x46\x08\x83\x08\x8c\x03\xf6\x01\x00\x00\xa8\x08\x32\x08\x00\x00\x00\x00\x00\x00\x8e\x08\x00\x00\x05\x07\x00\x00\x48\x07\x00\x00\x00\x00\x8d\x08\x8c\x08\x8a\x08\x89\x08\x92\x08\x00\x00\x00\x00\x6b\x08\x00\x00\x2f\x08\xa1\x08\x6b\x07\x64\x07\x00\x00\x70\x08\x00\x00\x00\x00\x00\x00\x27\x08\x2a\x08\x00\x00\x00\x00\x00\x00\x61\x07\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x48\x00\x9b\x08\x75\x08\x00\x00\x65\x01\x13\x08\x00\x00\x00\x00\x00\x00\x00\x00\x26\x08\x78\x08\x92\x08\x00\x00\x00\x00\x8b\x08\x00\x00\x6e\x08\x00\x00\x00\x00\x00\x00\x00\x00\x88\x08\x00\x00\x5f\x07\x36\x08\x00\x00\xed\x07\x00\x00\x00\x00\x41\x07\x00\x00\x00\x00\x00\x00\x58\x08\x23\x03\x00\x00\x64\x08\x6a\x07\x00\x00\x00\x00\x00\x00"#

happyGotoOffsets :: HappyAddr
happyGotoOffsets = HappyA# "\x06\x00\x03\x00\x80\x08\xa7\x02\x7d\x08\x7b\x08\xf8\x01\x5e\x08\x5b\x08\x87\x04\x59\x08\x57\x08\x55\x08\x53\x08\x51\x08\x4f\x08\x4d\x08\x4b\x08\x49\x08\x47\x08\x45\x08\x2b\x00\x35\x03\xc7\x00\x3d\x07\xe1\x03\x3e\x08\x37\x08\x35\x08\x23\x07\x9b\x07\x41\x02\xd5\x01\x29\x08\x6c\x00\x33\x08\x25\x08\x68\x02\x22\x08\x20\x08\x1e\x08\x40\x01\x1b\x08\x19\x08\x8d\x01\x7f\x02\x7e\x02\x11\x08\x0f\x08\x0d\x08\x0b\x08\x05\x08\x01\x08\xfe\x07\xf3\x07\xf0\x07\xe8\x07\xe7\x07\xea\x07\xe1\x07\xdf\x07\xdb\x07\xdc\x07\xda\x07\xd5\x07\xd0\x07\xcd\x07\xf3\x02\x62\x09\xb0\x09\x29\x0a\xc5\x07\xc2\x07\xc0\x07\xbe\x07\xb9\x07\xb7\x07\x39\x04\xa9\x07\x9e\x07\x92\x07\x86\x07\x7e\x07\x70\x07\x6d\x07\xe2\x03\x69\x07\x6e\x07\x5c\x07\x57\x07\x58\x07\x48\x01\x4e\x07\x43\x07\x40\x07\x3b\x07\x30\x07\x8c\x02\x45\x01\x42\x01\x1b\x00\x27\x07\x24\x07\x24\x05\x38\x03\x1d\x07\xa6\x07\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x23\x02\x00\x00\x00\x00\x00\x00\x00\x00\x2c\x01\x00\x00\x25\x01\x00\x00\x59\x07\x00\x00\x6c\x07\x00\x00\x09\x07\x00\x00\x2c\x07\x00\x00\x85\x02\x00\x00\x21\x05\x00\x00\x20\x05\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x28\x07\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x62\x07\x00\x00\x5e\x07\x00\x00\x53\x07\x00\x00\x55\x07\x08\x07\x00\x00\x00\x00\x00\x00\x00\x00\xf7\x06\x00\x00\xee\x06\x00\x00\x1d\x05\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x7e\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x3c\x03\x00\x0a\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xe3\x06\x00\x00\xda\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xea\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb4\x06\x00\x00\x00\x00\xae\x06\x00\x00\x00\x00\x00\x00\x62\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x3f\x04\x00\x00\x37\x02\x00\x00\x00\x00\x00\x00\x00\x00\x2a\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x1f\x01\x38\x02\x00\x00\xe5\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2a\x07\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x1c\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb3\x06\x3d\x05\xe4\x04\x6d\x00\x68\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x16\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x9a\x06\x00\x00\x15\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xc9\x06\x00\x00\x00\x00\x00\x00\x00\x00\x25\x00\x8b\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x6a\x00\x2d\x00\xf9\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x98\x06\x00\x00\x00\x00\xb6\x06\x00\x00\x00\x00\xeb\x06\x00\x00\x00\x00\x00\x00\x00\x00\xf7\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\xd0\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x7e\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xd2\x03\x00\x00\x85\x03\x00\x00\x00\x00\x00\x00\x67\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x81\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x71\x06\x21\x00\xbd\x06\x00\x00\x00\x00\x00\x00\xc3\x06\x00\x00\x00\x00\x54\x06\x70\x00\x00\x00\x00\x00\xdb\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa8\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xb5\x06\x33\x06\x8e\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x38\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x89\x02\x42\x03\x13\x07\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x13\x06\x00\x00\xcf\x04\x29\x05\x82\x05\x5f\x05\x4a\x05\xba\x04\x00\x00\x00\x00\xef\x05\xda\x05\xb9\x05\x93\x05\x49\x06\x32\x06\x23\x06\xff\x05\x6a\x06\x58\x06\xa2\x06\x8f\x06\x12\x06\x7f\x06\x78\x04\x00\x00\x00\x00\x00\x00\x61\x00\x17\x05\x00\x00\xed\x04\x00\x00\x11\x06\x30\x06\x00\x00\x00\x00\x2c\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x89\x06\x00\x00\x00\x00\x00\x06\x00\x00\x00\x00\x31\x00\x1c\x00\x00\x00\x00\x00\x00\x00\x08\x06\xe6\x05\xc0\x05\x00\x00\x00\x00\x00\x00\x00\x00\xad\x05\x00\x00\x00\x00\x00\x00\x00\x00\x4b\x05\x00\x00\x89\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xce\x05\xcc\x05\xb5\x05\xac\x05\x00\x00\xec\x04\x00\x00\x00\x00\x52\x05\x00\x00\x00\x00\x00\x00\x00\x00\x1b\x01\x67\x00\x27\x00\x28\x05\x00\x00\xe9\x04\x6c\x05\x00\x00\x18\x05\x0d\x05\x00\x00\x07\x00\x62\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x32\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x30\x00\x2f\x00\x2c\x05\x00\x00\xca\x06\x00\x00\xc2\x06\x00\x00\x00\x00\x00\x00\x40\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x91\x06\x8a\x06\x88\x06\x3f\x05\xf7\x04\xf4\x04\x00\x00\x00\x00\xdf\x04\x84\x04\x81\x04\x80\x04\x7d\x04\x7c\x04\xaf\x04\xd7\x09\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xae\x03\x3c\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x66\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x1a\x00\x00\x00\x11\x00\x00\x00\x61\x04\x00\x00\x87\x02\xf2\x04\x00\x00\x00\x00\x00\x00\x85\x04\x79\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x4a\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xac\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x6b\x02\xcd\x03\x00\x00\x00\x00\x00\x00\x24\x00\x00\x00\x00\x00\x2d\x03\x00\x00\x20\x01\x00\x00\x86\x03\x00\x00\x2d\x01\x00\x00\x00\x00\x18\x03\x00\x00\x00\x00\xec\x03\x69\x06\x00\x00\x00\x00\xf5\x02\x00\x00\x00\x00\x96\x06\x00\x00\x00\x00\x00\x00\x00\x00\xd7\x02\x00\x00\xd1\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x61\x06\x00\x00\xec\x05\x2b\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x88\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x05\x00\x00\x00\x00\x00\x65\x02\xdd\x03\x00\x00\x11\x02\x00\x00\x00\x00\x00\x00\x69\x02\x9a\x03\x00\x00\x00\x00\x00\x00\x00\x00\xfd\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x27\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x43\x03\x26\x04\xc8\x03\x34\x03\x00\x00\x00\x00\xee\x05\xee\x05\x00\x00\x00\x00\xf0\x05\xd8\x00\x00\x00\x00\x00\x00\x00\x83\x05\x00\x00\x80\x05\x7e\x05\x27\x05\x3d\x03\x27\x05\x47\x02\x00\x00\x00\x00\x8f\x04\x49\x03\x00\x00\x6a\x03\xe4\x02\x00\x00\x60\x02\x00\x00\x75\x02\x00\x00\x00\x00\x00\x00\x00\x00\x86\x00\x00\x00\x32\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xc1\x00\x00\x00\x00\x00\xc5\x03\x00\x00\x72\x05\x20\x00\x00\x00\x00\x00\x00\x00\x97\x02\x00\x00\x00\x00\x00\x00\xbb\x01\xe0\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x6c\x03\x30\x01\x00\x00\x00\x00\x9e\x01\x73\x00\x00\x00\x00\x00\x00\x00\x00\x00\x71\x01\x00\x00\x1d\x02\x00\x00\x00\x00\xd4\x00\xce\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2e\x00\x00\x00\x00\x00\x95\x00\x00\x00\x22\x02\x00\x00\x6b\x04\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2d\x07\x00\x00\x00\x00\x56\x07\x00\x00\x00\x00\x00\x00"#

happyDefActions :: HappyAddr
happyDefActions = HappyA# "\x00\x00\x95\xff\x93\xff\x13\xff\x00\x00\x86\xff\x2c\xff\x00\x00\x27\xff\x00\x00\x25\xff\x23\xff\x21\xff\x1f\xff\x1d\xff\x1a\xff\x18\xff\x15\xff\x13\xff\x10\xff\x00\x00\x00\x00\x13\xff\x00\x00\xfd\xfe\xfd\xfe\xfd\xfe\x00\x00\x00\x00\xe1\xfe\x00\x00\x00\x00\x00\x00\xd2\xfe\x13\xff\x00\x00\x00\x00\x00\x00\x00\x00\xb9\xfe\xb6\xfe\xb4\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x92\xfe\x8f\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x65\xfe\x62\xfe\x00\x00\x5d\xfe\x5b\xfe\x57\xfe\x55\xfe\x00\x00\x50\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x93\xff\xf3\xfd\xf0\xfd\xee\xfd\x00\x00\x00\x00\x00\x00\x00\x00\xf4\xfd\x00\x00\xf6\xfd\xf5\xfd\x00\x00\xbf\xfe\x00\x00\x00\x00\x00\x00\x00\x00\xac\xfe\x00\x00\xb9\xfe\x00\x00\x00\x00\x00\x00\x5d\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xcb\xfe\xc5\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x57\xfe\x06\xfe\x05\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x1d\xff\x00\x00\x1d\xff\x00\x00\x1d\xff\x00\x00\x25\xff\x5d\xfe\x00\x00\x5f\xfe\x5e\xfe\x00\x00\x5b\xfe\x00\x00\x57\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2f\xfe\x2e\xfe\x2d\xfe\x2c\xfe\x2b\xfe\x2a\xfe\x29\xfe\x28\xfe\x27\xfe\x26\xfe\x25\xfe\x24\xfe\x23\xfe\x22\xfe\x21\xfe\x20\xfe\x1f\xfe\x1e\xfe\x1d\xfe\x1c\xfe\x1b\xfe\x1a\xfe\x19\xfe\x18\xfe\x17\xfe\x16\xfe\x25\xff\x00\x00\x00\x00\x4c\xfe\x4b\xfe\x4a\xfe\x49\xfe\x48\xfe\x47\xfe\x46\xfe\x45\xfe\x44\xfe\x43\xfe\x42\xfe\x41\xfe\x40\xfe\x3f\xfe\x3e\xfe\x3d\xfe\x3c\xfe\x3b\xfe\x3a\xfe\x39\xfe\x38\xfe\x37\xfe\x36\xfe\x35\xfe\x34\xfe\x33\xfe\x32\xfe\x31\xfe\x30\xfe\x25\xff\x00\x00\x00\x00\x4f\xfe\x4e\xfe\x00\x00\x52\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x56\xfe\x00\x00\x5a\xfe\x58\xfe\x59\xfe\x00\x00\x5c\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x62\xfe\x00\x00\x00\x00\x68\xfe\x00\x00\x67\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x9f\xfe\x00\x00\x00\x00\x9e\xfe\x00\x00\x00\x00\x00\x00\x00\x00\xb4\xfe\x00\x00\x00\x00\xa4\xfe\x70\xff\x6e\xff\x6c\xff\x6a\xff\x68\xff\x63\xff\x61\xff\x5e\xff\x59\xff\x57\xff\x53\xff\x51\xff\x4f\xff\x4b\xff\x48\xff\x43\xff\x3e\xff\x37\xff\x35\xff\x33\xff\xb4\xfe\x00\x00\xf0\xfd\x79\xff\x84\xff\x83\xff\x82\xff\x81\xff\x7c\xff\x7b\xff\x7a\xff\xaa\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x2c\xff\x00\x00\x7e\xff\x7f\xff\x7d\xff\x00\x00\x00\x00\x80\xff\x00\x00\x00\x00\x00\x00\xae\xfe\xaf\xfe\xb1\xfe\x00\x00\xb2\xfe\x00\x00\x00\x00\x00\x00\x00\x00\xb7\xfe\xb8\xfe\x00\x00\x00\x00\xc2\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xcd\xfe\xcc\xfe\x12\xff\x11\xff\x00\x00\x13\xff\x13\xff\x1a\xff\x00\x00\xf0\xfd\x00\x00\xd8\xfe\x00\x00\xdc\xfe\xdd\xfe\xdb\xfe\xde\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xe8\xfe\xe9\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x1a\xff\x00\x00\x00\x00\x07\xff\x06\xff\x00\x00\x03\xff\x04\xff\x02\xff\x05\xff\x00\x00\x95\xff\x00\x00\x10\xff\x00\x00\x00\x00\x0f\xff\x00\x00\x00\x00\x14\xff\x00\x00\x17\xff\x16\xff\x00\x00\x00\x00\x00\x00\x1c\xff\x1b\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x24\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2b\xff\x00\x00\x00\x00\x00\x00\x00\x00\x8c\xff\x8e\xff\x88\xff\x00\x00\x8a\xff\x00\x00\x00\x00\x00\x00\x13\xff\x94\xff\x00\x00\x00\x00\x00\x00\x8f\xff\x90\xff\x8b\xff\x8d\xff\x87\xff\x89\xff\x85\xff\x00\x00\x26\xff\x00\x00\x20\xff\x00\x00\x19\xff\x00\x00\x00\x00\xf4\xfe\x00\x00\x09\xff\x08\xff\x18\xff\xf5\xfe\x00\x00\x00\x00\x13\xff\x00\x00\x00\x00\x73\xfe\x00\x00\x00\x00\x00\x00\x00\x00\xfc\xfe\xe7\xfe\x00\x00\xe4\xfe\xe5\xfe\xe6\xfe\xe2\xfe\x00\x00\x00\x00\x32\xff\x00\x00\x18\xff\x00\x00\xd1\xfe\xcf\xfe\xce\xfe\xea\xfe\x0b\xff\x00\x00\x00\x00\xc0\xfe\xf2\xfd\x00\x00\xb5\xfe\xb3\xfe\xb0\xfe\x00\x00\x5a\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x5b\xff\x5d\xff\x5c\xff\x00\x00\xa8\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x56\xff\x00\x00\x55\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa5\xfe\x00\x00\x00\x00\x8f\xfe\x9d\xfe\x00\x00\x00\x00\x98\xfe\x00\x00\x00\x00\x9c\xfe\x00\x00\x9a\xfe\x99\xfe\x00\x00\x91\xfe\x8d\xfe\x00\x00\x8c\xfe\x89\xfe\x00\x00\x00\x00\x80\xfe\x7b\xfe\x00\x00\x6c\xfe\x00\x00\x00\x00\x6d\xfe\x69\xfe\x6a\xfe\x66\xfe\x62\xfe\x64\xfe\x61\xfe\x60\xfe\x54\xfe\x00\x00\x51\xfe\x00\x00\x15\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x21\xff\x21\xff\x21\xff\x21\xff\x00\x00\x00\x00\x12\xfe\x00\x00\x5d\xfe\x0f\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xd2\xfe\xfd\xfd\x00\x00\x55\xfe\xfa\xfd\x00\x00\x82\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x96\xff\xed\xfd\x00\x00\xbd\xfe\xbb\xfe\xba\xfe\xbc\xfe\xbe\xfe\x00\x00\x00\x00\x00\x00\x81\xfe\x7d\xfe\xa7\xfe\x8b\xfe\xfb\xfd\xfc\xfd\xfe\xfd\x00\x00\xc9\xfe\xc7\xfe\xc6\xfe\xc8\xfe\xca\xfe\x04\xfe\x88\xfe\x88\xfe\x88\xfe\x23\xff\x23\xff\x23\xff\x10\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x23\xff\x00\x00\x4d\xfe\x53\xfe\x63\xfe\x6e\xfe\x6f\xfe\x65\xfe\x00\x00\x77\xfe\x76\xfe\x75\xfe\x74\xfe\x78\xfe\x00\x00\x00\x00\xd4\xfe\x83\xfe\xb6\xfe\x8e\xfe\x00\x00\x9b\xfe\x97\xfe\x96\xfe\x00\x00\x94\xfe\x93\xfe\xa2\xfe\xb4\xfe\xa0\xfe\x00\x00\x6d\xff\x00\x00\x65\xff\x00\x00\x00\x00\x00\x00\x58\xff\x54\xff\x86\xff\x50\xff\x4c\xff\x4d\xff\x4e\xff\x49\xff\x4a\xff\x44\xff\x45\xff\x46\xff\x47\xff\x3f\xff\x40\xff\x41\xff\x42\xff\x00\x00\x32\xff\x3a\xff\x3b\xff\x3c\xff\x3d\xff\x36\xff\x34\xff\xef\xfd\xa9\xfe\x62\xff\x71\xff\x27\xff\x2a\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x30\xff\x00\x00\xec\xfe\xfd\xfe\xd0\xfe\xd5\xfe\x00\x00\x00\x00\x00\x00\xd6\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x72\xfe\xf9\xfe\x18\xff\x73\xfe\xf7\xfe\xf6\xfe\x00\x00\x00\xff\x01\xff\x0c\xff\x0d\xff\x0e\xff\x1e\xff\x22\xff\x00\x00\x92\xff\x13\xff\x00\x00\x28\xff\xf3\xfe\x00\x00\xfa\xfe\x73\xfe\x00\x00\x00\x00\x00\x00\xff\xfe\x00\x00\xe3\xfe\xd7\xfe\x00\x00\x76\xff\x31\xff\x78\xff\x0a\xff\xee\xfe\x00\x00\xc4\xfe\x00\x00\xf1\xfd\xc1\xfe\x00\x00\x00\x00\x75\xff\x00\x00\x00\x00\x69\xff\x00\x00\x29\xff\x00\x00\x00\x00\x32\xff\x52\xff\x00\x00\x00\x00\x00\x00\x64\xff\x00\x00\x92\xfe\xa1\xfe\x95\xfe\x90\xfe\x86\xfe\x00\x00\x7f\xfe\x7e\xfe\x00\x00\x6b\xfe\x71\xfe\x14\xfe\x00\x00\x00\x00\x03\xfe\x02\xfe\x01\xfe\x00\xfe\x13\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x87\xfe\x08\xfe\x82\xfe\x08\xfe\xff\xfd\x8a\xfe\x88\xfe\x00\x00\x7c\xfe\xf9\xfd\xab\xfe\x88\xfe\x00\x00\x88\xfe\x88\xfe\xf8\xfd\x00\x00\x82\xfe\x00\x00\xf8\xfd\xa6\xfe\x85\xfe\x00\x00\x00\x00\x00\x00\x00\x00\x11\xfe\x00\x00\x00\x00\x6c\xfe\xd3\xfe\xa3\xfe\x00\x00\x67\xff\x00\x00\x60\xff\x00\x00\x39\xff\x6b\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x2f\xff\xeb\xfe\xfd\xfe\x77\xff\x73\xfe\x00\x00\x00\x00\x00\x00\xf0\xfe\x15\xff\xf8\xfe\x91\xff\xfb\xfe\x00\x00\x73\xfe\xfe\xfe\xf1\xfe\xed\xfe\x00\x00\x74\xff\x72\xff\x73\xff\x6f\xff\x38\xff\x5f\xff\x66\xff\x65\xfe\x00\x00\x0a\xfe\x0d\xfe\x00\x00\x00\x00\x07\xfe\x84\xfe\xad\xfe\x2e\xff\x00\x00\x00\x00\x00\x00\xf7\xfd\x0b\xfe\x00\x00\xe1\xfe\x00\x00\x70\xfe\xc3\xfe\xf2\xfe\xef\xfe\x00\x00\xe0\xfe\x00\x00\x1f\xff\x2d\xff\x7a\xfe\x09\xfe\xe1\xfe\x00\x00\x0e\xfe\xdf\xfe\x79\xfe\x00\x00\x00\x00\xda\xfe\x00\x00\x00\x00\xd9\xfe\x0c\xfe"#

happyCheck :: HappyAddr
happyCheck = HappyA# "\xff\xff\x00\x00\x01\x00\x00\x00\x01\x00\x00\x00\x00\x00\x24\x00\x3a\x00\x3b\x00\x3c\x00\x1f\x00\x4a\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1d\x00\x1d\x00\x2d\x00\x1d\x00\x30\x00\x2d\x00\x2d\x00\x2e\x00\x4d\x00\x4e\x00\x32\x00\x2a\x00\x2d\x00\x35\x00\x36\x00\x99\x00\x40\x00\x41\x00\x30\x00\x31\x00\x74\x00\x46\x00\x51\x00\x49\x00\x81\x00\x30\x00\x3f\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x43\x00\x40\x00\x41\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x74\x00\x43\x00\x42\x00\x01\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x92\x00\x2a\x00\x92\x00\x2a\x00\x92\x00\x92\x00\x92\x00\x2a\x00\x94\x00\x95\x00\x18\x00\x1f\x00\x2f\x00\x1f\x00\x5b\x00\x1d\x00\x92\x00\x6f\x00\x94\x00\x3f\x00\x1d\x00\x94\x00\x8e\x00\x8f\x00\x90\x00\x92\x00\x43\x00\x92\x00\x43\x00\x94\x00\x95\x00\x92\x00\x92\x00\x6c\x00\x01\x00\x92\x00\x92\x00\x4b\x00\x92\x00\x25\x00\x94\x00\x74\x00\x92\x00\x4b\x00\x92\x00\x92\x00\x92\x00\x92\x00\x92\x00\x92\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x01\x00\x1c\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x92\x00\x73\x00\x94\x00\x95\x00\x30\x00\x1d\x00\x92\x00\x8d\x00\x94\x00\x92\x00\x01\x00\x92\x00\x92\x00\x8d\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x92\x00\x9a\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x4d\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x87\x00\x1c\x00\x40\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x92\x00\x1c\x00\x94\x00\x95\x00\x6b\x00\x22\x00\x92\x00\x3f\x00\x30\x00\x31\x00\x30\x00\x31\x00\x01\x00\x1d\x00\x44\x00\x76\x00\x88\x00\x3f\x00\x49\x00\x92\x00\x35\x00\x49\x00\x0b\x00\x92\x00\x3f\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x87\x00\x41\x00\x53\x00\x1e\x00\x51\x00\x46\x00\x49\x00\x01\x00\x46\x00\x44\x00\x22\x00\x1f\x00\x92\x00\x5a\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x92\x00\x44\x00\x94\x00\x95\x00\x7a\x00\x92\x00\x92\x00\x94\x00\x93\x00\x92\x00\x92\x00\x4d\x00\x94\x00\x95\x00\x0b\x00\x92\x00\x82\x00\x94\x00\x01\x00\x85\x00\x51\x00\x92\x00\x92\x00\x92\x00\x94\x00\x1f\x00\x92\x00\x3a\x00\x92\x00\x5a\x00\x61\x00\x58\x00\x42\x00\x63\x00\x92\x00\x88\x00\x94\x00\x95\x00\x5d\x00\x87\x00\x01\x00\x8f\x00\x92\x00\x8e\x00\x03\x00\x01\x00\x1d\x00\x39\x00\x01\x00\x96\x00\x4d\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x85\x00\x1d\x00\x47\x00\x26\x00\x1d\x00\x6f\x00\x54\x00\x91\x00\x93\x00\x2a\x00\x92\x00\x2a\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x1d\x00\x47\x00\x40\x00\x1e\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x63\x00\x92\x00\x2a\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x3f\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x92\x00\x32\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x3f\x00\x5f\x00\x60\x00\x4b\x00\x03\x00\x45\x00\x4f\x00\x4f\x00\x51\x00\x51\x00\x92\x00\x4b\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x92\x00\x6e\x00\x94\x00\x95\x00\x5c\x00\x41\x00\x5c\x00\x03\x00\x2a\x00\x4a\x00\x45\x00\x2b\x00\x92\x00\x38\x00\x94\x00\x95\x00\x4b\x00\x4b\x00\x92\x00\x4b\x00\x94\x00\x66\x00\x83\x00\x6f\x00\x8a\x00\x6f\x00\x5b\x00\x5c\x00\x89\x00\x29\x00\x90\x00\x70\x00\x4b\x00\x92\x00\x8d\x00\x94\x00\x95\x00\x45\x00\x92\x00\x92\x00\x94\x00\x94\x00\x8d\x00\x4f\x00\x51\x00\x51\x00\x2a\x00\x4b\x00\x92\x00\x4b\x00\x94\x00\x4b\x00\x4b\x00\x71\x00\x92\x00\x65\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x92\x00\x6e\x00\x61\x00\x8d\x00\x8d\x00\x92\x00\x8d\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x92\x00\x92\x00\x94\x00\x94\x00\x8d\x00\x82\x00\x8d\x00\x92\x00\x8d\x00\x8d\x00\x92\x00\x37\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x8a\x00\x22\x00\x2a\x00\x6c\x00\x6e\x00\x26\x00\x90\x00\x2f\x00\x26\x00\x1f\x00\x44\x00\x74\x00\x92\x00\x97\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x5d\x00\x3c\x00\x61\x00\x92\x00\x47\x00\x92\x00\x61\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x22\x00\x4c\x00\x38\x00\x56\x00\x26\x00\x82\x00\x5d\x00\x60\x00\x43\x00\x82\x00\x92\x00\x88\x00\x94\x00\x95\x00\x67\x00\x8a\x00\x69\x00\x25\x00\x5e\x00\x4e\x00\x6d\x00\x90\x00\x93\x00\x6a\x00\x5e\x00\x6c\x00\x2e\x00\x66\x00\x97\x00\x5e\x00\x77\x00\x92\x00\x5b\x00\x94\x00\x95\x00\x6f\x00\x01\x00\x70\x00\x92\x00\x04\x00\x94\x00\x6f\x00\x92\x00\x7e\x00\x94\x00\x95\x00\x6f\x00\x92\x00\x64\x00\x0e\x00\x0f\x00\x67\x00\x92\x00\x92\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x53\x00\x62\x00\x14\x00\x15\x00\x16\x00\x17\x00\x10\x00\x11\x00\x12\x00\x13\x00\x32\x00\x1b\x00\x92\x00\x35\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x64\x00\x32\x00\x28\x00\x67\x00\x35\x00\x92\x00\x92\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x92\x00\x1d\x00\x94\x00\x1d\x00\x20\x00\x92\x00\x20\x00\x7f\x00\x80\x00\x81\x00\x92\x00\x1b\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x04\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x92\x00\x05\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x1a\x00\x69\x00\x67\x00\x67\x00\x3a\x00\x3b\x00\x92\x00\x88\x00\x94\x00\x95\x00\x0b\x00\x0c\x00\x0d\x00\x48\x00\x8a\x00\x8b\x00\x8c\x00\x79\x00\x77\x00\x77\x00\x90\x00\x96\x00\x92\x00\x92\x00\x92\x00\x94\x00\x94\x00\x92\x00\x98\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x92\x00\x23\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x59\x00\x5a\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x92\x00\x92\x00\x94\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x92\x00\x2c\x00\x94\x00\x95\x00\x92\x00\x92\x00\x94\x00\x94\x00\x92\x00\x92\x00\x94\x00\x94\x00\x92\x00\x23\x00\x94\x00\x92\x00\x23\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x61\x00\x62\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x92\x00\x22\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x92\x00\x23\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x92\x00\x4b\x00\x94\x00\x95\x00\x6d\x00\x92\x00\x51\x00\x94\x00\x92\x00\x92\x00\x94\x00\x94\x00\x5b\x00\x5c\x00\x92\x00\x5a\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x92\x00\x92\x00\x94\x00\x95\x00\x82\x00\x42\x00\x92\x00\x85\x00\x94\x00\x92\x00\x92\x00\x94\x00\x94\x00\x92\x00\x72\x00\x94\x00\x74\x00\x92\x00\x92\x00\x6a\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x92\x00\x24\x00\x94\x00\x95\x00\x61\x00\x62\x00\x57\x00\x58\x00\x57\x00\x58\x00\x24\x00\x57\x00\x58\x00\x92\x00\x92\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x24\x00\x92\x00\x24\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x92\x00\x68\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x92\x00\x66\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x57\x00\x58\x00\x5b\x00\x5c\x00\x92\x00\x66\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x92\x00\x65\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x13\x00\x92\x00\x93\x00\x54\x00\x92\x00\x52\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x92\x00\x92\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x22\x00\x92\x00\x92\x00\x92\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x92\x00\x28\x00\x94\x00\x95\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x61\x00\x62\x00\x92\x00\x92\x00\x94\x00\x95\x00\x32\x00\x33\x00\x61\x00\x62\x00\x20\x00\x21\x00\x92\x00\x93\x00\x1b\x00\x51\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x18\x00\x19\x00\x1a\x00\x1b\x00\x5a\x00\x92\x00\x56\x00\x94\x00\x95\x00\x57\x00\x58\x00\x57\x00\x58\x00\x29\x00\x04\x00\x05\x00\x92\x00\x29\x00\x57\x00\x58\x00\x92\x00\x28\x00\x94\x00\x95\x00\x0e\x00\x0f\x00\x6a\x00\x34\x00\x6c\x00\x01\x00\x02\x00\x03\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x2b\x00\x92\x00\x1d\x00\x94\x00\x95\x00\x0e\x00\x0f\x00\x82\x00\x92\x00\x7e\x00\x85\x00\x01\x00\x02\x00\x03\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x1c\x00\x1d\x00\x92\x00\x92\x00\x27\x00\x94\x00\x95\x00\x4d\x00\x5c\x00\x55\x00\x56\x00\x63\x00\x5c\x00\x92\x00\x93\x00\x3d\x00\x3e\x00\x3f\x00\x27\x00\x92\x00\x1d\x00\x94\x00\x95\x00\x33\x00\x34\x00\x5d\x00\x5e\x00\x6f\x00\x92\x00\x63\x00\x92\x00\x6f\x00\x04\x00\x3d\x00\x3e\x00\x3f\x00\x1f\x00\x20\x00\x92\x00\x50\x00\x94\x00\x95\x00\x33\x00\x34\x00\x92\x00\x93\x00\x61\x00\x62\x00\x76\x00\x56\x00\x92\x00\x4f\x00\x3d\x00\x3e\x00\x3f\x00\x92\x00\x92\x00\x94\x00\x95\x00\x01\x00\x02\x00\x03\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x71\x00\x68\x00\x6a\x00\x4f\x00\x6c\x00\x0e\x00\x0f\x00\x6f\x00\x91\x00\x6c\x00\x92\x00\x93\x00\x3a\x00\x3b\x00\x1e\x00\x1f\x00\x6f\x00\x6b\x00\x71\x00\x1c\x00\x1d\x00\x1e\x00\x7e\x00\x35\x00\x36\x00\x3d\x00\x3e\x00\x92\x00\x3a\x00\x7c\x00\x32\x00\x33\x00\x44\x00\x6a\x00\x46\x00\x41\x00\x92\x00\x71\x00\x22\x00\x4b\x00\x26\x00\x88\x00\x33\x00\x34\x00\x1e\x00\x1f\x00\x1e\x00\x1f\x00\x7c\x00\x1e\x00\x1f\x00\x26\x00\x3d\x00\x3e\x00\x3f\x00\x26\x00\x1e\x00\x1f\x00\x01\x00\x02\x00\x03\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x3d\x00\x6c\x00\x0b\x00\x6a\x00\x4f\x00\x0e\x00\x0f\x00\x44\x00\x92\x00\x46\x00\x35\x00\x36\x00\x1e\x00\x1f\x00\x4b\x00\x6f\x00\x1e\x00\x1f\x00\x4c\x00\x1c\x00\x1d\x00\x02\x00\x41\x00\x1e\x00\x1f\x00\x7f\x00\x7a\x00\x44\x00\x92\x00\x7d\x00\x1e\x00\x1f\x00\x47\x00\x87\x00\x4b\x00\x92\x00\x6f\x00\x91\x00\x71\x00\x8d\x00\x8e\x00\x8c\x00\x33\x00\x34\x00\x0e\x00\x0f\x00\x1e\x00\x1f\x00\x3c\x00\x7c\x00\x92\x00\x8b\x00\x3d\x00\x3e\x00\x3f\x00\x8a\x00\x61\x00\x89\x00\x01\x00\x02\x00\x03\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x7f\x00\x88\x00\x6f\x00\x3d\x00\x4f\x00\x0e\x00\x0f\x00\x85\x00\x87\x00\x86\x00\x44\x00\x84\x00\x46\x00\x7a\x00\x8d\x00\x8e\x00\x7d\x00\x4b\x00\x60\x00\x1c\x00\x1d\x00\x1e\x00\x82\x00\x82\x00\x80\x00\x67\x00\x7f\x00\x69\x00\x83\x00\x88\x00\x0e\x00\x0f\x00\x1e\x00\x1f\x00\x1e\x00\x1f\x00\x6f\x00\x92\x00\x71\x00\x7e\x00\x93\x00\x77\x00\x33\x00\x34\x00\x1e\x00\x1f\x00\x7d\x00\x1e\x00\x1f\x00\x7c\x00\x0e\x00\x0f\x00\x3d\x00\x3e\x00\x3f\x00\x02\x00\x03\x00\x7c\x00\x01\x00\x02\x00\x03\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x02\x00\x03\x00\x7b\x00\x7f\x00\x4f\x00\x0e\x00\x0f\x00\x02\x00\x03\x00\x8b\x00\x8c\x00\x87\x00\x7a\x00\x0e\x00\x0f\x00\x0e\x00\x0f\x00\x8d\x00\x8e\x00\x1c\x00\x1d\x00\x1e\x00\x8b\x00\x8c\x00\x78\x00\x77\x00\x8a\x00\x8b\x00\x8c\x00\x76\x00\x75\x00\x74\x00\x90\x00\x73\x00\x92\x00\x6d\x00\x6f\x00\x6c\x00\x71\x00\x97\x00\x98\x00\x6b\x00\x33\x00\x34\x00\x68\x00\x6a\x00\x69\x00\x67\x00\x66\x00\x7c\x00\x61\x00\x63\x00\x3d\x00\x3e\x00\x3f\x00\x64\x00\x5f\x00\x5d\x00\x01\x00\x02\x00\x03\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x5b\x00\x59\x00\x0b\x00\x57\x00\x4f\x00\x0e\x00\x0f\x00\x55\x00\x54\x00\x53\x00\x52\x00\x4b\x00\x4a\x00\x48\x00\x47\x00\x46\x00\x44\x00\x37\x00\x42\x00\x1c\x00\x1d\x00\x39\x00\x38\x00\x32\x00\x2c\x00\x2b\x00\x2a\x00\x29\x00\x28\x00\x27\x00\x26\x00\x25\x00\x24\x00\x23\x00\x22\x00\x21\x00\x6f\x00\x20\x00\x71\x00\x05\x00\x04\x00\x02\x00\x33\x00\x34\x00\x21\x00\x99\x00\x2f\x00\x52\x00\x01\x00\x7c\x00\x1d\x00\x01\x00\x3d\x00\x3e\x00\x3f\x00\x18\x00\x6b\x00\x1d\x00\x01\x00\x02\x00\x03\x00\x04\x00\x05\x00\x06\x00\x07\x00\x08\x00\x88\x00\x01\x00\x2d\x00\x74\x00\x4f\x00\x0e\x00\x0f\x00\x01\x00\x74\x00\x7d\x00\x3a\x00\x74\x00\x1e\x00\x1e\x00\x01\x00\x1e\x00\x1e\x00\x1e\x00\x2a\x00\x1c\x00\x1d\x00\x76\x00\x6b\x00\x01\x00\x57\x00\x9a\x00\x18\x00\x76\x00\x01\x00\x94\x00\x01\x00\x4b\x00\x01\x00\x88\x00\x1e\x00\x01\x00\x6f\x00\x04\x00\x71\x00\x04\x00\x27\x00\x28\x00\x33\x00\x34\x00\x04\x00\x2c\x00\x1d\x00\x74\x00\x2f\x00\x7c\x00\x1e\x00\x1e\x00\x3d\x00\x3e\x00\x3f\x00\x1e\x00\x74\x00\x38\x00\x27\x00\x28\x00\x3b\x00\x1d\x00\x01\x00\x2c\x00\x01\x00\x1d\x00\x2f\x00\x1e\x00\x1e\x00\x44\x00\x4f\x00\x46\x00\x1f\x00\x48\x00\x1f\x00\x38\x00\x4b\x00\x1f\x00\x3b\x00\x1e\x00\x29\x00\x50\x00\x1d\x00\x0a\x00\x2a\x00\x88\x00\x1f\x00\x44\x00\x02\x00\x46\x00\x02\x00\x48\x00\x67\x00\x01\x00\x4b\x00\x01\x00\x59\x00\x59\x00\x61\x00\x2a\x00\x9a\x00\x6b\x00\x6f\x00\x88\x00\x71\x00\x01\x00\x01\x00\x01\x00\x89\x00\x89\x00\x97\x00\x89\x00\x04\x00\x90\x00\x01\x00\x7c\x00\x61\x00\x8e\x00\x8a\x00\x59\x00\x8f\x00\x5d\x00\x79\x00\x78\x00\x01\x00\x1d\x00\x8a\x00\x01\x00\x7f\x00\x80\x00\x1e\x00\x82\x00\x1e\x00\x01\x00\x85\x00\x30\x00\x87\x00\x88\x00\x1d\x00\x5f\x00\x79\x00\x1e\x00\x7b\x00\x5c\x00\x5c\x00\x1e\x00\x7f\x00\x80\x00\x93\x00\x82\x00\x95\x00\x67\x00\x85\x00\x67\x00\x87\x00\x88\x00\x27\x00\x28\x00\x71\x00\x67\x00\x88\x00\x2c\x00\x67\x00\x99\x00\x2f\x00\x01\x00\x93\x00\x1e\x00\x95\x00\x5e\x00\x31\x00\x01\x00\x1d\x00\x38\x00\x27\x00\x28\x00\x3b\x00\x1d\x00\x68\x00\x2c\x00\x68\x00\x74\x00\x2f\x00\x68\x00\x71\x00\x44\x00\x01\x00\x46\x00\x1d\x00\x48\x00\x1e\x00\x38\x00\x4b\x00\x01\x00\x3b\x00\x4f\x00\x86\x00\x50\x00\x4f\x00\x8d\x00\x6f\x00\x49\x00\x9b\x00\x44\x00\x01\x00\x46\x00\x37\x00\x48\x00\x01\x00\x9b\x00\x4b\x00\x8e\x00\x36\x00\x01\x00\x61\x00\x9b\x00\x36\x00\x72\x00\x09\x00\x9b\x00\x88\x00\x9b\x00\x9b\x00\x9b\x00\x01\x00\x9b\x00\x74\x00\x9b\x00\x74\x00\x1d\x00\x01\x00\x01\x00\x61\x00\x9b\x00\x26\x00\x9b\x00\x9b\x00\x9b\x00\x79\x00\x1d\x00\x9b\x00\x96\x00\x1d\x00\x1d\x00\x7f\x00\x80\x00\x65\x00\x82\x00\x9b\x00\x67\x00\x85\x00\x1d\x00\x87\x00\x88\x00\x9b\x00\x67\x00\x79\x00\x67\x00\x02\x00\x5e\x00\x31\x00\x39\x00\x7f\x00\x80\x00\x93\x00\x82\x00\x95\x00\x44\x00\x85\x00\x46\x00\x87\x00\x88\x00\x01\x00\x9b\x00\x4b\x00\x9b\x00\x31\x00\x9b\x00\x23\x00\x9b\x00\x9b\x00\x31\x00\x93\x00\x01\x00\x95\x00\x9b\x00\x9b\x00\x42\x00\x9b\x00\x9b\x00\x5f\x00\x9b\x00\x01\x00\x9b\x00\x9b\x00\x9b\x00\x9b\x00\x9b\x00\x21\x00\x9b\x00\x7b\x00\x8a\x00\x9b\x00\x01\x00\x69\x00\x9b\x00\x44\x00\x92\x00\x46\x00\x40\x00\x6f\x00\x70\x00\x71\x00\x4b\x00\x73\x00\x74\x00\x75\x00\x76\x00\x77\x00\x78\x00\x79\x00\x7a\x00\x7b\x00\x7c\x00\x7d\x00\x7e\x00\x7f\x00\x80\x00\x9b\x00\x82\x00\x83\x00\x84\x00\x85\x00\x86\x00\x87\x00\x88\x00\x89\x00\x8a\x00\x8b\x00\x8c\x00\x8d\x00\x8e\x00\x8f\x00\x69\x00\x91\x00\x44\x00\x9b\x00\x46\x00\x8f\x00\x9b\x00\x98\x00\x71\x00\x4b\x00\x73\x00\x74\x00\x75\x00\x76\x00\x77\x00\x78\x00\x79\x00\x7a\x00\x7b\x00\x7c\x00\x7d\x00\x7e\x00\x7f\x00\x80\x00\x54\x00\x82\x00\x83\x00\x84\x00\x85\x00\x86\x00\x87\x00\x88\x00\x89\x00\x8a\x00\x8b\x00\x8c\x00\x8d\x00\x8e\x00\x8f\x00\x69\x00\x91\x00\x44\x00\x54\x00\x46\x00\x54\x00\x9b\x00\x9b\x00\x71\x00\x4b\x00\x73\x00\x74\x00\x75\x00\x76\x00\x77\x00\x78\x00\x79\x00\x7a\x00\x7b\x00\x7c\x00\x7d\x00\x7e\x00\x7f\x00\x80\x00\x9b\x00\x82\x00\x83\x00\x84\x00\x85\x00\x86\x00\x87\x00\x88\x00\x89\x00\x8a\x00\x8b\x00\x8c\x00\x8d\x00\x8e\x00\x8f\x00\x69\x00\x91\x00\x9b\x00\x40\x00\x44\x00\x5d\x00\x46\x00\x9b\x00\x9b\x00\x72\x00\x8a\x00\x4b\x00\x75\x00\x76\x00\x77\x00\x78\x00\x79\x00\x7a\x00\x7b\x00\x7c\x00\x9b\x00\x7e\x00\x7f\x00\x80\x00\x9b\x00\x82\x00\x83\x00\x84\x00\x85\x00\x86\x00\x87\x00\x88\x00\x89\x00\x8a\x00\x8b\x00\x8c\x00\x8d\x00\x8e\x00\x8f\x00\x97\x00\x91\x00\x69\x00\x90\x00\x75\x00\x9b\x00\x44\x00\x9b\x00\x46\x00\x64\x00\x01\x00\x72\x00\x9b\x00\x4b\x00\x75\x00\x76\x00\x77\x00\x78\x00\x79\x00\x7a\x00\x7b\x00\x7c\x00\x01\x00\x7e\x00\x7f\x00\x80\x00\x9b\x00\x82\x00\x83\x00\x84\x00\x85\x00\x86\x00\x87\x00\x88\x00\x89\x00\x8a\x00\x8b\x00\x8c\x00\x8d\x00\x8e\x00\x8f\x00\x8f\x00\x91\x00\x69\x00\x9b\x00\x01\x00\x9b\x00\x01\x00\x9b\x00\x01\x00\x75\x00\x9b\x00\x72\x00\x01\x00\x9b\x00\x75\x00\x76\x00\x77\x00\x78\x00\x79\x00\x7a\x00\x7b\x00\x7c\x00\x20\x00\x7e\x00\x7f\x00\x80\x00\x20\x00\x82\x00\x83\x00\x84\x00\x85\x00\x86\x00\x87\x00\x88\x00\x89\x00\x8a\x00\x8b\x00\x8c\x00\x8d\x00\x8e\x00\x8f\x00\x1d\x00\x91\x00\x01\x00\x95\x00\x93\x00\x88\x00\x87\x00\x85\x00\x80\x00\x7f\x00\x79\x00\x27\x00\x48\x00\x48\x00\x48\x00\x48\x00\x46\x00\x3b\x00\x44\x00\x44\x00\x44\x00\x2f\x00\x3b\x00\x2c\x00\x3b\x00\x28\x00\x3b\x00\x3b\x00\x50\x00\x8e\x00\x5f\x00\x8f\x00\x7d\x00\x40\x00\x50\x00\x74\x00\x99\x00\x6b\x00\x76\x00\x9a\x00\x54\x00\x88\x00\x57\x00\x93\x00\x01\x00\x58\x00\x3a\x00\x01\x00\x37\x00\x2d\x00\x36\x00\x4a\x00\x92\x00\x99\x00\x4c\x00\x52\x00\x1d\x00\x01\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x59\x00\x59\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"#

happyTable :: HappyAddr
happyTable = HappyA# "\x00\x00\xd6\x01\xe9\x01\xd6\x01\xd7\x01\x86\x03\xd8\x01\xad\x01\xbc\x03\x8f\x01\xbd\x03\xfe\x02\xc6\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x4b\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x84\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x84\x01\x6a\x03\x6c\x03\x18\x03\x6d\x03\x9a\x03\x30\x03\x0a\x02\x0b\x02\x98\x02\x99\x02\x9a\x01\x7b\x01\xa9\x01\x31\x03\x32\x03\xc8\x01\xc2\x02\xc3\x02\x28\x03\xc3\x03\x2b\x03\x73\x00\x48\x03\x49\x03\xae\x01\x3b\x02\xa4\x02\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\xd7\x02\x05\x02\xc2\x02\xc4\x02\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x18\x02\x29\x01\x62\x02\x0b\x01\x6c\x00\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\xa3\x03\x6a\x00\x7b\x01\x6a\x00\x7b\x01\x6a\x00\x6a\x00\x4d\x01\xa0\x01\x6d\x00\x4e\x01\x83\x01\x70\x03\x12\x03\xc1\x02\x63\x02\x84\x01\x6c\x00\x3c\x02\x33\x01\xa5\x02\x48\x03\x2a\x01\x74\x00\x75\x00\x76\x00\x6a\x01\x06\x02\x86\x01\x7c\x01\x6d\x00\x4e\x01\x9f\x01\xaa\x01\x13\x01\x6c\x00\xaa\x01\xaa\x01\x7c\x00\x6c\x00\xc0\x03\x88\x01\x14\x01\xaa\x01\x7c\x00\x7d\x01\x9f\x01\x6b\x03\x6b\x03\x86\x01\x6b\x03\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\xfe\x02\x6c\x00\x9d\x03\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x4b\x01\x86\x01\xc2\x02\x6d\x00\x4e\x01\x9e\x01\x35\x01\x6c\x00\x19\x02\x88\x01\x7d\x01\x6c\x00\x7d\x01\x86\x01\xb3\x03\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x84\x01\x86\x01\x22\x01\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x14\x02\x73\x03\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\xfe\x02\x65\x02\x2c\x03\x7d\x03\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\xfe\x02\x86\x01\xff\x02\x6d\x00\x4e\x01\x82\xfe\x8f\x02\x9f\x01\xa6\x02\x28\x03\x91\x03\x28\x03\x29\x03\x6c\x00\x75\x01\x5a\x02\x1e\x01\x7f\x00\x86\x02\x1e\x02\xbe\x03\xf6\x01\x42\x02\xf2\x02\x4d\x01\x87\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\xc8\x01\xfc\x00\x76\x01\xf7\x01\x17\x02\x90\x02\x78\x00\x69\x01\x6c\x00\x7a\x00\x89\x00\xf9\x02\x4e\x03\x86\x01\x91\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x4b\x01\x86\x01\x92\x01\x6d\x00\x4e\x01\xf8\x01\x6c\x00\x6a\x01\x88\x01\x5b\x02\x6a\x01\x86\x01\x67\x01\x6d\x00\x4e\x01\x06\x03\x6c\x00\x92\x02\x88\x01\x6c\x00\x93\x02\xfa\x02\x9f\x01\x6c\x00\x9f\x01\x88\x01\x67\x03\xb6\x03\x9a\x01\xf9\x01\xfb\x02\x93\x01\x6e\x01\x0b\x01\x68\x01\x86\x01\x7f\x00\x6d\x00\x4e\x01\xb2\x03\x8a\x00\x6c\x00\x79\x00\x6a\x01\x7b\x00\x1f\x03\x6c\x00\x35\x01\xb4\x03\x6c\x00\x77\x01\x4c\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x84\x01\xfc\x02\xd5\x02\x07\x03\x70\x01\x35\x01\x0c\x01\x24\x01\x69\x01\x94\x01\x6c\x01\x86\x01\xd3\x01\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\xc8\x01\x7a\x01\x71\x01\x85\x01\xc9\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x82\x03\xba\x03\x4d\x01\x7b\x01\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\xbf\x03\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x2e\x03\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\xae\x03\x89\x02\x22\x02\x23\x02\x24\x02\x25\x02\x86\x01\x0e\x01\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x2e\x03\x87\x01\xc6\x03\xc7\x03\x7c\x00\xd9\x01\x63\x03\x51\x02\x40\x02\x36\x01\x36\x01\x86\x01\x7c\x00\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x8b\x03\x86\x01\x0f\x01\x6d\x00\x4e\x01\x26\x02\x5d\x02\x3d\x02\xd2\x01\xd3\x01\x95\x02\x72\x01\xb5\x01\x86\x01\xac\x00\x6d\x00\x4e\x01\x7c\x00\x7c\x00\x6c\x00\x7c\x00\x88\x01\x37\x02\x10\x01\x27\x02\xaa\x02\x3e\x02\x96\x02\x97\x02\x11\x01\x97\x03\xa9\x02\x39\x02\xad\x00\x86\x01\x41\x02\x6d\x00\x4e\x01\xb6\x01\x6c\x00\x6c\x00\x33\x01\x33\x01\x73\x01\x35\x01\x32\x01\x36\x01\xd3\x01\x7c\x00\x6c\x00\x7c\x00\x88\x01\x7c\x00\x7c\x00\x5e\x02\x86\x01\xa5\x03\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x20\x03\xa7\x03\x81\x02\x8c\x00\x73\x01\x7f\x03\x86\x01\x36\x03\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x22\x03\x6c\x00\x6c\x00\x33\x01\x33\x01\x45\x03\x8d\x00\xf7\x02\xfa\x00\x09\x02\x7d\x00\x86\x01\xa8\x03\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x25\x03\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x2e\x03\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\xf6\x02\xaa\x02\x69\x02\xa0\x01\x13\x01\xf9\x00\x6a\x02\xa9\x02\xa1\x01\x70\x01\x2c\x01\x9f\x00\x14\x01\x86\x01\xa8\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\xe0\x01\x6d\x02\x2d\x01\x8c\x00\xfa\x00\x71\x01\x86\x01\x8c\x00\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\xe1\x01\x69\x02\xcc\x01\xa9\x03\xdd\x01\x70\x02\x8d\x00\xab\x03\x2e\x01\x02\x01\x8d\x00\x86\x01\x7f\x00\x6d\x00\x4e\x01\x2f\x01\x6e\x02\x30\x01\x96\x01\x26\x01\x03\x01\x31\x01\x6f\x02\x78\x00\xde\x01\x01\x02\xdf\x01\x97\x01\x37\x02\x70\x02\x26\x01\x32\x01\x86\x01\x04\x01\x6d\x00\x4e\x01\x27\x01\x6c\x00\x39\x02\x6c\x00\x7f\x01\x76\x03\x02\x02\x6c\x00\xe0\x01\x6d\x00\x6e\x00\x27\x01\xb0\x03\x51\x03\x80\x01\x81\x01\xb7\x03\x86\x01\x79\x03\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\xe2\x01\x7e\x03\x98\x01\x28\x02\x29\x02\x2a\x02\x2b\x02\x2c\x02\x2d\x02\x2e\x02\x2f\x02\x9a\x01\x83\x03\x86\x01\x9c\x03\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\xea\x01\x51\x03\x9a\x01\x24\x03\x52\x03\x9b\x01\x86\x01\x2b\x03\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x10\x02\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x4e\x02\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x52\x02\x6c\x00\x03\x02\x77\x03\x03\x02\x04\x02\x35\x03\x1e\x02\x97\x00\x98\x00\x99\x00\x86\x01\x40\x03\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\x56\x02\x35\x02\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\xd9\x02\x86\x01\x42\x03\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\x49\x01\x4a\x01\xc3\x01\xa9\x00\xca\x02\x4a\x02\xc5\x03\x8f\x01\x86\x01\x7f\x00\x6d\x00\x4e\x01\x32\x02\x33\x02\x34\x02\x4c\x03\x1d\xff\xba\x01\xbb\x01\xaa\x00\xcb\x02\x4b\x02\x1d\xff\x38\x03\xc3\x01\x6c\x00\x6c\x00\x78\x03\x7b\x03\x86\x01\x6c\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\xea\x02\x86\x01\x54\x03\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x48\x01\xef\x02\xac\x03\xad\x03\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x1a\x02\x6c\x00\x86\x01\x46\x03\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\x44\x03\x86\x01\x5a\x03\x6d\x00\x4e\x01\x6c\x00\x6c\x00\x55\x03\x56\x03\x6c\x00\x6c\x00\x57\x03\x58\x03\x6c\x00\x5c\x03\x59\x03\x86\x01\x5d\x03\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\xd6\x02\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\x47\x01\xee\x02\x0e\x03\xb9\x03\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x1b\x02\x86\x01\x9f\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\xeb\x02\x86\x01\x5e\x03\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\xec\x02\x86\x01\x69\x03\x6d\x00\x4e\x01\x9a\x02\x6c\x00\xa0\x02\x9d\x02\x6c\x00\x6c\x00\xac\x02\xd3\x02\x96\x02\xaf\x03\x86\x01\xa1\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\x46\x01\xed\x02\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\xe4\x02\x86\x01\x9b\x02\x6d\x00\x4e\x01\xa2\x02\x9c\x02\x6c\x00\xa3\x02\x72\x02\x6c\x00\x6c\x00\x7f\x02\x80\x02\x6c\x00\xfc\x01\x6f\x00\xfd\x01\xa3\x02\x86\x01\xaa\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\xe5\x02\x86\x01\xad\x02\x6d\x00\x4e\x01\x0e\x03\x9b\x03\x5f\x03\x6e\x03\x5f\x03\x70\x03\xae\x02\x5f\x03\x72\x03\x86\x01\xb5\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\xe6\x02\xaf\x02\x86\x01\xb0\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\x45\x01\xe7\x02\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\xe0\x02\x86\x01\xb6\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\xdb\x02\x86\x01\xb7\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\xe1\x02\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\xe2\x02\x5f\x03\x74\x03\x96\x02\x75\x03\x86\x01\xb8\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\x44\x01\xe3\x02\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\xde\x02\x86\x01\xb9\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\x43\x01\xdf\x02\x0e\x02\x92\x03\xcd\x02\x86\x01\xd0\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\xda\x02\x86\x01\xc5\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\xdc\x02\xbc\x02\xd1\x02\x86\x01\xf0\x02\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x3f\x01\x40\x01\x41\x01\x42\x01\xdd\x02\x86\x01\x03\x03\x6d\x00\x4e\x01\x37\x01\x38\x01\x39\x01\x3a\x01\x3b\x01\x3c\x01\x3d\x01\x3e\x01\x1c\x02\x0e\x03\x94\x03\x86\x01\xf0\x02\x6d\x00\x4e\x01\x9c\x01\x21\x03\x0e\x03\x23\x03\x3e\x03\x3f\x03\x0e\x02\x50\x03\x04\x03\xbd\x02\x22\x02\x23\x02\x24\x02\x25\x02\x22\x02\x23\x02\x24\x02\x25\x02\xbe\x02\x86\x01\xce\x01\x6d\x00\x4e\x01\x5f\x03\x60\x03\x5f\x03\x61\x03\x82\x03\xa3\x01\xa4\x01\x13\x03\x44\x03\x5f\x03\x62\x03\x86\x01\x15\x03\x6d\x00\x4e\x01\x80\x01\x81\x01\xcf\x01\x17\x03\xd0\x01\x6c\x00\x50\x01\x51\x01\x52\x01\x53\x01\x54\x01\x55\x01\x56\x01\xe8\x01\x86\x01\xa5\x01\x6d\x00\x4e\x01\x58\x01\x59\x01\xbf\x02\x19\x03\xd2\x01\xc0\x02\x6c\x00\x50\x01\x51\x01\x52\x01\x53\x01\x54\x01\x55\x01\x56\x01\x5a\x01\x5b\x01\xe6\x01\x86\x01\xed\x01\x6d\x00\x4e\x01\x67\x01\x26\x02\x64\x03\x65\x03\xee\x01\x26\x02\x0e\x02\xc6\x02\xa6\x01\xa7\x01\xa8\x01\x04\x02\x86\x01\x5b\x01\x6d\x00\x4e\x01\x5c\x01\x5d\x01\x67\x03\x68\x03\x27\x02\xf9\x01\x68\x01\x11\x02\x27\x02\x35\x02\x5e\x01\x5f\x01\x60\x01\xf4\x02\xf5\x02\x86\x01\x3f\x02\x6d\x00\x4e\x01\x5c\x01\x5d\x01\x0e\x02\x09\x03\x0e\x03\x0f\x03\x1e\x01\xce\x01\x58\x02\x61\x01\x5e\x01\x5f\x01\x60\x01\x86\x01\x5b\x02\x6d\x00\x4e\x01\x6c\x00\x50\x01\x51\x01\x52\x01\x53\x01\x54\x01\x55\x01\x56\x01\xa9\x01\x60\x02\xcf\x01\x61\x01\xd0\x01\x58\x01\x59\x01\xd1\x01\x69\x01\x73\x02\x0e\x02\x0f\x02\x8e\x01\x8f\x01\xc5\x03\x91\x03\x62\x01\x74\x02\x63\x01\x5a\x01\x5b\x01\xa3\x03\xd2\x01\xfd\xfe\xfd\xfe\xc9\x03\xca\x03\x63\x02\x9a\x01\x64\x01\x9c\x01\x9d\x01\x89\x00\x75\x02\x7a\x00\xfd\xfe\x65\x02\x63\x01\x69\x02\x7c\x00\x76\x02\x7f\x00\x5c\x01\x5d\x01\xc2\x03\xc3\x03\xb9\x03\x35\x03\x64\x01\x99\x03\xfe\x02\x77\x02\x5e\x01\x5f\x01\x60\x01\x78\x02\x9a\x03\x91\x03\x6c\x00\x50\x01\x51\x01\x52\x01\x53\x01\x54\x01\x55\x01\x56\x01\xcc\x03\x7c\x02\x57\x01\x82\x02\x61\x01\x58\x01\x59\x01\x89\x00\x83\x02\x7a\x00\xf0\x01\xf1\x01\x7d\x03\xfe\x02\x7c\x00\xfd\xfe\x8d\x03\x8e\x03\x85\x02\x5a\x01\x5b\x01\x8b\x02\xf2\x01\x8f\x03\x35\x03\x8a\x01\xfd\xfe\x9f\x00\x6a\x00\xfd\xfe\x90\x03\x91\x03\x84\x02\x8b\x01\xce\x03\x70\x00\x62\x01\x71\x00\x63\x01\x8c\x01\x8d\x01\x7f\x00\x5c\x01\x5d\x01\x80\x01\x81\x01\x34\x03\x35\x03\x45\x02\x64\x01\xfd\xfe\x81\x00\x5e\x01\x5f\x01\x60\x01\x83\x00\x8c\x00\x85\x00\x6c\x00\x50\x01\x51\x01\x52\x01\x53\x01\x54\x01\x55\x01\x56\x01\x8a\x01\x87\x00\xf3\x01\x89\x01\x61\x01\x58\x01\x59\x01\x8f\x00\x8b\x01\x8d\x00\x89\x00\x91\x00\x7a\x00\xf4\x01\x8c\x01\x8d\x01\x16\x01\x7c\x00\x46\x02\x5a\x01\x5b\x01\x85\x03\x95\x00\x8d\x00\x9b\x00\x47\x02\x9d\x00\x48\x02\x93\x00\x7f\x00\x30\x02\x31\x02\x4c\x03\xfe\x02\xfd\x02\xfe\x02\x62\x01\xf5\x01\x63\x01\x9f\x00\x78\x00\x49\x02\x5c\x01\x5d\x01\x01\x03\x02\x03\xa1\x00\x1e\x03\x1f\x03\x64\x01\x80\x01\x81\x01\x5e\x01\x5f\x01\x60\x01\xdb\x01\xdc\x01\xa3\x00\x6c\x00\x50\x01\x51\x01\x52\x01\x53\x01\x54\x01\x55\x01\x56\x01\xec\x01\xed\x01\xa5\x00\x8a\x01\x61\x01\x58\x01\x59\x01\x08\x02\x09\x02\xba\x01\xbb\x01\x8b\x01\xa7\x00\x80\x01\x81\x01\x80\x01\x81\x01\x8c\x01\x8d\x01\x5a\x01\x5b\x01\x30\x03\xba\x01\xbb\x01\xad\x00\xaf\x00\x1d\xff\xba\x01\xbb\x01\xb1\x00\xb3\x00\xb5\x00\x1d\xff\xb7\x00\xc3\x01\xfc\x00\x62\x01\xfe\x00\x63\x01\x1d\xff\x6c\x02\x00\x01\x5c\x01\x5d\x01\x07\x01\x04\x01\x06\x01\x09\x01\x0c\x01\x64\x01\x16\x01\x14\x01\x5e\x01\x5f\x01\x60\x01\x11\x01\x18\x01\x1a\x01\x6c\x00\x50\x01\x51\x01\x52\x01\x53\x01\x54\x01\x55\x01\x56\x01\x1c\x01\x1e\x01\x57\x01\x20\x01\x61\x01\x58\x01\x59\x01\x22\x01\x24\x01\x27\x01\x2a\x01\x64\x01\x65\x01\x6c\x01\x6e\x01\x71\x01\x77\x01\x78\x01\x81\x01\x5a\x01\x5b\x01\x90\x01\x94\x01\x98\x01\xab\x01\xae\x01\xb0\x01\xb1\x01\xb3\x01\xb6\x01\xb8\x01\xbb\x01\xbd\x01\xbf\x01\xc1\x01\xc4\x01\x62\x01\xc6\x01\x63\x01\xca\x01\xcc\x01\xd4\x01\x5c\x01\x5d\x01\xcc\x03\x1a\x01\xc9\x03\xbd\x01\x6c\x00\x64\x01\xbc\x03\x6c\x00\x5e\x01\x5f\x01\x60\x01\xb2\x03\x1c\x01\xb6\x03\x6c\x00\x50\x01\x51\x01\x52\x01\x53\x01\x54\x01\x55\x01\x56\x01\x7f\x00\x6c\x00\xb3\x01\x18\x01\x61\x01\x58\x01\x59\x01\x6c\x00\x18\x01\x16\x01\x9a\x01\xa7\x03\x9f\x03\xa0\x03\x6c\x00\xa1\x03\xa2\x03\xa5\x03\xab\x03\x5a\x01\x5b\x01\x1e\x01\x1c\x01\x6c\x00\x20\x01\x22\x01\x72\x03\x1e\x01\x6c\x00\x7b\x03\x6c\x00\x86\x03\x6c\x00\x7f\x00\x81\x03\x6c\x00\x62\x01\x88\x03\x63\x01\x89\x03\xb5\x00\xb3\x00\x5c\x01\x5d\x01\x8a\x03\xb1\x00\x8b\x03\x18\x01\xaf\x00\x64\x01\x94\x03\x96\x03\x5e\x01\x5f\x01\x60\x01\x97\x03\x18\x01\xac\x00\xb5\x00\xb3\x00\xf5\x00\x27\x03\x6c\x00\xb1\x00\x6c\x00\x28\x03\xaf\x00\x2e\x03\x3a\x03\x9b\x00\x61\x01\x97\x00\x39\x03\xd6\x00\x3b\x03\xac\x00\xad\x00\x3c\x03\xd5\x00\x3d\x03\x21\x02\xf6\x00\x42\x03\x35\x02\x3e\x03\x7f\x00\x4e\x03\x9b\x00\x4f\x03\x97\x00\x50\x03\xd6\x00\x4b\x03\x6c\x00\xad\x00\x6c\x00\xc1\x01\xc1\x01\x8c\x00\x5c\x03\x22\x01\x1c\x01\x62\x01\x7f\x00\x63\x01\x6c\x00\x8d\x02\x6c\x00\x8e\x02\x94\x02\xa8\x02\x95\x02\xac\x02\xa9\x02\x6c\x00\x64\x01\x8c\x00\xfe\x00\xaa\x02\xbf\x01\x06\x01\xb3\x02\x89\x00\xb4\x02\x6c\x00\xbb\x02\xb2\x02\x6c\x00\x87\x00\x85\x00\xcf\x02\x8d\x00\xd0\x02\x6c\x00\x83\x00\xd6\x02\x81\x00\x7f\x00\xea\x02\x09\x01\x89\x00\xf3\x02\x69\x02\xd3\x02\xe9\x02\xf4\x02\x87\x00\x85\x00\x78\x00\x8d\x00\x73\x00\xc8\x02\x83\x00\xc9\x02\x81\x00\x7f\x00\xb5\x00\xb3\x00\xd9\x02\xcc\x02\x7f\x00\xb1\x00\xcd\x02\xc8\x01\xaf\x00\x6c\x00\x78\x00\x03\x03\x73\x00\x08\x03\x09\x03\x6c\x00\x0b\x03\xac\x00\xb5\x00\xb3\x00\xf5\x00\x0e\x03\x0c\x03\xb1\x00\x0d\x03\x18\x01\xaf\x00\x11\x03\x12\x03\x9b\x00\x6c\x00\x97\x00\x15\x03\xd6\x00\x17\x03\xac\x00\xad\x00\x6c\x00\xd5\x00\x1c\x03\x1b\x03\xf6\x00\xe5\x01\x1d\x03\xe4\x01\xe6\x01\xff\xff\x9b\x00\x6c\x00\x97\x00\xb0\x01\xd6\x00\x6c\x00\xff\xff\xad\x00\xe8\x01\xb8\x01\x6c\x00\x8c\x00\xff\xff\xb8\x01\xfb\x01\x00\x02\xff\xff\x7f\x00\xff\xff\xff\xff\xff\xff\x6c\x00\xff\xff\xfe\x01\xff\xff\xff\x01\x0d\x02\x6c\x00\x6c\x00\x8c\x00\xff\xff\x13\x02\xff\xff\xff\xff\xff\xff\x89\x00\x14\x02\xff\xff\x0e\x02\x16\x02\x17\x02\x87\x00\x85\x00\x3a\x02\x8d\x00\xff\xff\x44\x02\x83\x00\x4e\x02\x81\x00\x7f\x00\xff\xff\x4c\x02\x89\x00\x4d\x02\x56\x02\x50\x02\x51\x02\x58\x02\x87\x00\x85\x00\x78\x00\x8d\x00\x73\x00\x89\x00\x83\x00\x73\x00\x81\x00\x7f\x00\x6c\x00\xff\xff\x7c\x00\xff\xff\x54\x02\xff\xff\x5f\x02\xff\xff\xff\xff\x55\x02\x78\x00\x6c\x00\x73\x00\xff\xff\xff\xff\x60\x02\xff\xff\xff\xff\x09\x01\xff\xff\x6c\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x67\x02\xff\xff\x69\x02\x72\x02\xff\xff\x6c\x00\xa9\x00\xff\xff\x89\x00\xc3\x01\x73\x00\x00\x01\xf6\x00\xf7\x00\xf8\x00\x7c\x00\xd7\x00\xd8\x00\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\xe2\x00\xe3\x00\xe4\x00\xff\xff\xe5\x00\xe6\x00\xe7\x00\xe8\x00\xe9\x00\xea\x00\xeb\x00\xec\x00\xed\x00\xee\x00\xef\x00\xf0\x00\xf1\x00\xf2\x00\xa9\x00\xf3\x00\x89\x00\xff\xff\x73\x00\x06\x01\xff\xff\x6c\x02\xb4\x02\x7c\x00\xd7\x00\xd8\x00\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\xe2\x00\xe3\x00\xe4\x00\x7a\x02\xe5\x00\xe6\x00\xe7\x00\xe8\x00\xe9\x00\xea\x00\xeb\x00\xec\x00\xed\x00\xee\x00\xef\x00\xf0\x00\xf1\x00\xf2\x00\xa9\x00\xf3\x00\x89\x00\x7b\x02\x73\x00\x7c\x02\xff\xff\xff\xff\xd6\x00\x7c\x00\xd7\x00\xd8\x00\xd9\x00\xda\x00\xdb\x00\xdc\x00\xdd\x00\xde\x00\xdf\x00\xe0\x00\xe1\x00\xe2\x00\xe3\x00\xe4\x00\xff\xff\xe5\x00\xe6\x00\xe7\x00\xe8\x00\xe9\x00\xea\x00\xeb\x00\xec\x00\xed\x00\xee\x00\xef\x00\xf0\x00\xf1\x00\xf2\x00\xa9\x00\xf3\x00\xff\xff\x00\x01\x89\x00\x6d\x02\x73\x00\xff\xff\xff\xff\x53\x03\x6e\x02\x7c\x00\xba\x00\xbb\x00\xbc\x00\xbd\x00\xbe\x00\xbf\x00\xc0\x00\xc1\x00\xff\xff\xc2\x00\xc3\x00\xc4\x00\xff\xff\xc5\x00\xc6\x00\xc7\x00\xc8\x00\xc9\x00\xca\x00\xcb\x00\xcc\x00\xcd\x00\xce\x00\xcf\x00\xd0\x00\xd1\x00\xd2\x00\x70\x02\xd3\x00\xa9\x00\x6f\x02\x7e\x02\xff\xff\x89\x00\xff\xff\x73\x00\x7f\x02\x6c\x00\x67\x02\xff\xff\x7c\x00\xba\x00\xbb\x00\xbc\x00\xbd\x00\xbe\x00\xbf\x00\xc0\x00\xc1\x00\x6c\x00\xc2\x00\xc3\x00\xc4\x00\xff\xff\xc5\x00\xc6\x00\xc7\x00\xc8\x00\xc9\x00\xca\x00\xcb\x00\xcc\x00\xcd\x00\xce\x00\xcf\x00\xd0\x00\xd1\x00\xd2\x00\x06\x01\xd3\x00\xa9\x00\xff\xff\x6c\x00\xff\xff\x6c\x00\xff\xff\x6c\x00\x89\x02\xff\xff\xb9\x00\x6c\x00\xff\xff\xba\x00\xbb\x00\xbc\x00\xbd\x00\xbe\x00\xbf\x00\xc0\x00\xc1\x00\x8b\x02\xc2\x00\xc3\x00\xc4\x00\x04\x02\xc5\x00\xc6\x00\xc7\x00\xc8\x00\xc9\x00\xca\x00\xcb\x00\xcc\x00\xcd\x00\xce\x00\xcf\x00\xd0\x00\xd1\x00\xd2\x00\xd6\x01\xd3\x00\x6c\x00\x73\x00\x78\x00\x7f\x00\x81\x00\x83\x00\x85\x00\x87\x00\x89\x00\xb5\x00\x8f\x00\x91\x00\x93\x00\x95\x00\x97\x00\xa1\x00\x9b\x00\x9d\x00\x9f\x00\xaf\x00\xa3\x00\xb1\x00\xa5\x00\xb3\x00\xa7\x00\xa9\x00\xb7\x00\xfe\x00\x09\x01\x06\x01\x16\x01\x00\x01\xb9\x00\x18\x01\x1a\x01\x1c\x01\x1e\x01\x22\x01\x24\x01\x7f\x00\x20\x01\x78\x00\x6c\x00\x6e\x01\x9a\x01\x6c\x00\xb0\x01\xb3\x01\xb8\x01\xc6\x01\xc3\x01\xc8\x01\xcc\x01\xbd\x01\xd6\x01\x6c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xbf\x01\xc1\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyReduceArr = Happy_Data_Array.array (105, 530) [
	(105 , happyReduce_105),
	(106 , happyReduce_106),
	(107 , happyReduce_107),
	(108 , happyReduce_108),
	(109 , happyReduce_109),
	(110 , happyReduce_110),
	(111 , happyReduce_111),
	(112 , happyReduce_112),
	(113 , happyReduce_113),
	(114 , happyReduce_114),
	(115 , happyReduce_115),
	(116 , happyReduce_116),
	(117 , happyReduce_117),
	(118 , happyReduce_118),
	(119 , happyReduce_119),
	(120 , happyReduce_120),
	(121 , happyReduce_121),
	(122 , happyReduce_122),
	(123 , happyReduce_123),
	(124 , happyReduce_124),
	(125 , happyReduce_125),
	(126 , happyReduce_126),
	(127 , happyReduce_127),
	(128 , happyReduce_128),
	(129 , happyReduce_129),
	(130 , happyReduce_130),
	(131 , happyReduce_131),
	(132 , happyReduce_132),
	(133 , happyReduce_133),
	(134 , happyReduce_134),
	(135 , happyReduce_135),
	(136 , happyReduce_136),
	(137 , happyReduce_137),
	(138 , happyReduce_138),
	(139 , happyReduce_139),
	(140 , happyReduce_140),
	(141 , happyReduce_141),
	(142 , happyReduce_142),
	(143 , happyReduce_143),
	(144 , happyReduce_144),
	(145 , happyReduce_145),
	(146 , happyReduce_146),
	(147 , happyReduce_147),
	(148 , happyReduce_148),
	(149 , happyReduce_149),
	(150 , happyReduce_150),
	(151 , happyReduce_151),
	(152 , happyReduce_152),
	(153 , happyReduce_153),
	(154 , happyReduce_154),
	(155 , happyReduce_155),
	(156 , happyReduce_156),
	(157 , happyReduce_157),
	(158 , happyReduce_158),
	(159 , happyReduce_159),
	(160 , happyReduce_160),
	(161 , happyReduce_161),
	(162 , happyReduce_162),
	(163 , happyReduce_163),
	(164 , happyReduce_164),
	(165 , happyReduce_165),
	(166 , happyReduce_166),
	(167 , happyReduce_167),
	(168 , happyReduce_168),
	(169 , happyReduce_169),
	(170 , happyReduce_170),
	(171 , happyReduce_171),
	(172 , happyReduce_172),
	(173 , happyReduce_173),
	(174 , happyReduce_174),
	(175 , happyReduce_175),
	(176 , happyReduce_176),
	(177 , happyReduce_177),
	(178 , happyReduce_178),
	(179 , happyReduce_179),
	(180 , happyReduce_180),
	(181 , happyReduce_181),
	(182 , happyReduce_182),
	(183 , happyReduce_183),
	(184 , happyReduce_184),
	(185 , happyReduce_185),
	(186 , happyReduce_186),
	(187 , happyReduce_187),
	(188 , happyReduce_188),
	(189 , happyReduce_189),
	(190 , happyReduce_190),
	(191 , happyReduce_191),
	(192 , happyReduce_192),
	(193 , happyReduce_193),
	(194 , happyReduce_194),
	(195 , happyReduce_195),
	(196 , happyReduce_196),
	(197 , happyReduce_197),
	(198 , happyReduce_198),
	(199 , happyReduce_199),
	(200 , happyReduce_200),
	(201 , happyReduce_201),
	(202 , happyReduce_202),
	(203 , happyReduce_203),
	(204 , happyReduce_204),
	(205 , happyReduce_205),
	(206 , happyReduce_206),
	(207 , happyReduce_207),
	(208 , happyReduce_208),
	(209 , happyReduce_209),
	(210 , happyReduce_210),
	(211 , happyReduce_211),
	(212 , happyReduce_212),
	(213 , happyReduce_213),
	(214 , happyReduce_214),
	(215 , happyReduce_215),
	(216 , happyReduce_216),
	(217 , happyReduce_217),
	(218 , happyReduce_218),
	(219 , happyReduce_219),
	(220 , happyReduce_220),
	(221 , happyReduce_221),
	(222 , happyReduce_222),
	(223 , happyReduce_223),
	(224 , happyReduce_224),
	(225 , happyReduce_225),
	(226 , happyReduce_226),
	(227 , happyReduce_227),
	(228 , happyReduce_228),
	(229 , happyReduce_229),
	(230 , happyReduce_230),
	(231 , happyReduce_231),
	(232 , happyReduce_232),
	(233 , happyReduce_233),
	(234 , happyReduce_234),
	(235 , happyReduce_235),
	(236 , happyReduce_236),
	(237 , happyReduce_237),
	(238 , happyReduce_238),
	(239 , happyReduce_239),
	(240 , happyReduce_240),
	(241 , happyReduce_241),
	(242 , happyReduce_242),
	(243 , happyReduce_243),
	(244 , happyReduce_244),
	(245 , happyReduce_245),
	(246 , happyReduce_246),
	(247 , happyReduce_247),
	(248 , happyReduce_248),
	(249 , happyReduce_249),
	(250 , happyReduce_250),
	(251 , happyReduce_251),
	(252 , happyReduce_252),
	(253 , happyReduce_253),
	(254 , happyReduce_254),
	(255 , happyReduce_255),
	(256 , happyReduce_256),
	(257 , happyReduce_257),
	(258 , happyReduce_258),
	(259 , happyReduce_259),
	(260 , happyReduce_260),
	(261 , happyReduce_261),
	(262 , happyReduce_262),
	(263 , happyReduce_263),
	(264 , happyReduce_264),
	(265 , happyReduce_265),
	(266 , happyReduce_266),
	(267 , happyReduce_267),
	(268 , happyReduce_268),
	(269 , happyReduce_269),
	(270 , happyReduce_270),
	(271 , happyReduce_271),
	(272 , happyReduce_272),
	(273 , happyReduce_273),
	(274 , happyReduce_274),
	(275 , happyReduce_275),
	(276 , happyReduce_276),
	(277 , happyReduce_277),
	(278 , happyReduce_278),
	(279 , happyReduce_279),
	(280 , happyReduce_280),
	(281 , happyReduce_281),
	(282 , happyReduce_282),
	(283 , happyReduce_283),
	(284 , happyReduce_284),
	(285 , happyReduce_285),
	(286 , happyReduce_286),
	(287 , happyReduce_287),
	(288 , happyReduce_288),
	(289 , happyReduce_289),
	(290 , happyReduce_290),
	(291 , happyReduce_291),
	(292 , happyReduce_292),
	(293 , happyReduce_293),
	(294 , happyReduce_294),
	(295 , happyReduce_295),
	(296 , happyReduce_296),
	(297 , happyReduce_297),
	(298 , happyReduce_298),
	(299 , happyReduce_299),
	(300 , happyReduce_300),
	(301 , happyReduce_301),
	(302 , happyReduce_302),
	(303 , happyReduce_303),
	(304 , happyReduce_304),
	(305 , happyReduce_305),
	(306 , happyReduce_306),
	(307 , happyReduce_307),
	(308 , happyReduce_308),
	(309 , happyReduce_309),
	(310 , happyReduce_310),
	(311 , happyReduce_311),
	(312 , happyReduce_312),
	(313 , happyReduce_313),
	(314 , happyReduce_314),
	(315 , happyReduce_315),
	(316 , happyReduce_316),
	(317 , happyReduce_317),
	(318 , happyReduce_318),
	(319 , happyReduce_319),
	(320 , happyReduce_320),
	(321 , happyReduce_321),
	(322 , happyReduce_322),
	(323 , happyReduce_323),
	(324 , happyReduce_324),
	(325 , happyReduce_325),
	(326 , happyReduce_326),
	(327 , happyReduce_327),
	(328 , happyReduce_328),
	(329 , happyReduce_329),
	(330 , happyReduce_330),
	(331 , happyReduce_331),
	(332 , happyReduce_332),
	(333 , happyReduce_333),
	(334 , happyReduce_334),
	(335 , happyReduce_335),
	(336 , happyReduce_336),
	(337 , happyReduce_337),
	(338 , happyReduce_338),
	(339 , happyReduce_339),
	(340 , happyReduce_340),
	(341 , happyReduce_341),
	(342 , happyReduce_342),
	(343 , happyReduce_343),
	(344 , happyReduce_344),
	(345 , happyReduce_345),
	(346 , happyReduce_346),
	(347 , happyReduce_347),
	(348 , happyReduce_348),
	(349 , happyReduce_349),
	(350 , happyReduce_350),
	(351 , happyReduce_351),
	(352 , happyReduce_352),
	(353 , happyReduce_353),
	(354 , happyReduce_354),
	(355 , happyReduce_355),
	(356 , happyReduce_356),
	(357 , happyReduce_357),
	(358 , happyReduce_358),
	(359 , happyReduce_359),
	(360 , happyReduce_360),
	(361 , happyReduce_361),
	(362 , happyReduce_362),
	(363 , happyReduce_363),
	(364 , happyReduce_364),
	(365 , happyReduce_365),
	(366 , happyReduce_366),
	(367 , happyReduce_367),
	(368 , happyReduce_368),
	(369 , happyReduce_369),
	(370 , happyReduce_370),
	(371 , happyReduce_371),
	(372 , happyReduce_372),
	(373 , happyReduce_373),
	(374 , happyReduce_374),
	(375 , happyReduce_375),
	(376 , happyReduce_376),
	(377 , happyReduce_377),
	(378 , happyReduce_378),
	(379 , happyReduce_379),
	(380 , happyReduce_380),
	(381 , happyReduce_381),
	(382 , happyReduce_382),
	(383 , happyReduce_383),
	(384 , happyReduce_384),
	(385 , happyReduce_385),
	(386 , happyReduce_386),
	(387 , happyReduce_387),
	(388 , happyReduce_388),
	(389 , happyReduce_389),
	(390 , happyReduce_390),
	(391 , happyReduce_391),
	(392 , happyReduce_392),
	(393 , happyReduce_393),
	(394 , happyReduce_394),
	(395 , happyReduce_395),
	(396 , happyReduce_396),
	(397 , happyReduce_397),
	(398 , happyReduce_398),
	(399 , happyReduce_399),
	(400 , happyReduce_400),
	(401 , happyReduce_401),
	(402 , happyReduce_402),
	(403 , happyReduce_403),
	(404 , happyReduce_404),
	(405 , happyReduce_405),
	(406 , happyReduce_406),
	(407 , happyReduce_407),
	(408 , happyReduce_408),
	(409 , happyReduce_409),
	(410 , happyReduce_410),
	(411 , happyReduce_411),
	(412 , happyReduce_412),
	(413 , happyReduce_413),
	(414 , happyReduce_414),
	(415 , happyReduce_415),
	(416 , happyReduce_416),
	(417 , happyReduce_417),
	(418 , happyReduce_418),
	(419 , happyReduce_419),
	(420 , happyReduce_420),
	(421 , happyReduce_421),
	(422 , happyReduce_422),
	(423 , happyReduce_423),
	(424 , happyReduce_424),
	(425 , happyReduce_425),
	(426 , happyReduce_426),
	(427 , happyReduce_427),
	(428 , happyReduce_428),
	(429 , happyReduce_429),
	(430 , happyReduce_430),
	(431 , happyReduce_431),
	(432 , happyReduce_432),
	(433 , happyReduce_433),
	(434 , happyReduce_434),
	(435 , happyReduce_435),
	(436 , happyReduce_436),
	(437 , happyReduce_437),
	(438 , happyReduce_438),
	(439 , happyReduce_439),
	(440 , happyReduce_440),
	(441 , happyReduce_441),
	(442 , happyReduce_442),
	(443 , happyReduce_443),
	(444 , happyReduce_444),
	(445 , happyReduce_445),
	(446 , happyReduce_446),
	(447 , happyReduce_447),
	(448 , happyReduce_448),
	(449 , happyReduce_449),
	(450 , happyReduce_450),
	(451 , happyReduce_451),
	(452 , happyReduce_452),
	(453 , happyReduce_453),
	(454 , happyReduce_454),
	(455 , happyReduce_455),
	(456 , happyReduce_456),
	(457 , happyReduce_457),
	(458 , happyReduce_458),
	(459 , happyReduce_459),
	(460 , happyReduce_460),
	(461 , happyReduce_461),
	(462 , happyReduce_462),
	(463 , happyReduce_463),
	(464 , happyReduce_464),
	(465 , happyReduce_465),
	(466 , happyReduce_466),
	(467 , happyReduce_467),
	(468 , happyReduce_468),
	(469 , happyReduce_469),
	(470 , happyReduce_470),
	(471 , happyReduce_471),
	(472 , happyReduce_472),
	(473 , happyReduce_473),
	(474 , happyReduce_474),
	(475 , happyReduce_475),
	(476 , happyReduce_476),
	(477 , happyReduce_477),
	(478 , happyReduce_478),
	(479 , happyReduce_479),
	(480 , happyReduce_480),
	(481 , happyReduce_481),
	(482 , happyReduce_482),
	(483 , happyReduce_483),
	(484 , happyReduce_484),
	(485 , happyReduce_485),
	(486 , happyReduce_486),
	(487 , happyReduce_487),
	(488 , happyReduce_488),
	(489 , happyReduce_489),
	(490 , happyReduce_490),
	(491 , happyReduce_491),
	(492 , happyReduce_492),
	(493 , happyReduce_493),
	(494 , happyReduce_494),
	(495 , happyReduce_495),
	(496 , happyReduce_496),
	(497 , happyReduce_497),
	(498 , happyReduce_498),
	(499 , happyReduce_499),
	(500 , happyReduce_500),
	(501 , happyReduce_501),
	(502 , happyReduce_502),
	(503 , happyReduce_503),
	(504 , happyReduce_504),
	(505 , happyReduce_505),
	(506 , happyReduce_506),
	(507 , happyReduce_507),
	(508 , happyReduce_508),
	(509 , happyReduce_509),
	(510 , happyReduce_510),
	(511 , happyReduce_511),
	(512 , happyReduce_512),
	(513 , happyReduce_513),
	(514 , happyReduce_514),
	(515 , happyReduce_515),
	(516 , happyReduce_516),
	(517 , happyReduce_517),
	(518 , happyReduce_518),
	(519 , happyReduce_519),
	(520 , happyReduce_520),
	(521 , happyReduce_521),
	(522 , happyReduce_522),
	(523 , happyReduce_523),
	(524 , happyReduce_524),
	(525 , happyReduce_525),
	(526 , happyReduce_526),
	(527 , happyReduce_527),
	(528 , happyReduce_528),
	(529 , happyReduce_529),
	(530 , happyReduce_530)
	]

happy_n_terms = 156 :: Int
happy_n_nonterms = 150 :: Int

happyReduce_105 = happySpecReduce_2  0# happyReduction_105
happyReduction_105 happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_1 of { happy_var_1 -> 
	case happyOut110 happy_x_2 of { happy_var_2 -> 
	happyIn108
		 (Type happy_var_1 happy_var_2
	)}}

happyReduce_106 = happySpecReduce_0  1# happyReduction_106
happyReduction_106  =  happyIn109
		 (NoType
	)

happyReduce_107 = happySpecReduce_1  1# happyReduction_107
happyReduction_107 happy_x_1
	 =  case happyOut108 happy_x_1 of { happy_var_1 -> 
	happyIn109
		 (JustType happy_var_1
	)}

happyReduce_108 = happySpecReduce_0  2# happyReduction_108
happyReduction_108  =  happyIn110
		 (NoTypeSize
	)

happyReduce_109 = happySpecReduce_3  2# happyReduction_109
happyReduction_109 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut111 happy_x_2 of { happy_var_2 -> 
	happyIn110
		 (TypeMaximumSize happy_var_2
	)}

happyReduce_110 = happyReduce 5# 2# happyReduction_110
happyReduction_110 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut111 happy_x_2 of { happy_var_2 -> 
	case happyOut111 happy_x_4 of { happy_var_4 -> 
	happyIn110
		 (TypeSize happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_111 = happySpecReduce_2  3# happyReduction_111
happyReduction_111 happy_x_2
	happy_x_1
	 =  case happyOut150 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { (LiteralFloat happy_var_2) -> 
	happyIn111
		 (DoubleSize happy_var_1 happy_var_2
	)}}

happyReduce_112 = happySpecReduce_2  3# happyReduction_112
happyReduction_112 happy_x_2
	happy_x_1
	 =  case happyOut150 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { (LiteralInteger happy_var_2) -> 
	happyIn111
		 (IntegerSize happy_var_1 happy_var_2
	)}}

happyReduce_113 = happySpecReduce_1  4# happyReduction_113
happyReduction_113 happy_x_1
	 =  happyIn112
		 (Like
	)

happyReduce_114 = happySpecReduce_2  4# happyReduction_114
happyReduction_114 happy_x_2
	happy_x_1
	 =  happyIn112
		 (NotLike
	)

happyReduce_115 = happySpecReduce_1  4# happyReduction_115
happyReduction_115 happy_x_1
	 =  happyIn112
		 (Glob
	)

happyReduce_116 = happySpecReduce_2  4# happyReduction_116
happyReduction_116 happy_x_2
	happy_x_1
	 =  happyIn112
		 (NotGlob
	)

happyReduce_117 = happySpecReduce_1  4# happyReduction_117
happyReduction_117 happy_x_1
	 =  happyIn112
		 (Regexp
	)

happyReduce_118 = happySpecReduce_2  4# happyReduction_118
happyReduction_118 happy_x_2
	happy_x_1
	 =  happyIn112
		 (NotRegexp
	)

happyReduce_119 = happySpecReduce_1  4# happyReduction_119
happyReduction_119 happy_x_1
	 =  happyIn112
		 (Match
	)

happyReduce_120 = happySpecReduce_2  4# happyReduction_120
happyReduction_120 happy_x_2
	happy_x_1
	 =  happyIn112
		 (NotMatch
	)

happyReduce_121 = happySpecReduce_0  5# happyReduction_121
happyReduction_121  =  happyIn113
		 (NoEscape
	)

happyReduce_122 = happySpecReduce_2  5# happyReduction_122
happyReduction_122 happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_2 of { happy_var_2 -> 
	happyIn113
		 (Escape happy_var_2
	)}

happyReduce_123 = happySpecReduce_1  6# happyReduction_123
happyReduction_123 happy_x_1
	 =  case happyOutTok happy_x_1 of { (LiteralInteger happy_var_1) -> 
	happyIn114
		 (ExpressionLiteralInteger happy_var_1
	)}

happyReduce_124 = happySpecReduce_1  6# happyReduction_124
happyReduction_124 happy_x_1
	 =  case happyOutTok happy_x_1 of { (LiteralFloat happy_var_1) -> 
	happyIn114
		 (ExpressionLiteralFloat happy_var_1
	)}

happyReduce_125 = happySpecReduce_1  6# happyReduction_125
happyReduction_125 happy_x_1
	 =  case happyOutTok happy_x_1 of { (LiteralString happy_var_1) -> 
	happyIn114
		 (ExpressionLiteralString happy_var_1
	)}

happyReduce_126 = happySpecReduce_1  6# happyReduction_126
happyReduction_126 happy_x_1
	 =  case happyOutTok happy_x_1 of { (LiteralBlob happy_var_1) -> 
	happyIn114
		 (ExpressionLiteralBlob happy_var_1
	)}

happyReduce_127 = happySpecReduce_1  6# happyReduction_127
happyReduction_127 happy_x_1
	 =  happyIn114
		 (ExpressionLiteralNull
	)

happyReduce_128 = happySpecReduce_1  6# happyReduction_128
happyReduction_128 happy_x_1
	 =  happyIn114
		 (ExpressionLiteralCurrentTime
	)

happyReduce_129 = happySpecReduce_1  6# happyReduction_129
happyReduction_129 happy_x_1
	 =  happyIn114
		 (ExpressionLiteralCurrentDate
	)

happyReduce_130 = happySpecReduce_1  6# happyReduction_130
happyReduction_130 happy_x_1
	 =  happyIn114
		 (ExpressionLiteralCurrentTimestamp
	)

happyReduce_131 = happySpecReduce_1  6# happyReduction_131
happyReduction_131 happy_x_1
	 =  happyIn114
		 (ExpressionVariable
	)

happyReduce_132 = happySpecReduce_1  6# happyReduction_132
happyReduction_132 happy_x_1
	 =  case happyOutTok happy_x_1 of { (VariableN happy_var_1) -> 
	happyIn114
		 (ExpressionVariableN happy_var_1
	)}

happyReduce_133 = happySpecReduce_1  6# happyReduction_133
happyReduction_133 happy_x_1
	 =  case happyOutTok happy_x_1 of { (VariableNamed happy_var_1) -> 
	happyIn114
		 (ExpressionVariableNamed happy_var_1
	)}

happyReduce_134 = happySpecReduce_1  6# happyReduction_134
happyReduction_134 happy_x_1
	 =  case happyOut257 happy_x_1 of { happy_var_1 -> 
	happyIn114
		 (ExpressionIdentifier happy_var_1
	)}

happyReduce_135 = happyReduce 4# 6# happyReduction_135
happyReduction_135 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut254 happy_x_1 of { happy_var_1 -> 
	case happyOut135 happy_x_3 of { happy_var_3 -> 
	happyIn114
		 (ExpressionFunctionCall happy_var_1 happy_var_3
	) `HappyStk` happyRest}}

happyReduce_136 = happyReduce 5# 6# happyReduction_136
happyReduction_136 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut254 happy_x_1 of { happy_var_1 -> 
	case happyOut136 happy_x_4 of { happy_var_4 -> 
	happyIn114
		 (ExpressionFunctionCallDistinct happy_var_1 (fromJust $ mkOneOrMore happy_var_4)
	) `HappyStk` happyRest}}

happyReduce_137 = happyReduce 4# 6# happyReduction_137
happyReduction_137 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut254 happy_x_1 of { happy_var_1 -> 
	happyIn114
		 (ExpressionFunctionCallStar happy_var_1
	) `HappyStk` happyRest}

happyReduce_138 = happyReduce 4# 6# happyReduction_138
happyReduction_138 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = happyIn114
		 (ExpressionRaiseIgnore
	) `HappyStk` happyRest

happyReduce_139 = happyReduce 6# 6# happyReduction_139
happyReduction_139 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_5 of { (LiteralString happy_var_5) -> 
	happyIn114
		 (ExpressionRaiseRollback happy_var_5
	) `HappyStk` happyRest}

happyReduce_140 = happyReduce 6# 6# happyReduction_140
happyReduction_140 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_5 of { (LiteralString happy_var_5) -> 
	happyIn114
		 (ExpressionRaiseAbort happy_var_5
	) `HappyStk` happyRest}

happyReduce_141 = happyReduce 6# 6# happyReduction_141
happyReduction_141 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_5 of { (LiteralString happy_var_5) -> 
	happyIn114
		 (ExpressionRaiseFail happy_var_5
	) `HappyStk` happyRest}

happyReduce_142 = happySpecReduce_3  6# happyReduction_142
happyReduction_142 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_2 of { happy_var_2 -> 
	happyIn114
		 (ExpressionParenthesized happy_var_2
	)}

happyReduce_143 = happySpecReduce_1  7# happyReduction_143
happyReduction_143 happy_x_1
	 =  case happyOut114 happy_x_1 of { happy_var_1 -> 
	happyIn115
		 (happy_var_1
	)}

happyReduce_144 = happyReduce 6# 7# happyReduction_144
happyReduction_144 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut134 happy_x_3 of { happy_var_3 -> 
	case happyOut108 happy_x_5 of { happy_var_5 -> 
	happyIn115
		 (ExpressionCast happy_var_3 happy_var_5
	) `HappyStk` happyRest}}

happyReduce_145 = happySpecReduce_1  8# happyReduction_145
happyReduction_145 happy_x_1
	 =  case happyOut115 happy_x_1 of { happy_var_1 -> 
	happyIn116
		 (happy_var_1
	)}

happyReduce_146 = happySpecReduce_3  8# happyReduction_146
happyReduction_146 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut116 happy_x_1 of { happy_var_1 -> 
	case happyOut254 happy_x_3 of { happy_var_3 -> 
	happyIn116
		 (ExpressionCollate happy_var_1 happy_var_3
	)}}

happyReduce_147 = happySpecReduce_1  9# happyReduction_147
happyReduction_147 happy_x_1
	 =  case happyOut116 happy_x_1 of { happy_var_1 -> 
	happyIn117
		 (happy_var_1
	)}

happyReduce_148 = happyReduce 5# 9# happyReduction_148
happyReduction_148 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut138 happy_x_2 of { happy_var_2 -> 
	case happyOut139 happy_x_3 of { happy_var_3 -> 
	case happyOut141 happy_x_4 of { happy_var_4 -> 
	happyIn117
		 (ExpressionCase happy_var_2 (fromJust $ mkOneOrMore happy_var_3) happy_var_4
	) `HappyStk` happyRest}}}

happyReduce_149 = happySpecReduce_1  10# happyReduction_149
happyReduction_149 happy_x_1
	 =  case happyOut117 happy_x_1 of { happy_var_1 -> 
	happyIn118
		 (happy_var_1
	)}

happyReduce_150 = happyReduce 4# 10# happyReduction_150
happyReduction_150 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut249 happy_x_3 of { happy_var_3 -> 
	happyIn118
		 (ExpressionExistsSubquery happy_var_3
	) `HappyStk` happyRest}

happyReduce_151 = happySpecReduce_1  11# happyReduction_151
happyReduction_151 happy_x_1
	 =  case happyOut118 happy_x_1 of { happy_var_1 -> 
	happyIn119
		 (happy_var_1
	)}

happyReduce_152 = happyReduce 5# 11# happyReduction_152
happyReduction_152 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut119 happy_x_1 of { happy_var_1 -> 
	case happyOut249 happy_x_4 of { happy_var_4 -> 
	happyIn119
		 (ExpressionInSelect happy_var_1 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_153 = happyReduce 6# 11# happyReduction_153
happyReduction_153 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut119 happy_x_1 of { happy_var_1 -> 
	case happyOut249 happy_x_5 of { happy_var_5 -> 
	happyIn119
		 (ExpressionNotInSelect happy_var_1 happy_var_5
	) `HappyStk` happyRest}}

happyReduce_154 = happySpecReduce_3  11# happyReduction_154
happyReduction_154 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut119 happy_x_1 of { happy_var_1 -> 
	case happyOut256 happy_x_3 of { happy_var_3 -> 
	happyIn119
		 (ExpressionInTable happy_var_1 happy_var_3
	)}}

happyReduce_155 = happyReduce 4# 11# happyReduction_155
happyReduction_155 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut119 happy_x_1 of { happy_var_1 -> 
	case happyOut256 happy_x_4 of { happy_var_4 -> 
	happyIn119
		 (ExpressionNotInTable happy_var_1 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_156 = happySpecReduce_1  12# happyReduction_156
happyReduction_156 happy_x_1
	 =  case happyOut119 happy_x_1 of { happy_var_1 -> 
	happyIn120
		 (happy_var_1
	)}

happyReduce_157 = happySpecReduce_3  12# happyReduction_157
happyReduction_157 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut249 happy_x_2 of { happy_var_2 -> 
	happyIn120
		 (ExpressionSubquery happy_var_2
	)}

happyReduce_158 = happySpecReduce_1  13# happyReduction_158
happyReduction_158 happy_x_1
	 =  case happyOut120 happy_x_1 of { happy_var_1 -> 
	happyIn121
		 (happy_var_1
	)}

happyReduce_159 = happyReduce 5# 13# happyReduction_159
happyReduction_159 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut121 happy_x_1 of { happy_var_1 -> 
	case happyOut131 happy_x_3 of { happy_var_3 -> 
	case happyOut120 happy_x_5 of { happy_var_5 -> 
	happyIn121
		 (ExpressionBetween happy_var_1 happy_var_3 happy_var_5
	) `HappyStk` happyRest}}}

happyReduce_160 = happyReduce 6# 13# happyReduction_160
happyReduction_160 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut121 happy_x_1 of { happy_var_1 -> 
	case happyOut131 happy_x_4 of { happy_var_4 -> 
	case happyOut120 happy_x_6 of { happy_var_6 -> 
	happyIn121
		 (ExpressionNotBetween happy_var_1 happy_var_4 happy_var_6
	) `HappyStk` happyRest}}}

happyReduce_161 = happySpecReduce_1  14# happyReduction_161
happyReduction_161 happy_x_1
	 =  case happyOut121 happy_x_1 of { happy_var_1 -> 
	happyIn122
		 (happy_var_1
	)}

happyReduce_162 = happySpecReduce_2  14# happyReduction_162
happyReduction_162 happy_x_2
	happy_x_1
	 =  case happyOut122 happy_x_2 of { happy_var_2 -> 
	happyIn122
		 (ExpressionUnaryNegative happy_var_2
	)}

happyReduce_163 = happySpecReduce_2  14# happyReduction_163
happyReduction_163 happy_x_2
	happy_x_1
	 =  case happyOut122 happy_x_2 of { happy_var_2 -> 
	happyIn122
		 (ExpressionUnaryPositive happy_var_2
	)}

happyReduce_164 = happySpecReduce_2  14# happyReduction_164
happyReduction_164 happy_x_2
	happy_x_1
	 =  case happyOut122 happy_x_2 of { happy_var_2 -> 
	happyIn122
		 (ExpressionUnaryBitwiseNot happy_var_2
	)}

happyReduce_165 = happySpecReduce_2  14# happyReduction_165
happyReduction_165 happy_x_2
	happy_x_1
	 =  case happyOut122 happy_x_2 of { happy_var_2 -> 
	happyIn122
		 (case happy_var_2 of
        ExpressionExistsSubquery subquery -> ExpressionNotExistsSubquery subquery
        subexpression -> ExpressionUnaryLogicalNot subexpression
	)}

happyReduce_166 = happySpecReduce_1  15# happyReduction_166
happyReduction_166 happy_x_1
	 =  case happyOut122 happy_x_1 of { happy_var_1 -> 
	happyIn123
		 (happy_var_1
	)}

happyReduce_167 = happySpecReduce_3  15# happyReduction_167
happyReduction_167 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut123 happy_x_1 of { happy_var_1 -> 
	case happyOut122 happy_x_3 of { happy_var_3 -> 
	happyIn123
		 (case happy_var_3 of
        ExpressionUnaryLogicalNot subexpression -> ExpressionIsNot happy_var_1 subexpression
        _ -> ExpressionIs happy_var_1 happy_var_3
	)}}

happyReduce_168 = happySpecReduce_1  16# happyReduction_168
happyReduction_168 happy_x_1
	 =  case happyOut123 happy_x_1 of { happy_var_1 -> 
	happyIn124
		 (happy_var_1
	)}

happyReduce_169 = happySpecReduce_2  16# happyReduction_169
happyReduction_169 happy_x_2
	happy_x_1
	 =  case happyOut124 happy_x_1 of { happy_var_1 -> 
	happyIn124
		 (ExpressionIsnull happy_var_1
	)}

happyReduce_170 = happySpecReduce_2  16# happyReduction_170
happyReduction_170 happy_x_2
	happy_x_1
	 =  case happyOut124 happy_x_1 of { happy_var_1 -> 
	happyIn124
		 (ExpressionNotnull happy_var_1
	)}

happyReduce_171 = happySpecReduce_3  16# happyReduction_171
happyReduction_171 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut124 happy_x_1 of { happy_var_1 -> 
	happyIn124
		 (ExpressionNotNull happy_var_1
	)}

happyReduce_172 = happySpecReduce_1  17# happyReduction_172
happyReduction_172 happy_x_1
	 =  case happyOut124 happy_x_1 of { happy_var_1 -> 
	happyIn125
		 (happy_var_1
	)}

happyReduce_173 = happyReduce 4# 17# happyReduction_173
happyReduction_173 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut125 happy_x_1 of { happy_var_1 -> 
	case happyOut112 happy_x_2 of { happy_var_2 -> 
	case happyOut124 happy_x_3 of { happy_var_3 -> 
	case happyOut113 happy_x_4 of { happy_var_4 -> 
	happyIn125
		 (ExpressionLike happy_var_1 happy_var_2 happy_var_3 happy_var_4
	) `HappyStk` happyRest}}}}

happyReduce_174 = happySpecReduce_1  18# happyReduction_174
happyReduction_174 happy_x_1
	 =  case happyOut125 happy_x_1 of { happy_var_1 -> 
	happyIn126
		 (happy_var_1
	)}

happyReduce_175 = happySpecReduce_3  18# happyReduction_175
happyReduction_175 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut126 happy_x_1 of { happy_var_1 -> 
	case happyOut125 happy_x_3 of { happy_var_3 -> 
	happyIn126
		 (ExpressionBinaryConcatenate happy_var_1 happy_var_3
	)}}

happyReduce_176 = happySpecReduce_1  19# happyReduction_176
happyReduction_176 happy_x_1
	 =  case happyOut126 happy_x_1 of { happy_var_1 -> 
	happyIn127
		 (happy_var_1
	)}

happyReduce_177 = happySpecReduce_3  19# happyReduction_177
happyReduction_177 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut127 happy_x_1 of { happy_var_1 -> 
	case happyOut126 happy_x_3 of { happy_var_3 -> 
	happyIn127
		 (ExpressionBinaryMultiply happy_var_1 happy_var_3
	)}}

happyReduce_178 = happySpecReduce_3  19# happyReduction_178
happyReduction_178 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut127 happy_x_1 of { happy_var_1 -> 
	case happyOut126 happy_x_3 of { happy_var_3 -> 
	happyIn127
		 (ExpressionBinaryDivide happy_var_1 happy_var_3
	)}}

happyReduce_179 = happySpecReduce_3  19# happyReduction_179
happyReduction_179 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut127 happy_x_1 of { happy_var_1 -> 
	case happyOut126 happy_x_3 of { happy_var_3 -> 
	happyIn127
		 (ExpressionBinaryModulus happy_var_1 happy_var_3
	)}}

happyReduce_180 = happySpecReduce_1  20# happyReduction_180
happyReduction_180 happy_x_1
	 =  case happyOut127 happy_x_1 of { happy_var_1 -> 
	happyIn128
		 (happy_var_1
	)}

happyReduce_181 = happySpecReduce_3  20# happyReduction_181
happyReduction_181 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut128 happy_x_1 of { happy_var_1 -> 
	case happyOut127 happy_x_3 of { happy_var_3 -> 
	happyIn128
		 (ExpressionBinaryAdd happy_var_1 happy_var_3
	)}}

happyReduce_182 = happySpecReduce_3  20# happyReduction_182
happyReduction_182 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut128 happy_x_1 of { happy_var_1 -> 
	case happyOut127 happy_x_3 of { happy_var_3 -> 
	happyIn128
		 (ExpressionBinarySubtract happy_var_1 happy_var_3
	)}}

happyReduce_183 = happySpecReduce_1  21# happyReduction_183
happyReduction_183 happy_x_1
	 =  case happyOut128 happy_x_1 of { happy_var_1 -> 
	happyIn129
		 (happy_var_1
	)}

happyReduce_184 = happySpecReduce_3  21# happyReduction_184
happyReduction_184 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut129 happy_x_1 of { happy_var_1 -> 
	case happyOut128 happy_x_3 of { happy_var_3 -> 
	happyIn129
		 (ExpressionBinaryLeftShift happy_var_1 happy_var_3
	)}}

happyReduce_185 = happySpecReduce_3  21# happyReduction_185
happyReduction_185 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut129 happy_x_1 of { happy_var_1 -> 
	case happyOut128 happy_x_3 of { happy_var_3 -> 
	happyIn129
		 (ExpressionBinaryRightShift happy_var_1 happy_var_3
	)}}

happyReduce_186 = happySpecReduce_3  21# happyReduction_186
happyReduction_186 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut129 happy_x_1 of { happy_var_1 -> 
	case happyOut128 happy_x_3 of { happy_var_3 -> 
	happyIn129
		 (ExpressionBinaryBitwiseAnd happy_var_1 happy_var_3
	)}}

happyReduce_187 = happySpecReduce_3  21# happyReduction_187
happyReduction_187 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut129 happy_x_1 of { happy_var_1 -> 
	case happyOut128 happy_x_3 of { happy_var_3 -> 
	happyIn129
		 (ExpressionBinaryBitwiseOr happy_var_1 happy_var_3
	)}}

happyReduce_188 = happySpecReduce_1  22# happyReduction_188
happyReduction_188 happy_x_1
	 =  case happyOut129 happy_x_1 of { happy_var_1 -> 
	happyIn130
		 (happy_var_1
	)}

happyReduce_189 = happySpecReduce_3  22# happyReduction_189
happyReduction_189 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut130 happy_x_1 of { happy_var_1 -> 
	case happyOut129 happy_x_3 of { happy_var_3 -> 
	happyIn130
		 (ExpressionBinaryLess happy_var_1 happy_var_3
	)}}

happyReduce_190 = happySpecReduce_3  22# happyReduction_190
happyReduction_190 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut130 happy_x_1 of { happy_var_1 -> 
	case happyOut129 happy_x_3 of { happy_var_3 -> 
	happyIn130
		 (ExpressionBinaryLessEquals happy_var_1 happy_var_3
	)}}

happyReduce_191 = happySpecReduce_3  22# happyReduction_191
happyReduction_191 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut130 happy_x_1 of { happy_var_1 -> 
	case happyOut129 happy_x_3 of { happy_var_3 -> 
	happyIn130
		 (ExpressionBinaryGreater happy_var_1 happy_var_3
	)}}

happyReduce_192 = happySpecReduce_3  22# happyReduction_192
happyReduction_192 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut130 happy_x_1 of { happy_var_1 -> 
	case happyOut129 happy_x_3 of { happy_var_3 -> 
	happyIn130
		 (ExpressionBinaryGreaterEquals happy_var_1 happy_var_3
	)}}

happyReduce_193 = happySpecReduce_1  23# happyReduction_193
happyReduction_193 happy_x_1
	 =  case happyOut130 happy_x_1 of { happy_var_1 -> 
	happyIn131
		 (happy_var_1
	)}

happyReduce_194 = happySpecReduce_3  23# happyReduction_194
happyReduction_194 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut131 happy_x_1 of { happy_var_1 -> 
	case happyOut130 happy_x_3 of { happy_var_3 -> 
	happyIn131
		 (ExpressionBinaryEquals happy_var_1 happy_var_3
	)}}

happyReduce_195 = happySpecReduce_3  23# happyReduction_195
happyReduction_195 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut131 happy_x_1 of { happy_var_1 -> 
	case happyOut130 happy_x_3 of { happy_var_3 -> 
	happyIn131
		 (ExpressionBinaryEqualsEquals happy_var_1 happy_var_3
	)}}

happyReduce_196 = happySpecReduce_3  23# happyReduction_196
happyReduction_196 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut131 happy_x_1 of { happy_var_1 -> 
	case happyOut130 happy_x_3 of { happy_var_3 -> 
	happyIn131
		 (ExpressionBinaryNotEquals happy_var_1 happy_var_3
	)}}

happyReduce_197 = happySpecReduce_3  23# happyReduction_197
happyReduction_197 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut131 happy_x_1 of { happy_var_1 -> 
	case happyOut130 happy_x_3 of { happy_var_3 -> 
	happyIn131
		 (ExpressionBinaryLessGreater happy_var_1 happy_var_3
	)}}

happyReduce_198 = happyReduce 5# 23# happyReduction_198
happyReduction_198 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut131 happy_x_1 of { happy_var_1 -> 
	case happyOut135 happy_x_4 of { happy_var_4 -> 
	happyIn131
		 (ExpressionInList happy_var_1 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_199 = happyReduce 6# 23# happyReduction_199
happyReduction_199 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut131 happy_x_1 of { happy_var_1 -> 
	case happyOut135 happy_x_5 of { happy_var_5 -> 
	happyIn131
		 (ExpressionNotInList happy_var_1 happy_var_5
	) `HappyStk` happyRest}}

happyReduce_200 = happySpecReduce_1  24# happyReduction_200
happyReduction_200 happy_x_1
	 =  case happyOut131 happy_x_1 of { happy_var_1 -> 
	happyIn132
		 (happy_var_1
	)}

happyReduce_201 = happySpecReduce_3  24# happyReduction_201
happyReduction_201 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut132 happy_x_1 of { happy_var_1 -> 
	case happyOut131 happy_x_3 of { happy_var_3 -> 
	happyIn132
		 (ExpressionBinaryLogicalAnd happy_var_1 happy_var_3
	)}}

happyReduce_202 = happySpecReduce_1  25# happyReduction_202
happyReduction_202 happy_x_1
	 =  case happyOut132 happy_x_1 of { happy_var_1 -> 
	happyIn133
		 (happy_var_1
	)}

happyReduce_203 = happySpecReduce_3  25# happyReduction_203
happyReduction_203 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut133 happy_x_1 of { happy_var_1 -> 
	case happyOut132 happy_x_3 of { happy_var_3 -> 
	happyIn133
		 (ExpressionBinaryLogicalOr happy_var_1 happy_var_3
	)}}

happyReduce_204 = happySpecReduce_1  26# happyReduction_204
happyReduction_204 happy_x_1
	 =  case happyOut133 happy_x_1 of { happy_var_1 -> 
	happyIn134
		 (happy_var_1
	)}

happyReduce_205 = happySpecReduce_0  27# happyReduction_205
happyReduction_205  =  happyIn135
		 ([]
	)

happyReduce_206 = happySpecReduce_2  27# happyReduction_206
happyReduction_206 happy_x_2
	happy_x_1
	 =  case happyOut135 happy_x_1 of { happy_var_1 -> 
	case happyOut134 happy_x_2 of { happy_var_2 -> 
	happyIn135
		 (happy_var_1 ++ [happy_var_2]
	)}}

happyReduce_207 = happySpecReduce_1  28# happyReduction_207
happyReduction_207 happy_x_1
	 =  case happyOut134 happy_x_1 of { happy_var_1 -> 
	happyIn136
		 ([happy_var_1]
	)}

happyReduce_208 = happySpecReduce_3  28# happyReduction_208
happyReduction_208 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut136 happy_x_1 of { happy_var_1 -> 
	case happyOut134 happy_x_3 of { happy_var_3 -> 
	happyIn136
		 (happy_var_1 ++ [happy_var_3]
	)}}

happyReduce_209 = happySpecReduce_3  29# happyReduction_209
happyReduction_209 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_1 of { happy_var_1 -> 
	case happyOut134 happy_x_3 of { happy_var_3 -> 
	happyIn137
		 ([(happy_var_1, happy_var_3)]
	)}}

happyReduce_210 = happyReduce 5# 29# happyReduction_210
happyReduction_210 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut137 happy_x_1 of { happy_var_1 -> 
	case happyOut254 happy_x_3 of { happy_var_3 -> 
	case happyOut134 happy_x_5 of { happy_var_5 -> 
	happyIn137
		 (happy_var_1 ++ [(happy_var_3, happy_var_5)]
	) `HappyStk` happyRest}}}

happyReduce_211 = happySpecReduce_0  30# happyReduction_211
happyReduction_211  =  happyIn138
		 (NoSwitch
	)

happyReduce_212 = happySpecReduce_1  30# happyReduction_212
happyReduction_212 happy_x_1
	 =  case happyOut134 happy_x_1 of { happy_var_1 -> 
	happyIn138
		 (Switch happy_var_1
	)}

happyReduce_213 = happySpecReduce_1  31# happyReduction_213
happyReduction_213 happy_x_1
	 =  case happyOut140 happy_x_1 of { happy_var_1 -> 
	happyIn139
		 ([happy_var_1]
	)}

happyReduce_214 = happySpecReduce_2  31# happyReduction_214
happyReduction_214 happy_x_2
	happy_x_1
	 =  case happyOut139 happy_x_1 of { happy_var_1 -> 
	case happyOut140 happy_x_2 of { happy_var_2 -> 
	happyIn139
		 (happy_var_1 ++ [happy_var_2]
	)}}

happyReduce_215 = happyReduce 4# 32# happyReduction_215
happyReduction_215 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut134 happy_x_2 of { happy_var_2 -> 
	case happyOut134 happy_x_4 of { happy_var_4 -> 
	happyIn140
		 (WhenThen happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_216 = happySpecReduce_0  33# happyReduction_216
happyReduction_216  =  happyIn141
		 (NoElse
	)

happyReduce_217 = happySpecReduce_2  33# happyReduction_217
happyReduction_217 happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_2 of { happy_var_2 -> 
	happyIn141
		 (Else happy_var_2
	)}

happyReduce_218 = happySpecReduce_0  34# happyReduction_218
happyReduction_218  =  happyIn142
		 (NoUnique
	)

happyReduce_219 = happySpecReduce_1  34# happyReduction_219
happyReduction_219 happy_x_1
	 =  happyIn142
		 (Unique
	)

happyReduce_220 = happySpecReduce_0  35# happyReduction_220
happyReduction_220  =  happyIn143
		 (NoIfNotExists
	)

happyReduce_221 = happySpecReduce_3  35# happyReduction_221
happyReduction_221 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn143
		 (IfNotExists
	)

happyReduce_222 = happySpecReduce_0  36# happyReduction_222
happyReduction_222  =  happyIn144
		 (NoIfExists
	)

happyReduce_223 = happySpecReduce_2  36# happyReduction_223
happyReduction_223 happy_x_2
	happy_x_1
	 =  happyIn144
		 (IfExists
	)

happyReduce_224 = happySpecReduce_0  37# happyReduction_224
happyReduction_224  =  happyIn145
		 (NoForEachRow
	)

happyReduce_225 = happySpecReduce_3  37# happyReduction_225
happyReduction_225 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn145
		 (ForEachRow
	)

happyReduce_226 = happySpecReduce_0  38# happyReduction_226
happyReduction_226  =  happyIn146
		 (NoTemporary
	)

happyReduce_227 = happySpecReduce_1  38# happyReduction_227
happyReduction_227 happy_x_1
	 =  happyIn146
		 (Temp
	)

happyReduce_228 = happySpecReduce_1  38# happyReduction_228
happyReduction_228 happy_x_1
	 =  happyIn146
		 (Temporary
	)

happyReduce_229 = happySpecReduce_0  39# happyReduction_229
happyReduction_229  =  happyIn147
		 (NoCollation
	)

happyReduce_230 = happySpecReduce_2  39# happyReduction_230
happyReduction_230 happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_2 of { happy_var_2 -> 
	happyIn147
		 (Collation happy_var_2
	)}

happyReduce_231 = happySpecReduce_0  40# happyReduction_231
happyReduction_231  =  happyIn148
		 (NoAscDesc
	)

happyReduce_232 = happySpecReduce_1  40# happyReduction_232
happyReduction_232 happy_x_1
	 =  happyIn148
		 (Asc
	)

happyReduce_233 = happySpecReduce_1  40# happyReduction_233
happyReduction_233 happy_x_1
	 =  happyIn148
		 (Desc
	)

happyReduce_234 = happySpecReduce_0  41# happyReduction_234
happyReduction_234  =  happyIn149
		 (NoAutoincrement
	)

happyReduce_235 = happySpecReduce_1  41# happyReduction_235
happyReduction_235 happy_x_1
	 =  happyIn149
		 (Autoincrement
	)

happyReduce_236 = happySpecReduce_0  42# happyReduction_236
happyReduction_236  =  happyIn150
		 (NoSign
	)

happyReduce_237 = happySpecReduce_1  42# happyReduction_237
happyReduction_237 happy_x_1
	 =  happyIn150
		 (PositiveSign
	)

happyReduce_238 = happySpecReduce_1  42# happyReduction_238
happyReduction_238 happy_x_1
	 =  happyIn150
		 (NegativeSign
	)

happyReduce_239 = happySpecReduce_0  43# happyReduction_239
happyReduction_239  =  happyIn151
		 (ElidedColumn
	)

happyReduce_240 = happySpecReduce_1  43# happyReduction_240
happyReduction_240 happy_x_1
	 =  happyIn151
		 (Column
	)

happyReduce_241 = happySpecReduce_3  44# happyReduction_241
happyReduction_241 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_3 of { happy_var_3 -> 
	happyIn152
		 (RenameTo happy_var_3
	)}

happyReduce_242 = happySpecReduce_3  44# happyReduction_242
happyReduction_242 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut151 happy_x_2 of { happy_var_2 -> 
	case happyOut153 happy_x_3 of { happy_var_3 -> 
	happyIn152
		 (AddColumn happy_var_2 happy_var_3
	)}}

happyReduce_243 = happySpecReduce_3  45# happyReduction_243
happyReduction_243 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_1 of { happy_var_1 -> 
	case happyOut109 happy_x_2 of { happy_var_2 -> 
	case happyOut160 happy_x_3 of { happy_var_3 -> 
	happyIn153
		 (ColumnDefinition happy_var_1 happy_var_2 happy_var_3
	)}}}

happyReduce_244 = happySpecReduce_1  46# happyReduction_244
happyReduction_244 happy_x_1
	 =  case happyOut153 happy_x_1 of { happy_var_1 -> 
	happyIn154
		 ([happy_var_1]
	)}

happyReduce_245 = happySpecReduce_3  46# happyReduction_245
happyReduction_245 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut154 happy_x_1 of { happy_var_1 -> 
	case happyOut153 happy_x_3 of { happy_var_3 -> 
	happyIn154
		 (happy_var_1 ++ [happy_var_3]
	)}}

happyReduce_246 = happySpecReduce_2  47# happyReduction_246
happyReduction_246 happy_x_2
	happy_x_1
	 =  case happyOut150 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { (LiteralInteger happy_var_2) -> 
	happyIn155
		 (DefaultValueSignedInteger happy_var_1 happy_var_2
	)}}

happyReduce_247 = happySpecReduce_2  47# happyReduction_247
happyReduction_247 happy_x_2
	happy_x_1
	 =  case happyOut150 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { (LiteralFloat happy_var_2) -> 
	happyIn155
		 (DefaultValueSignedFloat happy_var_1 happy_var_2
	)}}

happyReduce_248 = happySpecReduce_1  47# happyReduction_248
happyReduction_248 happy_x_1
	 =  case happyOutTok happy_x_1 of { (LiteralString happy_var_1) -> 
	happyIn155
		 (DefaultValueLiteralString happy_var_1
	)}

happyReduce_249 = happySpecReduce_1  47# happyReduction_249
happyReduction_249 happy_x_1
	 =  case happyOutTok happy_x_1 of { (LiteralBlob happy_var_1) -> 
	happyIn155
		 (DefaultValueLiteralBlob happy_var_1
	)}

happyReduce_250 = happySpecReduce_1  47# happyReduction_250
happyReduction_250 happy_x_1
	 =  happyIn155
		 (DefaultValueLiteralNull
	)

happyReduce_251 = happySpecReduce_1  47# happyReduction_251
happyReduction_251 happy_x_1
	 =  happyIn155
		 (DefaultValueLiteralCurrentTime
	)

happyReduce_252 = happySpecReduce_1  47# happyReduction_252
happyReduction_252 happy_x_1
	 =  happyIn155
		 (DefaultValueLiteralCurrentDate
	)

happyReduce_253 = happySpecReduce_1  47# happyReduction_253
happyReduction_253 happy_x_1
	 =  happyIn155
		 (DefaultValueLiteralCurrentTimestamp
	)

happyReduce_254 = happySpecReduce_3  47# happyReduction_254
happyReduction_254 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_2 of { happy_var_2 -> 
	happyIn155
		 (DefaultValueExpression happy_var_2
	)}

happyReduce_255 = happySpecReduce_3  48# happyReduction_255
happyReduction_255 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_1 of { happy_var_1 -> 
	case happyOut147 happy_x_2 of { happy_var_2 -> 
	case happyOut148 happy_x_3 of { happy_var_3 -> 
	happyIn156
		 (IndexedColumn happy_var_1 happy_var_2 happy_var_3
	)}}}

happyReduce_256 = happySpecReduce_1  49# happyReduction_256
happyReduction_256 happy_x_1
	 =  case happyOut156 happy_x_1 of { happy_var_1 -> 
	happyIn157
		 ([happy_var_1]
	)}

happyReduce_257 = happySpecReduce_3  49# happyReduction_257
happyReduction_257 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut157 happy_x_1 of { happy_var_1 -> 
	case happyOut156 happy_x_3 of { happy_var_3 -> 
	happyIn157
		 (happy_var_1 ++ [happy_var_3]
	)}}

happyReduce_258 = happySpecReduce_0  50# happyReduction_258
happyReduction_258  =  happyIn158
		 (NoConstraintName
	)

happyReduce_259 = happySpecReduce_2  50# happyReduction_259
happyReduction_259 happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_2 of { happy_var_2 -> 
	happyIn158
		 (ConstraintName happy_var_2
	)}

happyReduce_260 = happyReduce 6# 51# happyReduction_260
happyReduction_260 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut158 happy_x_1 of { happy_var_1 -> 
	case happyOut148 happy_x_4 of { happy_var_4 -> 
	case happyOut206 happy_x_5 of { happy_var_5 -> 
	case happyOut149 happy_x_6 of { happy_var_6 -> 
	happyIn159
		 (ColumnPrimaryKey happy_var_1 happy_var_4 happy_var_5 happy_var_6
	) `HappyStk` happyRest}}}}

happyReduce_261 = happyReduce 4# 51# happyReduction_261
happyReduction_261 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut158 happy_x_1 of { happy_var_1 -> 
	case happyOut206 happy_x_4 of { happy_var_4 -> 
	happyIn159
		 (ColumnNotNull happy_var_1 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_262 = happySpecReduce_3  51# happyReduction_262
happyReduction_262 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut158 happy_x_1 of { happy_var_1 -> 
	case happyOut206 happy_x_3 of { happy_var_3 -> 
	happyIn159
		 (ColumnUnique happy_var_1 happy_var_3
	)}}

happyReduce_263 = happyReduce 5# 51# happyReduction_263
happyReduction_263 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut158 happy_x_1 of { happy_var_1 -> 
	case happyOut134 happy_x_4 of { happy_var_4 -> 
	happyIn159
		 (ColumnCheck happy_var_1 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_264 = happySpecReduce_3  51# happyReduction_264
happyReduction_264 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut158 happy_x_1 of { happy_var_1 -> 
	case happyOut155 happy_x_3 of { happy_var_3 -> 
	happyIn159
		 (ColumnDefault happy_var_1 happy_var_3
	)}}

happyReduce_265 = happySpecReduce_3  51# happyReduction_265
happyReduction_265 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut158 happy_x_1 of { happy_var_1 -> 
	case happyOut254 happy_x_3 of { happy_var_3 -> 
	happyIn159
		 (ColumnCollate happy_var_1 happy_var_3
	)}}

happyReduce_266 = happySpecReduce_2  51# happyReduction_266
happyReduction_266 happy_x_2
	happy_x_1
	 =  case happyOut158 happy_x_1 of { happy_var_1 -> 
	case happyOut207 happy_x_2 of { happy_var_2 -> 
	happyIn159
		 (ColumnForeignKey happy_var_1 happy_var_2
	)}}

happyReduce_267 = happySpecReduce_0  52# happyReduction_267
happyReduction_267  =  happyIn160
		 ([]
	)

happyReduce_268 = happySpecReduce_2  52# happyReduction_268
happyReduction_268 happy_x_2
	happy_x_1
	 =  case happyOut160 happy_x_1 of { happy_var_1 -> 
	case happyOut159 happy_x_2 of { happy_var_2 -> 
	happyIn160
		 (happy_var_1 ++ [happy_var_2]
	)}}

happyReduce_269 = happyReduce 7# 53# happyReduction_269
happyReduction_269 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut158 happy_x_1 of { happy_var_1 -> 
	case happyOut157 happy_x_5 of { happy_var_5 -> 
	case happyOut206 happy_x_7 of { happy_var_7 -> 
	happyIn161
		 (TablePrimaryKey happy_var_1 (fromJust $ mkOneOrMore happy_var_5) happy_var_7
	) `HappyStk` happyRest}}}

happyReduce_270 = happyReduce 6# 53# happyReduction_270
happyReduction_270 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut158 happy_x_1 of { happy_var_1 -> 
	case happyOut157 happy_x_4 of { happy_var_4 -> 
	case happyOut206 happy_x_6 of { happy_var_6 -> 
	happyIn161
		 (TableUnique happy_var_1 (fromJust $ mkOneOrMore happy_var_4) happy_var_6
	) `HappyStk` happyRest}}}

happyReduce_271 = happyReduce 5# 53# happyReduction_271
happyReduction_271 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut158 happy_x_1 of { happy_var_1 -> 
	case happyOut134 happy_x_4 of { happy_var_4 -> 
	happyIn161
		 (TableCheck happy_var_1 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_272 = happyReduce 7# 53# happyReduction_272
happyReduction_272 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut158 happy_x_1 of { happy_var_1 -> 
	case happyOut255 happy_x_5 of { happy_var_5 -> 
	case happyOut207 happy_x_7 of { happy_var_7 -> 
	happyIn161
		 (TableForeignKey happy_var_1 (fromJust $ mkOneOrMore happy_var_5) happy_var_7
	) `HappyStk` happyRest}}}

happyReduce_273 = happySpecReduce_1  54# happyReduction_273
happyReduction_273 happy_x_1
	 =  case happyOut161 happy_x_1 of { happy_var_1 -> 
	happyIn162
		 ([happy_var_1]
	)}

happyReduce_274 = happySpecReduce_3  54# happyReduction_274
happyReduction_274 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut162 happy_x_1 of { happy_var_1 -> 
	case happyOut161 happy_x_3 of { happy_var_3 -> 
	happyIn162
		 (happy_var_1 ++ [happy_var_3]
	)}}

happyReduce_275 = happySpecReduce_3  55# happyReduction_275
happyReduction_275 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut154 happy_x_2 of { happy_var_2 -> 
	happyIn163
		 (ColumnsAndConstraints (fromJust $ mkOneOrMore happy_var_2) []
	)}

happyReduce_276 = happyReduce 5# 55# happyReduction_276
happyReduction_276 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut154 happy_x_2 of { happy_var_2 -> 
	case happyOut162 happy_x_4 of { happy_var_4 -> 
	happyIn163
		 (ColumnsAndConstraints (fromJust $ mkOneOrMore happy_var_2) happy_var_4
	) `HappyStk` happyRest}}

happyReduce_277 = happySpecReduce_2  55# happyReduction_277
happyReduction_277 happy_x_2
	happy_x_1
	 =  case happyOut249 happy_x_2 of { happy_var_2 -> 
	happyIn163
		 (AsSelect happy_var_2
	)}

happyReduce_278 = happySpecReduce_1  56# happyReduction_278
happyReduction_278 happy_x_1
	 =  happyIn164
		 (Before
	)

happyReduce_279 = happySpecReduce_1  56# happyReduction_279
happyReduction_279 happy_x_1
	 =  happyIn164
		 (After
	)

happyReduce_280 = happySpecReduce_2  56# happyReduction_280
happyReduction_280 happy_x_2
	happy_x_1
	 =  happyIn164
		 (InsteadOf
	)

happyReduce_281 = happySpecReduce_2  57# happyReduction_281
happyReduction_281 happy_x_2
	happy_x_1
	 =  happyIn165
		 (DeleteOn
	)

happyReduce_282 = happySpecReduce_2  57# happyReduction_282
happyReduction_282 happy_x_2
	happy_x_1
	 =  happyIn165
		 (InsertOn
	)

happyReduce_283 = happySpecReduce_2  57# happyReduction_283
happyReduction_283 happy_x_2
	happy_x_1
	 =  happyIn165
		 (UpdateOn []
	)

happyReduce_284 = happyReduce 4# 57# happyReduction_284
happyReduction_284 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut255 happy_x_3 of { happy_var_3 -> 
	happyIn165
		 (UpdateOn happy_var_3
	) `HappyStk` happyRest}

happyReduce_285 = happySpecReduce_2  58# happyReduction_285
happyReduction_285 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_2 of { (ModuleArgumentToken happy_var_2) -> 
	happyIn166
		 (ModuleArgument happy_var_2
	)}

happyReduce_286 = happyMonadReduce 0# 59# happyReduction_286
happyReduction_286 (happyRest) tk
	 = happyThen (( do
         state <- getParseState
         putParseState $ state { parseStateLexingModuleArgument = True })
	) (\r -> happyReturn (happyIn167 r))

happyReduce_287 = happySpecReduce_1  60# happyReduction_287
happyReduction_287 happy_x_1
	 =  case happyOut166 happy_x_1 of { happy_var_1 -> 
	happyIn168
		 ([happy_var_1]
	)}

happyReduce_288 = happySpecReduce_3  60# happyReduction_288
happyReduction_288 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut168 happy_x_1 of { happy_var_1 -> 
	case happyOut166 happy_x_3 of { happy_var_3 -> 
	happyIn168
		 (happy_var_1 ++ [happy_var_3]
	)}}

happyReduce_289 = happySpecReduce_1  61# happyReduction_289
happyReduction_289 happy_x_1
	 =  case happyOut250 happy_x_1 of { happy_var_1 -> 
	happyIn169
		 (TriggerStatement happy_var_1
	)}

happyReduce_290 = happySpecReduce_1  61# happyReduction_290
happyReduction_290 happy_x_1
	 =  case happyOut243 happy_x_1 of { happy_var_1 -> 
	happyIn169
		 (TriggerStatement happy_var_1
	)}

happyReduce_291 = happySpecReduce_1  61# happyReduction_291
happyReduction_291 happy_x_1
	 =  case happyOut235 happy_x_1 of { happy_var_1 -> 
	happyIn169
		 (TriggerStatement happy_var_1
	)}

happyReduce_292 = happySpecReduce_1  61# happyReduction_292
happyReduction_292 happy_x_1
	 =  case happyOut249 happy_x_1 of { happy_var_1 -> 
	happyIn169
		 (TriggerStatement happy_var_1
	)}

happyReduce_293 = happySpecReduce_1  62# happyReduction_293
happyReduction_293 happy_x_1
	 =  case happyOut169 happy_x_1 of { happy_var_1 -> 
	happyIn170
		 ([happy_var_1]
	)}

happyReduce_294 = happySpecReduce_3  62# happyReduction_294
happyReduction_294 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut170 happy_x_1 of { happy_var_1 -> 
	case happyOut169 happy_x_3 of { happy_var_3 -> 
	happyIn170
		 (happy_var_1 ++ [happy_var_3]
	)}}

happyReduce_295 = happySpecReduce_1  63# happyReduction_295
happyReduction_295 happy_x_1
	 =  case happyOut256 happy_x_1 of { happy_var_1 -> 
	happyIn171
		 (TableNoIndexedBy happy_var_1
	)}

happyReduce_296 = happyReduce 4# 63# happyReduction_296
happyReduction_296 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut256 happy_x_1 of { happy_var_1 -> 
	case happyOut254 happy_x_4 of { happy_var_4 -> 
	happyIn171
		 (TableIndexedBy happy_var_1 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_297 = happySpecReduce_3  63# happyReduction_297
happyReduction_297 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut256 happy_x_1 of { happy_var_1 -> 
	happyIn171
		 (TableNotIndexed happy_var_1
	)}

happyReduce_298 = happySpecReduce_3  64# happyReduction_298
happyReduction_298 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_1 of { happy_var_1 -> 
	case happyOut147 happy_x_2 of { happy_var_2 -> 
	case happyOut148 happy_x_3 of { happy_var_3 -> 
	happyIn172
		 (OrderingTerm happy_var_1 happy_var_2 happy_var_3
	)}}}

happyReduce_299 = happySpecReduce_1  65# happyReduction_299
happyReduction_299 happy_x_1
	 =  case happyOut172 happy_x_1 of { happy_var_1 -> 
	happyIn173
		 ([happy_var_1]
	)}

happyReduce_300 = happySpecReduce_3  65# happyReduction_300
happyReduction_300 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut173 happy_x_1 of { happy_var_1 -> 
	case happyOut172 happy_x_3 of { happy_var_3 -> 
	happyIn173
		 (happy_var_1 ++ [happy_var_3]
	)}}

happyReduce_301 = happySpecReduce_0  66# happyReduction_301
happyReduction_301  =  happyIn174
		 (EmptyPragmaBody
	)

happyReduce_302 = happySpecReduce_2  66# happyReduction_302
happyReduction_302 happy_x_2
	happy_x_1
	 =  case happyOut175 happy_x_2 of { happy_var_2 -> 
	happyIn174
		 (EqualsPragmaBody happy_var_2
	)}

happyReduce_303 = happySpecReduce_3  66# happyReduction_303
happyReduction_303 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut175 happy_x_2 of { happy_var_2 -> 
	happyIn174
		 (CallPragmaBody happy_var_2
	)}

happyReduce_304 = happySpecReduce_2  67# happyReduction_304
happyReduction_304 happy_x_2
	happy_x_1
	 =  case happyOut150 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { (LiteralInteger happy_var_2) -> 
	happyIn175
		 (SignedIntegerPragmaValue happy_var_1 happy_var_2
	)}}

happyReduce_305 = happySpecReduce_2  67# happyReduction_305
happyReduction_305 happy_x_2
	happy_x_1
	 =  case happyOut150 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { (LiteralFloat happy_var_2) -> 
	happyIn175
		 (SignedFloatPragmaValue happy_var_1 happy_var_2
	)}}

happyReduce_306 = happySpecReduce_1  67# happyReduction_306
happyReduction_306 happy_x_1
	 =  case happyOut254 happy_x_1 of { happy_var_1 -> 
	happyIn175
		 (NamePragmaValue happy_var_1
	)}

happyReduce_307 = happySpecReduce_1  67# happyReduction_307
happyReduction_307 happy_x_1
	 =  case happyOutTok happy_x_1 of { (LiteralString happy_var_1) -> 
	happyIn175
		 (StringPragmaValue happy_var_1
	)}

happyReduce_308 = happySpecReduce_1  68# happyReduction_308
happyReduction_308 happy_x_1
	 =  happyIn176
		 (InsertNoAlternative
	)

happyReduce_309 = happySpecReduce_3  68# happyReduction_309
happyReduction_309 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn176
		 (InsertOrRollback
	)

happyReduce_310 = happySpecReduce_3  68# happyReduction_310
happyReduction_310 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn176
		 (InsertOrAbort
	)

happyReduce_311 = happySpecReduce_3  68# happyReduction_311
happyReduction_311 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn176
		 (InsertOrReplace
	)

happyReduce_312 = happySpecReduce_3  68# happyReduction_312
happyReduction_312 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn176
		 (InsertOrFail
	)

happyReduce_313 = happySpecReduce_3  68# happyReduction_313
happyReduction_313 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn176
		 (InsertOrIgnore
	)

happyReduce_314 = happySpecReduce_1  68# happyReduction_314
happyReduction_314 happy_x_1
	 =  happyIn176
		 (Replace
	)

happyReduce_315 = happyReduce 4# 69# happyReduction_315
happyReduction_315 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut136 happy_x_3 of { happy_var_3 -> 
	happyIn177
		 (InsertValues [] (fromJust $ mkOneOrMore happy_var_3)
	) `HappyStk` happyRest}

happyReduce_316 = happyReduce 7# 69# happyReduction_316
happyReduction_316 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut255 happy_x_2 of { happy_var_2 -> 
	case happyOut136 happy_x_6 of { happy_var_6 -> 
	happyIn177
		 (InsertValues happy_var_2 (fromJust $ mkOneOrMore happy_var_6)
	) `HappyStk` happyRest}}

happyReduce_317 = happySpecReduce_1  69# happyReduction_317
happyReduction_317 happy_x_1
	 =  case happyOut249 happy_x_1 of { happy_var_1 -> 
	happyIn177
		 (InsertSelect [] happy_var_1
	)}

happyReduce_318 = happyReduce 4# 69# happyReduction_318
happyReduction_318 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut255 happy_x_2 of { happy_var_2 -> 
	case happyOut249 happy_x_4 of { happy_var_4 -> 
	happyIn177
		 (InsertSelect happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_319 = happySpecReduce_2  69# happyReduction_319
happyReduction_319 happy_x_2
	happy_x_1
	 =  happyIn177
		 (InsertDefaultValues
	)

happyReduce_320 = happySpecReduce_1  70# happyReduction_320
happyReduction_320 happy_x_1
	 =  happyIn178
		 (UpdateNoAlternative
	)

happyReduce_321 = happySpecReduce_3  70# happyReduction_321
happyReduction_321 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn178
		 (UpdateOrRollback
	)

happyReduce_322 = happySpecReduce_3  70# happyReduction_322
happyReduction_322 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn178
		 (UpdateOrAbort
	)

happyReduce_323 = happySpecReduce_3  70# happyReduction_323
happyReduction_323 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn178
		 (UpdateOrReplace
	)

happyReduce_324 = happySpecReduce_3  70# happyReduction_324
happyReduction_324 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn178
		 (UpdateOrFail
	)

happyReduce_325 = happySpecReduce_3  70# happyReduction_325
happyReduction_325 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn178
		 (UpdateOrIgnore
	)

happyReduce_326 = happySpecReduce_0  71# happyReduction_326
happyReduction_326  =  happyIn179
		 (NoDistinctness
	)

happyReduce_327 = happySpecReduce_1  71# happyReduction_327
happyReduction_327 happy_x_1
	 =  happyIn179
		 (Distinct
	)

happyReduce_328 = happySpecReduce_1  71# happyReduction_328
happyReduction_328 happy_x_1
	 =  happyIn179
		 (All
	)

happyReduce_329 = happySpecReduce_0  72# happyReduction_329
happyReduction_329  =  happyIn180
		 (NoHaving
	)

happyReduce_330 = happySpecReduce_2  72# happyReduction_330
happyReduction_330 happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_2 of { happy_var_2 -> 
	happyIn180
		 (Having happy_var_2
	)}

happyReduce_331 = happySpecReduce_0  73# happyReduction_331
happyReduction_331  =  happyIn181
		 (NoAs
	)

happyReduce_332 = happySpecReduce_2  73# happyReduction_332
happyReduction_332 happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_2 of { happy_var_2 -> 
	happyIn181
		 (As happy_var_2
	)}

happyReduce_333 = happySpecReduce_1  73# happyReduction_333
happyReduction_333 happy_x_1
	 =  case happyOut254 happy_x_1 of { happy_var_1 -> 
	happyIn181
		 (ElidedAs happy_var_1
	)}

happyReduce_334 = happySpecReduce_1  74# happyReduction_334
happyReduction_334 happy_x_1
	 =  happyIn182
		 (Union
	)

happyReduce_335 = happySpecReduce_2  74# happyReduction_335
happyReduction_335 happy_x_2
	happy_x_1
	 =  happyIn182
		 (UnionAll
	)

happyReduce_336 = happySpecReduce_1  74# happyReduction_336
happyReduction_336 happy_x_1
	 =  happyIn182
		 (Intersect
	)

happyReduce_337 = happySpecReduce_1  74# happyReduction_337
happyReduction_337 happy_x_1
	 =  happyIn182
		 (Except
	)

happyReduce_338 = happyReduce 6# 75# happyReduction_338
happyReduction_338 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut179 happy_x_2 of { happy_var_2 -> 
	case happyOut186 happy_x_3 of { happy_var_3 -> 
	case happyOut194 happy_x_4 of { happy_var_4 -> 
	case happyOut196 happy_x_5 of { happy_var_5 -> 
	case happyOut198 happy_x_6 of { happy_var_6 -> 
	happyIn183
		 (SelectCore happy_var_2 (fromJust $ mkOneOrMore happy_var_3) happy_var_4 happy_var_5 happy_var_6
	) `HappyStk` happyRest}}}}}

happyReduce_339 = happySpecReduce_0  76# happyReduction_339
happyReduction_339  =  happyIn184
		 ([]
	)

happyReduce_340 = happySpecReduce_3  76# happyReduction_340
happyReduction_340 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut184 happy_x_1 of { happy_var_1 -> 
	case happyOut182 happy_x_2 of { happy_var_2 -> 
	case happyOut183 happy_x_3 of { happy_var_3 -> 
	happyIn184
		 (happy_var_1 ++ [(happy_var_2, happy_var_3)]
	)}}}

happyReduce_341 = happySpecReduce_1  77# happyReduction_341
happyReduction_341 happy_x_1
	 =  happyIn185
		 (Star
	)

happyReduce_342 = happySpecReduce_3  77# happyReduction_342
happyReduction_342 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_1 of { happy_var_1 -> 
	happyIn185
		 (TableStar happy_var_1
	)}

happyReduce_343 = happySpecReduce_2  77# happyReduction_343
happyReduction_343 happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_1 of { happy_var_1 -> 
	case happyOut181 happy_x_2 of { happy_var_2 -> 
	happyIn185
		 (Result happy_var_1 happy_var_2
	)}}

happyReduce_344 = happySpecReduce_1  78# happyReduction_344
happyReduction_344 happy_x_1
	 =  case happyOut185 happy_x_1 of { happy_var_1 -> 
	happyIn186
		 ([happy_var_1]
	)}

happyReduce_345 = happySpecReduce_3  78# happyReduction_345
happyReduction_345 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut186 happy_x_1 of { happy_var_1 -> 
	case happyOut185 happy_x_3 of { happy_var_3 -> 
	happyIn186
		 (happy_var_1 ++ [happy_var_3]
	)}}

happyReduce_346 = happySpecReduce_2  79# happyReduction_346
happyReduction_346 happy_x_2
	happy_x_1
	 =  case happyOut189 happy_x_1 of { happy_var_1 -> 
	case happyOut188 happy_x_2 of { happy_var_2 -> 
	happyIn187
		 (JoinSource happy_var_1 happy_var_2
	)}}

happyReduce_347 = happySpecReduce_0  80# happyReduction_347
happyReduction_347  =  happyIn188
		 ([]
	)

happyReduce_348 = happyReduce 4# 80# happyReduction_348
happyReduction_348 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut188 happy_x_1 of { happy_var_1 -> 
	case happyOut190 happy_x_2 of { happy_var_2 -> 
	case happyOut189 happy_x_3 of { happy_var_3 -> 
	case happyOut191 happy_x_4 of { happy_var_4 -> 
	happyIn188
		 (happy_var_1 ++ [(happy_var_2, happy_var_3, happy_var_4)]
	) `HappyStk` happyRest}}}}

happyReduce_349 = happySpecReduce_3  81# happyReduction_349
happyReduction_349 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut256 happy_x_1 of { happy_var_1 -> 
	case happyOut181 happy_x_2 of { happy_var_2 -> 
	case happyOut192 happy_x_3 of { happy_var_3 -> 
	happyIn189
		 (TableSource happy_var_1 happy_var_2 happy_var_3
	)}}}

happyReduce_350 = happyReduce 4# 81# happyReduction_350
happyReduction_350 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut249 happy_x_2 of { happy_var_2 -> 
	case happyOut181 happy_x_4 of { happy_var_4 -> 
	happyIn189
		 (SelectSource happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_351 = happySpecReduce_3  81# happyReduction_351
happyReduction_351 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut187 happy_x_2 of { happy_var_2 -> 
	happyIn189
		 (SubjoinSource happy_var_2
	)}

happyReduce_352 = happySpecReduce_1  82# happyReduction_352
happyReduction_352 happy_x_1
	 =  happyIn190
		 (Comma
	)

happyReduce_353 = happySpecReduce_1  82# happyReduction_353
happyReduction_353 happy_x_1
	 =  happyIn190
		 (Join
	)

happyReduce_354 = happySpecReduce_2  82# happyReduction_354
happyReduction_354 happy_x_2
	happy_x_1
	 =  happyIn190
		 (OuterJoin
	)

happyReduce_355 = happySpecReduce_2  82# happyReduction_355
happyReduction_355 happy_x_2
	happy_x_1
	 =  happyIn190
		 (LeftJoin
	)

happyReduce_356 = happySpecReduce_3  82# happyReduction_356
happyReduction_356 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn190
		 (LeftOuterJoin
	)

happyReduce_357 = happySpecReduce_2  82# happyReduction_357
happyReduction_357 happy_x_2
	happy_x_1
	 =  happyIn190
		 (InnerJoin
	)

happyReduce_358 = happySpecReduce_2  82# happyReduction_358
happyReduction_358 happy_x_2
	happy_x_1
	 =  happyIn190
		 (CrossJoin
	)

happyReduce_359 = happySpecReduce_2  82# happyReduction_359
happyReduction_359 happy_x_2
	happy_x_1
	 =  happyIn190
		 (NaturalJoin
	)

happyReduce_360 = happySpecReduce_3  82# happyReduction_360
happyReduction_360 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn190
		 (NaturalOuterJoin
	)

happyReduce_361 = happySpecReduce_3  82# happyReduction_361
happyReduction_361 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn190
		 (NaturalLeftJoin
	)

happyReduce_362 = happyReduce 4# 82# happyReduction_362
happyReduction_362 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = happyIn190
		 (NaturalLeftOuterJoin
	) `HappyStk` happyRest

happyReduce_363 = happySpecReduce_3  82# happyReduction_363
happyReduction_363 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn190
		 (NaturalInnerJoin
	)

happyReduce_364 = happySpecReduce_3  82# happyReduction_364
happyReduction_364 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn190
		 (NaturalCrossJoin
	)

happyReduce_365 = happySpecReduce_0  83# happyReduction_365
happyReduction_365  =  happyIn191
		 (NoConstraint
	)

happyReduce_366 = happySpecReduce_2  83# happyReduction_366
happyReduction_366 happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_2 of { happy_var_2 -> 
	happyIn191
		 (On happy_var_2
	)}

happyReduce_367 = happyReduce 4# 83# happyReduction_367
happyReduction_367 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut255 happy_x_3 of { happy_var_3 -> 
	happyIn191
		 (Using (fromJust $ mkOneOrMore happy_var_3)
	) `HappyStk` happyRest}

happyReduce_368 = happySpecReduce_0  84# happyReduction_368
happyReduction_368  =  happyIn192
		 (NoIndexedBy
	)

happyReduce_369 = happySpecReduce_3  84# happyReduction_369
happyReduction_369 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_3 of { happy_var_3 -> 
	happyIn192
		 (IndexedBy happy_var_3
	)}

happyReduce_370 = happySpecReduce_2  84# happyReduction_370
happyReduction_370 happy_x_2
	happy_x_1
	 =  happyIn192
		 (NotIndexed
	)

happyReduce_371 = happySpecReduce_2  85# happyReduction_371
happyReduction_371 happy_x_2
	happy_x_1
	 =  case happyOut187 happy_x_2 of { happy_var_2 -> 
	happyIn193
		 (From happy_var_2
	)}

happyReduce_372 = happySpecReduce_0  86# happyReduction_372
happyReduction_372  =  happyIn194
		 (Nothing
	)

happyReduce_373 = happySpecReduce_1  86# happyReduction_373
happyReduction_373 happy_x_1
	 =  case happyOut193 happy_x_1 of { happy_var_1 -> 
	happyIn194
		 (Just happy_var_1
	)}

happyReduce_374 = happySpecReduce_2  87# happyReduction_374
happyReduction_374 happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_2 of { happy_var_2 -> 
	happyIn195
		 (Where happy_var_2
	)}

happyReduce_375 = happySpecReduce_0  88# happyReduction_375
happyReduction_375  =  happyIn196
		 (Nothing
	)

happyReduce_376 = happySpecReduce_1  88# happyReduction_376
happyReduction_376 happy_x_1
	 =  case happyOut195 happy_x_1 of { happy_var_1 -> 
	happyIn196
		 (Just happy_var_1
	)}

happyReduce_377 = happyReduce 4# 89# happyReduction_377
happyReduction_377 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut173 happy_x_3 of { happy_var_3 -> 
	case happyOut180 happy_x_4 of { happy_var_4 -> 
	happyIn197
		 (GroupBy (fromJust $ mkOneOrMore happy_var_3) happy_var_4
	) `HappyStk` happyRest}}

happyReduce_378 = happySpecReduce_0  90# happyReduction_378
happyReduction_378  =  happyIn198
		 (Nothing
	)

happyReduce_379 = happySpecReduce_1  90# happyReduction_379
happyReduction_379 happy_x_1
	 =  case happyOut197 happy_x_1 of { happy_var_1 -> 
	happyIn198
		 (Just happy_var_1
	)}

happyReduce_380 = happySpecReduce_3  91# happyReduction_380
happyReduction_380 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut173 happy_x_3 of { happy_var_3 -> 
	happyIn199
		 (OrderBy (fromJust $ mkOneOrMore happy_var_3)
	)}

happyReduce_381 = happySpecReduce_0  92# happyReduction_381
happyReduction_381  =  happyIn200
		 (Nothing
	)

happyReduce_382 = happySpecReduce_1  92# happyReduction_382
happyReduction_382 happy_x_1
	 =  case happyOut199 happy_x_1 of { happy_var_1 -> 
	happyIn200
		 (Just happy_var_1
	)}

happyReduce_383 = happySpecReduce_2  93# happyReduction_383
happyReduction_383 happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_2 of { (LiteralInteger happy_var_2) -> 
	happyIn201
		 (Limit happy_var_2
	)}

happyReduce_384 = happyReduce 4# 93# happyReduction_384
happyReduction_384 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (LiteralInteger happy_var_2) -> 
	case happyOutTok happy_x_4 of { (LiteralInteger happy_var_4) -> 
	happyIn201
		 (LimitOffset happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_385 = happyReduce 4# 93# happyReduction_385
happyReduction_385 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOutTok happy_x_2 of { (LiteralInteger happy_var_2) -> 
	case happyOutTok happy_x_4 of { (LiteralInteger happy_var_4) -> 
	happyIn201
		 (LimitComma happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_386 = happySpecReduce_0  94# happyReduction_386
happyReduction_386  =  happyIn202
		 (Nothing
	)

happyReduce_387 = happySpecReduce_1  94# happyReduction_387
happyReduction_387 happy_x_1
	 =  case happyOut201 happy_x_1 of { happy_var_1 -> 
	happyIn202
		 (Just happy_var_1
	)}

happyReduce_388 = happySpecReduce_2  95# happyReduction_388
happyReduction_388 happy_x_2
	happy_x_1
	 =  case happyOut134 happy_x_2 of { happy_var_2 -> 
	happyIn203
		 (When happy_var_2
	)}

happyReduce_389 = happySpecReduce_0  96# happyReduction_389
happyReduction_389  =  happyIn204
		 (Nothing
	)

happyReduce_390 = happySpecReduce_1  96# happyReduction_390
happyReduction_390 happy_x_1
	 =  case happyOut203 happy_x_1 of { happy_var_1 -> 
	happyIn204
		 (Just happy_var_1
	)}

happyReduce_391 = happySpecReduce_3  97# happyReduction_391
happyReduction_391 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn205
		 (OnConflictRollback
	)

happyReduce_392 = happySpecReduce_3  97# happyReduction_392
happyReduction_392 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn205
		 (OnConflictAbort
	)

happyReduce_393 = happySpecReduce_3  97# happyReduction_393
happyReduction_393 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn205
		 (OnConflictFail
	)

happyReduce_394 = happySpecReduce_3  97# happyReduction_394
happyReduction_394 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn205
		 (OnConflictIgnore
	)

happyReduce_395 = happySpecReduce_3  97# happyReduction_395
happyReduction_395 happy_x_3
	happy_x_2
	happy_x_1
	 =  happyIn205
		 (OnConflictReplace
	)

happyReduce_396 = happySpecReduce_0  98# happyReduction_396
happyReduction_396  =  happyIn206
		 (Nothing
	)

happyReduce_397 = happySpecReduce_1  98# happyReduction_397
happyReduction_397 happy_x_1
	 =  case happyOut205 happy_x_1 of { happy_var_1 -> 
	happyIn206
		 (Just happy_var_1
	)}

happyReduce_398 = happyReduce 4# 99# happyReduction_398
happyReduction_398 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut254 happy_x_2 of { happy_var_2 -> 
	case happyOut209 happy_x_3 of { happy_var_3 -> 
	case happyOut211 happy_x_4 of { happy_var_4 -> 
	happyIn207
		 (References happy_var_2 [] happy_var_3 happy_var_4
	) `HappyStk` happyRest}}}

happyReduce_399 = happyReduce 7# 99# happyReduction_399
happyReduction_399 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut254 happy_x_2 of { happy_var_2 -> 
	case happyOut255 happy_x_4 of { happy_var_4 -> 
	case happyOut209 happy_x_6 of { happy_var_6 -> 
	case happyOut211 happy_x_7 of { happy_var_7 -> 
	happyIn207
		 (References happy_var_2 happy_var_4 happy_var_6 happy_var_7
	) `HappyStk` happyRest}}}}

happyReduce_400 = happySpecReduce_3  100# happyReduction_400
happyReduction_400 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut210 happy_x_3 of { happy_var_3 -> 
	happyIn208
		 (OnDelete happy_var_3
	)}

happyReduce_401 = happySpecReduce_3  100# happyReduction_401
happyReduction_401 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut210 happy_x_3 of { happy_var_3 -> 
	happyIn208
		 (OnUpdate happy_var_3
	)}

happyReduce_402 = happySpecReduce_2  100# happyReduction_402
happyReduction_402 happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_2 of { happy_var_2 -> 
	happyIn208
		 (ReferencesMatch happy_var_2
	)}

happyReduce_403 = happySpecReduce_0  101# happyReduction_403
happyReduction_403  =  happyIn209
		 ([]
	)

happyReduce_404 = happySpecReduce_2  101# happyReduction_404
happyReduction_404 happy_x_2
	happy_x_1
	 =  case happyOut209 happy_x_1 of { happy_var_1 -> 
	case happyOut208 happy_x_2 of { happy_var_2 -> 
	happyIn209
		 (happy_var_1 ++ [happy_var_2]
	)}}

happyReduce_405 = happySpecReduce_2  102# happyReduction_405
happyReduction_405 happy_x_2
	happy_x_1
	 =  happyIn210
		 (SetNull
	)

happyReduce_406 = happySpecReduce_2  102# happyReduction_406
happyReduction_406 happy_x_2
	happy_x_1
	 =  happyIn210
		 (SetDefault
	)

happyReduce_407 = happySpecReduce_1  102# happyReduction_407
happyReduction_407 happy_x_1
	 =  happyIn210
		 (Cascade
	)

happyReduce_408 = happySpecReduce_1  102# happyReduction_408
happyReduction_408 happy_x_1
	 =  happyIn210
		 (Restrict
	)

happyReduce_409 = happySpecReduce_2  102# happyReduction_409
happyReduction_409 happy_x_2
	happy_x_1
	 =  happyIn210
		 (NoAction
	)

happyReduce_410 = happySpecReduce_0  103# happyReduction_410
happyReduction_410  =  happyIn211
		 (NoDeferrablePart
	)

happyReduce_411 = happySpecReduce_2  103# happyReduction_411
happyReduction_411 happy_x_2
	happy_x_1
	 =  case happyOut212 happy_x_2 of { happy_var_2 -> 
	happyIn211
		 (Deferrable happy_var_2
	)}

happyReduce_412 = happySpecReduce_3  103# happyReduction_412
happyReduction_412 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut212 happy_x_3 of { happy_var_3 -> 
	happyIn211
		 (NotDeferrable happy_var_3
	)}

happyReduce_413 = happySpecReduce_0  104# happyReduction_413
happyReduction_413  =  happyIn212
		 (NoInitialDeferralStatus
	)

happyReduce_414 = happySpecReduce_2  104# happyReduction_414
happyReduction_414 happy_x_2
	happy_x_1
	 =  happyIn212
		 (InitiallyDeferred
	)

happyReduce_415 = happySpecReduce_2  104# happyReduction_415
happyReduction_415 happy_x_2
	happy_x_1
	 =  happyIn212
		 (InitiallyImmediate
	)

happyReduce_416 = happySpecReduce_1  105# happyReduction_416
happyReduction_416 happy_x_1
	 =  happyIn213
		 (CommitCommit
	)

happyReduce_417 = happySpecReduce_1  105# happyReduction_417
happyReduction_417 happy_x_1
	 =  happyIn213
		 (CommitEnd
	)

happyReduce_418 = happySpecReduce_0  106# happyReduction_418
happyReduction_418  =  happyIn214
		 (ElidedTransaction
	)

happyReduce_419 = happySpecReduce_1  106# happyReduction_419
happyReduction_419 happy_x_1
	 =  happyIn214
		 (Transaction
	)

happyReduce_420 = happySpecReduce_0  107# happyReduction_420
happyReduction_420  =  happyIn215
		 (NoTransactionType
	)

happyReduce_421 = happySpecReduce_1  107# happyReduction_421
happyReduction_421 happy_x_1
	 =  happyIn215
		 (Deferred
	)

happyReduce_422 = happySpecReduce_1  107# happyReduction_422
happyReduction_422 happy_x_1
	 =  happyIn215
		 (Immediate
	)

happyReduce_423 = happySpecReduce_1  107# happyReduction_423
happyReduction_423 happy_x_1
	 =  happyIn215
		 (Exclusive
	)

happyReduce_424 = happySpecReduce_0  108# happyReduction_424
happyReduction_424  =  happyIn216
		 (ElidedDatabase
	)

happyReduce_425 = happySpecReduce_1  108# happyReduction_425
happyReduction_425 happy_x_1
	 =  happyIn216
		 (Database
	)

happyReduce_426 = happySpecReduce_0  109# happyReduction_426
happyReduction_426  =  happyIn217
		 (NoSavepoint
	)

happyReduce_427 = happySpecReduce_2  109# happyReduction_427
happyReduction_427 happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_2 of { happy_var_2 -> 
	happyIn217
		 (To happy_var_2
	)}

happyReduce_428 = happySpecReduce_3  109# happyReduction_428
happyReduction_428 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_3 of { happy_var_3 -> 
	happyIn217
		 (ToSavepoint happy_var_3
	)}

happyReduce_429 = happySpecReduce_1  110# happyReduction_429
happyReduction_429 happy_x_1
	 =  case happyOut254 happy_x_1 of { happy_var_1 -> 
	happyIn218
		 (ElidedReleaseSavepoint happy_var_1
	)}

happyReduce_430 = happySpecReduce_2  110# happyReduction_430
happyReduction_430 happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_2 of { happy_var_2 -> 
	happyIn218
		 (ReleaseSavepoint happy_var_2
	)}

happyReduce_431 = happySpecReduce_0  111# happyReduction_431
happyReduction_431  =  happyIn219
		 (StatementList []
	)

happyReduce_432 = happySpecReduce_1  111# happyReduction_432
happyReduction_432 happy_x_1
	 =  case happyOut220 happy_x_1 of { happy_var_1 -> 
	happyIn219
		 (StatementList happy_var_1
	)}

happyReduce_433 = happySpecReduce_1  112# happyReduction_433
happyReduction_433 happy_x_1
	 =  case happyOut221 happy_x_1 of { happy_var_1 -> 
	happyIn220
		 ([happy_var_1]
	)}

happyReduce_434 = happySpecReduce_3  112# happyReduction_434
happyReduction_434 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut220 happy_x_1 of { happy_var_1 -> 
	case happyOut221 happy_x_3 of { happy_var_3 -> 
	happyIn220
		 (happy_var_1 ++ [happy_var_3]
	)}}

happyReduce_435 = happySpecReduce_1  113# happyReduction_435
happyReduction_435 happy_x_1
	 =  case happyOut223 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_436 = happySpecReduce_1  113# happyReduction_436
happyReduction_436 happy_x_1
	 =  case happyOut224 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_437 = happySpecReduce_1  113# happyReduction_437
happyReduction_437 happy_x_1
	 =  case happyOut225 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_438 = happySpecReduce_1  113# happyReduction_438
happyReduction_438 happy_x_1
	 =  case happyOut226 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_439 = happySpecReduce_1  113# happyReduction_439
happyReduction_439 happy_x_1
	 =  case happyOut227 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_440 = happySpecReduce_1  113# happyReduction_440
happyReduction_440 happy_x_1
	 =  case happyOut228 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_441 = happySpecReduce_1  113# happyReduction_441
happyReduction_441 happy_x_1
	 =  case happyOut229 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_442 = happySpecReduce_1  113# happyReduction_442
happyReduction_442 happy_x_1
	 =  case happyOut230 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_443 = happySpecReduce_1  113# happyReduction_443
happyReduction_443 happy_x_1
	 =  case happyOut231 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_444 = happySpecReduce_1  113# happyReduction_444
happyReduction_444 happy_x_1
	 =  case happyOut232 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_445 = happySpecReduce_1  113# happyReduction_445
happyReduction_445 happy_x_1
	 =  case happyOut233 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_446 = happySpecReduce_1  113# happyReduction_446
happyReduction_446 happy_x_1
	 =  case happyOut234 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_447 = happySpecReduce_1  113# happyReduction_447
happyReduction_447 happy_x_1
	 =  case happyOut235 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_448 = happySpecReduce_1  113# happyReduction_448
happyReduction_448 happy_x_1
	 =  case happyOut236 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_449 = happySpecReduce_1  113# happyReduction_449
happyReduction_449 happy_x_1
	 =  case happyOut238 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_450 = happySpecReduce_1  113# happyReduction_450
happyReduction_450 happy_x_1
	 =  case happyOut239 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_451 = happySpecReduce_1  113# happyReduction_451
happyReduction_451 happy_x_1
	 =  case happyOut240 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_452 = happySpecReduce_1  113# happyReduction_452
happyReduction_452 happy_x_1
	 =  case happyOut241 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_453 = happySpecReduce_1  113# happyReduction_453
happyReduction_453 happy_x_1
	 =  case happyOut242 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_454 = happySpecReduce_1  113# happyReduction_454
happyReduction_454 happy_x_1
	 =  case happyOut243 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_455 = happySpecReduce_1  113# happyReduction_455
happyReduction_455 happy_x_1
	 =  case happyOut244 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_456 = happySpecReduce_1  113# happyReduction_456
happyReduction_456 happy_x_1
	 =  case happyOut245 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_457 = happySpecReduce_1  113# happyReduction_457
happyReduction_457 happy_x_1
	 =  case happyOut246 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_458 = happySpecReduce_1  113# happyReduction_458
happyReduction_458 happy_x_1
	 =  case happyOut247 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_459 = happySpecReduce_1  113# happyReduction_459
happyReduction_459 happy_x_1
	 =  case happyOut248 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_460 = happySpecReduce_1  113# happyReduction_460
happyReduction_460 happy_x_1
	 =  case happyOut249 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_461 = happySpecReduce_1  113# happyReduction_461
happyReduction_461 happy_x_1
	 =  case happyOut250 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_462 = happySpecReduce_1  113# happyReduction_462
happyReduction_462 happy_x_1
	 =  case happyOut251 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_463 = happySpecReduce_1  113# happyReduction_463
happyReduction_463 happy_x_1
	 =  case happyOut253 happy_x_1 of { happy_var_1 -> 
	happyIn221
		 (Statement happy_var_1
	)}

happyReduce_464 = happySpecReduce_1  114# happyReduction_464
happyReduction_464 happy_x_1
	 =  case happyOut225 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_465 = happySpecReduce_1  114# happyReduction_465
happyReduction_465 happy_x_1
	 =  case happyOut226 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_466 = happySpecReduce_1  114# happyReduction_466
happyReduction_466 happy_x_1
	 =  case happyOut227 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_467 = happySpecReduce_1  114# happyReduction_467
happyReduction_467 happy_x_1
	 =  case happyOut228 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_468 = happySpecReduce_1  114# happyReduction_468
happyReduction_468 happy_x_1
	 =  case happyOut229 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_469 = happySpecReduce_1  114# happyReduction_469
happyReduction_469 happy_x_1
	 =  case happyOut230 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_470 = happySpecReduce_1  114# happyReduction_470
happyReduction_470 happy_x_1
	 =  case happyOut231 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_471 = happySpecReduce_1  114# happyReduction_471
happyReduction_471 happy_x_1
	 =  case happyOut232 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_472 = happySpecReduce_1  114# happyReduction_472
happyReduction_472 happy_x_1
	 =  case happyOut234 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_473 = happySpecReduce_1  114# happyReduction_473
happyReduction_473 happy_x_1
	 =  case happyOut235 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_474 = happySpecReduce_1  114# happyReduction_474
happyReduction_474 happy_x_1
	 =  case happyOut236 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_475 = happySpecReduce_1  114# happyReduction_475
happyReduction_475 happy_x_1
	 =  case happyOut238 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_476 = happySpecReduce_1  114# happyReduction_476
happyReduction_476 happy_x_1
	 =  case happyOut239 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_477 = happySpecReduce_1  114# happyReduction_477
happyReduction_477 happy_x_1
	 =  case happyOut240 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_478 = happySpecReduce_1  114# happyReduction_478
happyReduction_478 happy_x_1
	 =  case happyOut241 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_479 = happySpecReduce_1  114# happyReduction_479
happyReduction_479 happy_x_1
	 =  case happyOut242 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_480 = happySpecReduce_1  114# happyReduction_480
happyReduction_480 happy_x_1
	 =  case happyOut243 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_481 = happySpecReduce_1  114# happyReduction_481
happyReduction_481 happy_x_1
	 =  case happyOut244 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_482 = happySpecReduce_1  114# happyReduction_482
happyReduction_482 happy_x_1
	 =  case happyOut245 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_483 = happySpecReduce_1  114# happyReduction_483
happyReduction_483 happy_x_1
	 =  case happyOut246 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_484 = happySpecReduce_1  114# happyReduction_484
happyReduction_484 happy_x_1
	 =  case happyOut247 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_485 = happySpecReduce_1  114# happyReduction_485
happyReduction_485 happy_x_1
	 =  case happyOut248 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_486 = happySpecReduce_1  114# happyReduction_486
happyReduction_486 happy_x_1
	 =  case happyOut249 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_487 = happySpecReduce_1  114# happyReduction_487
happyReduction_487 happy_x_1
	 =  case happyOut250 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_488 = happySpecReduce_1  114# happyReduction_488
happyReduction_488 happy_x_1
	 =  case happyOut251 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_489 = happySpecReduce_1  114# happyReduction_489
happyReduction_489 happy_x_1
	 =  case happyOut253 happy_x_1 of { happy_var_1 -> 
	happyIn222
		 (ExplainableStatement happy_var_1
	)}

happyReduce_490 = happySpecReduce_2  115# happyReduction_490
happyReduction_490 happy_x_2
	happy_x_1
	 =  case happyOut222 happy_x_2 of { happy_var_2 -> 
	happyIn223
		 (Explain happy_var_2
	)}

happyReduce_491 = happyReduce 4# 116# happyReduction_491
happyReduction_491 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut222 happy_x_4 of { happy_var_4 -> 
	happyIn224
		 (ExplainQueryPlan happy_var_4
	) `HappyStk` happyRest}

happyReduce_492 = happyReduce 4# 117# happyReduction_492
happyReduction_492 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut256 happy_x_3 of { happy_var_3 -> 
	case happyOut152 happy_x_4 of { happy_var_4 -> 
	happyIn225
		 (AlterTable happy_var_3 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_493 = happySpecReduce_2  118# happyReduction_493
happyReduction_493 happy_x_2
	happy_x_1
	 =  case happyOut256 happy_x_2 of { happy_var_2 -> 
	happyIn226
		 (Analyze happy_var_2
	)}

happyReduce_494 = happyReduce 5# 119# happyReduction_494
happyReduction_494 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut216 happy_x_2 of { happy_var_2 -> 
	case happyOutTok happy_x_3 of { (LiteralString happy_var_3) -> 
	case happyOut254 happy_x_5 of { happy_var_5 -> 
	happyIn227
		 (Attach happy_var_2 happy_var_3 happy_var_5
	) `HappyStk` happyRest}}}

happyReduce_495 = happySpecReduce_3  120# happyReduction_495
happyReduction_495 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut215 happy_x_2 of { happy_var_2 -> 
	case happyOut214 happy_x_3 of { happy_var_3 -> 
	happyIn228
		 (Begin happy_var_2 happy_var_3
	)}}

happyReduce_496 = happySpecReduce_2  121# happyReduction_496
happyReduction_496 happy_x_2
	happy_x_1
	 =  case happyOut213 happy_x_1 of { happy_var_1 -> 
	case happyOut214 happy_x_2 of { happy_var_2 -> 
	happyIn229
		 (Commit happy_var_1 happy_var_2
	)}}

happyReduce_497 = happyReduce 10# 122# happyReduction_497
happyReduction_497 (happy_x_10 `HappyStk`
	happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut142 happy_x_2 of { happy_var_2 -> 
	case happyOut143 happy_x_4 of { happy_var_4 -> 
	case happyOut256 happy_x_5 of { happy_var_5 -> 
	case happyOut254 happy_x_7 of { happy_var_7 -> 
	case happyOut157 happy_x_9 of { happy_var_9 -> 
	happyIn230
		 (CreateIndex happy_var_2 happy_var_4 happy_var_5 happy_var_7 (fromJust $ mkOneOrMore happy_var_9)
	) `HappyStk` happyRest}}}}}

happyReduce_498 = happyReduce 6# 123# happyReduction_498
happyReduction_498 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut146 happy_x_2 of { happy_var_2 -> 
	case happyOut143 happy_x_4 of { happy_var_4 -> 
	case happyOut256 happy_x_5 of { happy_var_5 -> 
	case happyOut163 happy_x_6 of { happy_var_6 -> 
	happyIn231
		 (CreateTable happy_var_2 happy_var_4 happy_var_5 happy_var_6
	) `HappyStk` happyRest}}}}

happyReduce_499 = happyReduce 14# 124# happyReduction_499
happyReduction_499 (happy_x_14 `HappyStk`
	happy_x_13 `HappyStk`
	happy_x_12 `HappyStk`
	happy_x_11 `HappyStk`
	happy_x_10 `HappyStk`
	happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut146 happy_x_2 of { happy_var_2 -> 
	case happyOut143 happy_x_4 of { happy_var_4 -> 
	case happyOut256 happy_x_5 of { happy_var_5 -> 
	case happyOut164 happy_x_6 of { happy_var_6 -> 
	case happyOut165 happy_x_7 of { happy_var_7 -> 
	case happyOut254 happy_x_8 of { happy_var_8 -> 
	case happyOut145 happy_x_9 of { happy_var_9 -> 
	case happyOut204 happy_x_10 of { happy_var_10 -> 
	case happyOut170 happy_x_12 of { happy_var_12 -> 
	happyIn232
		 (CreateTrigger happy_var_2 happy_var_4 happy_var_5 happy_var_6 happy_var_7 happy_var_8 happy_var_9 happy_var_10 (fromJust $ mkOneOrMore happy_var_12)
	) `HappyStk` happyRest}}}}}}}}}

happyReduce_500 = happyReduce 7# 125# happyReduction_500
happyReduction_500 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut146 happy_x_2 of { happy_var_2 -> 
	case happyOut143 happy_x_4 of { happy_var_4 -> 
	case happyOut256 happy_x_5 of { happy_var_5 -> 
	case happyOut249 happy_x_7 of { happy_var_7 -> 
	happyIn233
		 (CreateView happy_var_2 happy_var_4 happy_var_5 happy_var_7
	) `HappyStk` happyRest}}}}

happyReduce_501 = happyReduce 6# 126# happyReduction_501
happyReduction_501 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut256 happy_x_4 of { happy_var_4 -> 
	case happyOut254 happy_x_6 of { happy_var_6 -> 
	happyIn234
		 (CreateVirtualTable happy_var_4 happy_var_6 []
	) `HappyStk` happyRest}}

happyReduce_502 = happyReduce 9# 126# happyReduction_502
happyReduction_502 (happy_x_9 `HappyStk`
	happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut256 happy_x_4 of { happy_var_4 -> 
	case happyOut254 happy_x_6 of { happy_var_6 -> 
	case happyOut168 happy_x_8 of { happy_var_8 -> 
	happyIn234
		 (CreateVirtualTable happy_var_4 happy_var_6 happy_var_8
	) `HappyStk` happyRest}}}

happyReduce_503 = happyReduce 4# 127# happyReduction_503
happyReduction_503 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut171 happy_x_3 of { happy_var_3 -> 
	case happyOut196 happy_x_4 of { happy_var_4 -> 
	happyIn235
		 (Delete happy_var_3 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_504 = happyReduce 6# 128# happyReduction_504
happyReduction_504 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut171 happy_x_3 of { happy_var_3 -> 
	case happyOut196 happy_x_4 of { happy_var_4 -> 
	case happyOut200 happy_x_5 of { happy_var_5 -> 
	case happyOut201 happy_x_6 of { happy_var_6 -> 
	happyIn236
		 (DeleteLimited happy_var_3 happy_var_4 happy_var_5 happy_var_6
	) `HappyStk` happyRest}}}}

happyReduce_505 = happySpecReduce_1  129# happyReduction_505
happyReduction_505 happy_x_1
	 =  case happyOut235 happy_x_1 of { happy_var_1 -> 
	happyIn237
		 (Statement happy_var_1
	)}

happyReduce_506 = happySpecReduce_1  129# happyReduction_506
happyReduction_506 happy_x_1
	 =  case happyOut236 happy_x_1 of { happy_var_1 -> 
	happyIn237
		 (Statement happy_var_1
	)}

happyReduce_507 = happySpecReduce_3  130# happyReduction_507
happyReduction_507 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut216 happy_x_2 of { happy_var_2 -> 
	case happyOut254 happy_x_3 of { happy_var_3 -> 
	happyIn238
		 (Detach happy_var_2 happy_var_3
	)}}

happyReduce_508 = happyReduce 4# 131# happyReduction_508
happyReduction_508 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut144 happy_x_3 of { happy_var_3 -> 
	case happyOut256 happy_x_4 of { happy_var_4 -> 
	happyIn239
		 (DropIndex happy_var_3 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_509 = happyReduce 4# 132# happyReduction_509
happyReduction_509 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut144 happy_x_3 of { happy_var_3 -> 
	case happyOut256 happy_x_4 of { happy_var_4 -> 
	happyIn240
		 (DropTable happy_var_3 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_510 = happyReduce 4# 133# happyReduction_510
happyReduction_510 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut144 happy_x_3 of { happy_var_3 -> 
	case happyOut256 happy_x_4 of { happy_var_4 -> 
	happyIn241
		 (DropTrigger happy_var_3 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_511 = happyReduce 4# 134# happyReduction_511
happyReduction_511 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut144 happy_x_3 of { happy_var_3 -> 
	case happyOut256 happy_x_4 of { happy_var_4 -> 
	happyIn242
		 (DropView happy_var_3 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_512 = happyReduce 4# 135# happyReduction_512
happyReduction_512 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut176 happy_x_1 of { happy_var_1 -> 
	case happyOut256 happy_x_3 of { happy_var_3 -> 
	case happyOut177 happy_x_4 of { happy_var_4 -> 
	happyIn243
		 (Insert happy_var_1 happy_var_3 happy_var_4
	) `HappyStk` happyRest}}}

happyReduce_513 = happySpecReduce_3  136# happyReduction_513
happyReduction_513 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut256 happy_x_2 of { happy_var_2 -> 
	case happyOut174 happy_x_3 of { happy_var_3 -> 
	happyIn244
		 (Pragma happy_var_2 happy_var_3
	)}}

happyReduce_514 = happySpecReduce_2  137# happyReduction_514
happyReduction_514 happy_x_2
	happy_x_1
	 =  case happyOut256 happy_x_2 of { happy_var_2 -> 
	happyIn245
		 (Reindex happy_var_2
	)}

happyReduce_515 = happySpecReduce_3  138# happyReduction_515
happyReduction_515 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut218 happy_x_2 of { happy_var_2 -> 
	case happyOut254 happy_x_3 of { happy_var_3 -> 
	happyIn246
		 (Release happy_var_2 happy_var_3
	)}}

happyReduce_516 = happySpecReduce_3  139# happyReduction_516
happyReduction_516 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut214 happy_x_2 of { happy_var_2 -> 
	case happyOut217 happy_x_3 of { happy_var_3 -> 
	happyIn247
		 (Rollback happy_var_2 happy_var_3
	)}}

happyReduce_517 = happySpecReduce_2  140# happyReduction_517
happyReduction_517 happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_2 of { happy_var_2 -> 
	happyIn248
		 (Savepoint happy_var_2
	)}

happyReduce_518 = happyReduce 4# 141# happyReduction_518
happyReduction_518 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut183 happy_x_1 of { happy_var_1 -> 
	case happyOut184 happy_x_2 of { happy_var_2 -> 
	case happyOut200 happy_x_3 of { happy_var_3 -> 
	case happyOut202 happy_x_4 of { happy_var_4 -> 
	happyIn249
		 (Select happy_var_1 happy_var_2 happy_var_3 happy_var_4
	) `HappyStk` happyRest}}}}

happyReduce_519 = happyReduce 5# 142# happyReduction_519
happyReduction_519 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut178 happy_x_1 of { happy_var_1 -> 
	case happyOut171 happy_x_2 of { happy_var_2 -> 
	case happyOut137 happy_x_4 of { happy_var_4 -> 
	case happyOut196 happy_x_5 of { happy_var_5 -> 
	happyIn250
		 (Update happy_var_1 happy_var_2 (fromJust $ mkOneOrMore happy_var_4) happy_var_5
	) `HappyStk` happyRest}}}}

happyReduce_520 = happyReduce 7# 143# happyReduction_520
happyReduction_520 (happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut178 happy_x_1 of { happy_var_1 -> 
	case happyOut171 happy_x_2 of { happy_var_2 -> 
	case happyOut137 happy_x_4 of { happy_var_4 -> 
	case happyOut196 happy_x_5 of { happy_var_5 -> 
	case happyOut200 happy_x_6 of { happy_var_6 -> 
	case happyOut201 happy_x_7 of { happy_var_7 -> 
	happyIn251
		 (UpdateLimited happy_var_1 happy_var_2 (fromJust $ mkOneOrMore happy_var_4) happy_var_5 happy_var_6 happy_var_7
	) `HappyStk` happyRest}}}}}}

happyReduce_521 = happySpecReduce_1  144# happyReduction_521
happyReduction_521 happy_x_1
	 =  case happyOut250 happy_x_1 of { happy_var_1 -> 
	happyIn252
		 (Statement happy_var_1
	)}

happyReduce_522 = happySpecReduce_1  144# happyReduction_522
happyReduction_522 happy_x_1
	 =  case happyOut251 happy_x_1 of { happy_var_1 -> 
	happyIn252
		 (Statement happy_var_1
	)}

happyReduce_523 = happySpecReduce_1  145# happyReduction_523
happyReduction_523 happy_x_1
	 =  happyIn253
		 (Vacuum
	)

happyReduce_524 = happySpecReduce_1  146# happyReduction_524
happyReduction_524 happy_x_1
	 =  case happyOutTok happy_x_1 of { (Identifier happy_var_1) -> 
	happyIn254
		 (UnqualifiedIdentifier happy_var_1
	)}

happyReduce_525 = happySpecReduce_1  147# happyReduction_525
happyReduction_525 happy_x_1
	 =  case happyOut254 happy_x_1 of { happy_var_1 -> 
	happyIn255
		 ([happy_var_1]
	)}

happyReduce_526 = happySpecReduce_3  147# happyReduction_526
happyReduction_526 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut255 happy_x_1 of { happy_var_1 -> 
	case happyOut254 happy_x_3 of { happy_var_3 -> 
	happyIn255
		 (happy_var_1 ++ [happy_var_3]
	)}}

happyReduce_527 = happySpecReduce_1  148# happyReduction_527
happyReduction_527 happy_x_1
	 =  case happyOut254 happy_x_1 of { happy_var_1 -> 
	happyIn256
		 (let UnqualifiedIdentifier properName = happy_var_1
      in SinglyQualifiedIdentifier Nothing properName
	)}

happyReduce_528 = happySpecReduce_3  148# happyReduction_528
happyReduction_528 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut254 happy_x_1 of { happy_var_1 -> 
	case happyOut254 happy_x_3 of { happy_var_3 -> 
	happyIn256
		 (let { UnqualifiedIdentifier parentName = happy_var_1;
            UnqualifiedIdentifier properName = happy_var_3 }
      in SinglyQualifiedIdentifier (Just parentName) properName
	)}}

happyReduce_529 = happySpecReduce_1  149# happyReduction_529
happyReduction_529 happy_x_1
	 =  case happyOut256 happy_x_1 of { happy_var_1 -> 
	happyIn257
		 (case happy_var_1 of
        SinglyQualifiedIdentifier Nothing properName
          -> DoublyQualifiedIdentifier Nothing properName
        SinglyQualifiedIdentifier (Just parentName) properName
          -> DoublyQualifiedIdentifier (Just (parentName, Nothing)) properName
	)}

happyReduce_530 = happySpecReduce_3  149# happyReduction_530
happyReduction_530 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut256 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_3 of { (Identifier happy_var_3) -> 
	happyIn257
		 (let properName = happy_var_3
      in case happy_var_1 of
           SinglyQualifiedIdentifier Nothing parentName
             -> DoublyQualifiedIdentifier (Just (parentName, Nothing))
                                          properName
           SinglyQualifiedIdentifier (Just grandparentName) parentName
             -> DoublyQualifiedIdentifier (Just (parentName, Just grandparentName))
                                          properName
	)}}

happyNewToken action sts stk
	= lexerTakingContinuation(\tk -> 
	let cont i = happyDoAction i tk action sts stk in
	case tk of {
	EndOfInputToken -> happyDoAction 155# tk action sts stk;
	Identifier happy_dollar_dollar -> cont 1#;
	LiteralInteger happy_dollar_dollar -> cont 2#;
	LiteralFloat happy_dollar_dollar -> cont 3#;
	LiteralString happy_dollar_dollar -> cont 4#;
	LiteralBlob happy_dollar_dollar -> cont 5#;
	Variable -> cont 6#;
	VariableN happy_dollar_dollar -> cont 7#;
	VariableNamed happy_dollar_dollar -> cont 8#;
	ModuleArgumentToken happy_dollar_dollar -> cont 9#;
	PunctuationBarBar -> cont 10#;
	PunctuationStar -> cont 11#;
	PunctuationSlash -> cont 12#;
	PunctuationPercent -> cont 13#;
	PunctuationPlus -> cont 14#;
	PunctuationMinus -> cont 15#;
	PunctuationLessLess -> cont 16#;
	PunctuationGreaterGreater -> cont 17#;
	PunctuationAmpersand -> cont 18#;
	PunctuationBar -> cont 19#;
	PunctuationLess -> cont 20#;
	PunctuationLessEquals -> cont 21#;
	PunctuationGreater -> cont 22#;
	PunctuationGreaterEquals -> cont 23#;
	PunctuationEquals -> cont 24#;
	PunctuationEqualsEquals -> cont 25#;
	PunctuationBangEquals -> cont 26#;
	PunctuationLessGreater -> cont 27#;
	PunctuationTilde -> cont 28#;
	PunctuationLeftParenthesis -> cont 29#;
	PunctuationRightParenthesis -> cont 30#;
	PunctuationComma -> cont 31#;
	PunctuationDot -> cont 32#;
	PunctuationSemicolon -> cont 33#;
	KeywordAbort -> cont 34#;
	KeywordAction -> cont 35#;
	KeywordAdd -> cont 36#;
	KeywordAfter -> cont 37#;
	KeywordAll -> cont 38#;
	KeywordAlter -> cont 39#;
	KeywordAnalyze -> cont 40#;
	KeywordAnd -> cont 41#;
	KeywordAs -> cont 42#;
	KeywordAsc -> cont 43#;
	KeywordAttach -> cont 44#;
	KeywordAutoincrement -> cont 45#;
	KeywordBefore -> cont 46#;
	KeywordBegin -> cont 47#;
	KeywordBetween -> cont 48#;
	KeywordBy -> cont 49#;
	KeywordCascade -> cont 50#;
	KeywordCase -> cont 51#;
	KeywordCast -> cont 52#;
	KeywordCheck -> cont 53#;
	KeywordCollate -> cont 54#;
	KeywordColumn -> cont 55#;
	KeywordCommit -> cont 56#;
	KeywordConflict -> cont 57#;
	KeywordConstraint -> cont 58#;
	KeywordCreate -> cont 59#;
	KeywordCross -> cont 60#;
	KeywordCurrentDate -> cont 61#;
	KeywordCurrentTime -> cont 62#;
	KeywordCurrentTimestamp -> cont 63#;
	KeywordDatabase -> cont 64#;
	KeywordDefault -> cont 65#;
	KeywordDeferrable -> cont 66#;
	KeywordDeferred -> cont 67#;
	KeywordDelete -> cont 68#;
	KeywordDesc -> cont 69#;
	KeywordDetach -> cont 70#;
	KeywordDistinct -> cont 71#;
	KeywordDrop -> cont 72#;
	KeywordEach -> cont 73#;
	KeywordElse -> cont 74#;
	KeywordEnd -> cont 75#;
	KeywordEscape -> cont 76#;
	KeywordExcept -> cont 77#;
	KeywordExclusive -> cont 78#;
	KeywordExists -> cont 79#;
	KeywordExplain -> cont 80#;
	KeywordFail -> cont 81#;
	KeywordFor -> cont 82#;
	KeywordForeign -> cont 83#;
	KeywordFrom -> cont 84#;
	KeywordFull -> cont 85#;
	KeywordGlob -> cont 86#;
	KeywordGroup -> cont 87#;
	KeywordHaving -> cont 88#;
	KeywordIf -> cont 89#;
	KeywordIgnore -> cont 90#;
	KeywordImmediate -> cont 91#;
	KeywordIn -> cont 92#;
	KeywordIndex -> cont 93#;
	KeywordIndexed -> cont 94#;
	KeywordInitially -> cont 95#;
	KeywordInner -> cont 96#;
	KeywordInsert -> cont 97#;
	KeywordInstead -> cont 98#;
	KeywordIntersect -> cont 99#;
	KeywordInto -> cont 100#;
	KeywordIs -> cont 101#;
	KeywordIsnull -> cont 102#;
	KeywordJoin -> cont 103#;
	KeywordKey -> cont 104#;
	KeywordLeft -> cont 105#;
	KeywordLike -> cont 106#;
	KeywordLimit -> cont 107#;
	KeywordMatch -> cont 108#;
	KeywordNatural -> cont 109#;
	KeywordNo -> cont 110#;
	KeywordNot -> cont 111#;
	KeywordNotnull -> cont 112#;
	KeywordNull -> cont 113#;
	KeywordOf -> cont 114#;
	KeywordOffset -> cont 115#;
	KeywordOn -> cont 116#;
	KeywordOr -> cont 117#;
	KeywordOrder -> cont 118#;
	KeywordOuter -> cont 119#;
	KeywordPlan -> cont 120#;
	KeywordPragma -> cont 121#;
	KeywordPrimary -> cont 122#;
	KeywordQuery -> cont 123#;
	KeywordRaise -> cont 124#;
	KeywordReferences -> cont 125#;
	KeywordRegexp -> cont 126#;
	KeywordReindex -> cont 127#;
	KeywordRelease -> cont 128#;
	KeywordRename -> cont 129#;
	KeywordReplace -> cont 130#;
	KeywordRestrict -> cont 131#;
	KeywordRight -> cont 132#;
	KeywordRollback -> cont 133#;
	KeywordRow -> cont 134#;
	KeywordSavepoint -> cont 135#;
	KeywordSelect -> cont 136#;
	KeywordSet -> cont 137#;
	KeywordTable -> cont 138#;
	KeywordTemp -> cont 139#;
	KeywordTemporary -> cont 140#;
	KeywordThen -> cont 141#;
	KeywordTo -> cont 142#;
	KeywordTransaction -> cont 143#;
	KeywordTrigger -> cont 144#;
	KeywordUnion -> cont 145#;
	KeywordUnique -> cont 146#;
	KeywordUpdate -> cont 147#;
	KeywordUsing -> cont 148#;
	KeywordVacuum -> cont 149#;
	KeywordValues -> cont 150#;
	KeywordView -> cont 151#;
	KeywordVirtual -> cont 152#;
	KeywordWhen -> cont 153#;
	KeywordWhere -> cont 154#;
	_ -> happyError' tk
	})

happyError_ tk = happyError' tk

happyThen :: () => Parse a -> (a -> Parse b) -> Parse b
happyThen = (>>=)
happyReturn :: () => a -> Parse a
happyReturn = (return)
happyThen1 = happyThen
happyReturn1 :: () => a -> Parse a
happyReturn1 = happyReturn
happyError' :: () => (Token) -> Parse a
happyError' tk = parseError tk

parseType = happySomeParser where
  happySomeParser = happyThen (happyParse 0#) (\x -> happyReturn (happyOut108 x))

parseMaybeType = happySomeParser where
  happySomeParser = happyThen (happyParse 1#) (\x -> happyReturn (happyOut109 x))

parseMaybeTypeSize = happySomeParser where
  happySomeParser = happyThen (happyParse 2#) (\x -> happyReturn (happyOut110 x))

parseTypeSizeField = happySomeParser where
  happySomeParser = happyThen (happyParse 3#) (\x -> happyReturn (happyOut111 x))

parseLikeType = happySomeParser where
  happySomeParser = happyThen (happyParse 4#) (\x -> happyReturn (happyOut112 x))

parseEscape = happySomeParser where
  happySomeParser = happyThen (happyParse 5#) (\x -> happyReturn (happyOut113 x))

parseMaybeSwitchExpression = happySomeParser where
  happySomeParser = happyThen (happyParse 6#) (\x -> happyReturn (happyOut138 x))

parseCasePair = happySomeParser where
  happySomeParser = happyThen (happyParse 7#) (\x -> happyReturn (happyOut140 x))

parseElse = happySomeParser where
  happySomeParser = happyThen (happyParse 8#) (\x -> happyReturn (happyOut141 x))

parseExpression = happySomeParser where
  happySomeParser = happyThen (happyParse 9#) (\x -> happyReturn (happyOut134 x))

parseMaybeUnique = happySomeParser where
  happySomeParser = happyThen (happyParse 10#) (\x -> happyReturn (happyOut142 x))

parseMaybeIfNotExists = happySomeParser where
  happySomeParser = happyThen (happyParse 11#) (\x -> happyReturn (happyOut143 x))

parseMaybeIfExists = happySomeParser where
  happySomeParser = happyThen (happyParse 12#) (\x -> happyReturn (happyOut144 x))

parseMaybeForEachRow = happySomeParser where
  happySomeParser = happyThen (happyParse 13#) (\x -> happyReturn (happyOut145 x))

parseMaybeTemporary = happySomeParser where
  happySomeParser = happyThen (happyParse 14#) (\x -> happyReturn (happyOut146 x))

parseMaybeCollation = happySomeParser where
  happySomeParser = happyThen (happyParse 15#) (\x -> happyReturn (happyOut147 x))

parseMaybeAscDesc = happySomeParser where
  happySomeParser = happyThen (happyParse 16#) (\x -> happyReturn (happyOut148 x))

parseMaybeAutoincrement = happySomeParser where
  happySomeParser = happyThen (happyParse 17#) (\x -> happyReturn (happyOut149 x))

parseMaybeSign = happySomeParser where
  happySomeParser = happyThen (happyParse 18#) (\x -> happyReturn (happyOut150 x))

parseMaybeColumn = happySomeParser where
  happySomeParser = happyThen (happyParse 19#) (\x -> happyReturn (happyOut151 x))

parseAlterTableBody = happySomeParser where
  happySomeParser = happyThen (happyParse 20#) (\x -> happyReturn (happyOut152 x))

parseColumnDefinition = happySomeParser where
  happySomeParser = happyThen (happyParse 21#) (\x -> happyReturn (happyOut153 x))

parseDefaultValue = happySomeParser where
  happySomeParser = happyThen (happyParse 22#) (\x -> happyReturn (happyOut155 x))

parseIndexedColumn = happySomeParser where
  happySomeParser = happyThen (happyParse 23#) (\x -> happyReturn (happyOut156 x))

parseColumnConstraint = happySomeParser where
  happySomeParser = happyThen (happyParse 24#) (\x -> happyReturn (happyOut159 x))

parseTableConstraint = happySomeParser where
  happySomeParser = happyThen (happyParse 25#) (\x -> happyReturn (happyOut161 x))

parseMaybeConstraintName = happySomeParser where
  happySomeParser = happyThen (happyParse 26#) (\x -> happyReturn (happyOut158 x))

parseTriggerTime = happySomeParser where
  happySomeParser = happyThen (happyParse 27#) (\x -> happyReturn (happyOut164 x))

parseTriggerCondition = happySomeParser where
  happySomeParser = happyThen (happyParse 28#) (\x -> happyReturn (happyOut165 x))

parseModuleArgument = happySomeParser where
  happySomeParser = happyThen (happyParse 29#) (\x -> happyReturn (happyOut166 x))

parseTriggerStatement = happySomeParser where
  happySomeParser = happyThen (happyParse 30#) (\x -> happyReturn (happyOut169 x))

parseQualifiedTableName = happySomeParser where
  happySomeParser = happyThen (happyParse 31#) (\x -> happyReturn (happyOut171 x))

parseOrderingTerm = happySomeParser where
  happySomeParser = happyThen (happyParse 32#) (\x -> happyReturn (happyOut172 x))

parsePragmaBody = happySomeParser where
  happySomeParser = happyThen (happyParse 33#) (\x -> happyReturn (happyOut174 x))

parsePragmaValue = happySomeParser where
  happySomeParser = happyThen (happyParse 34#) (\x -> happyReturn (happyOut175 x))

parseCreateTableBody = happySomeParser where
  happySomeParser = happyThen (happyParse 35#) (\x -> happyReturn (happyOut163 x))

parseInsertHead = happySomeParser where
  happySomeParser = happyThen (happyParse 36#) (\x -> happyReturn (happyOut176 x))

parseInsertBody = happySomeParser where
  happySomeParser = happyThen (happyParse 37#) (\x -> happyReturn (happyOut177 x))

parseUpdateHead = happySomeParser where
  happySomeParser = happyThen (happyParse 38#) (\x -> happyReturn (happyOut178 x))

parseDistinctness = happySomeParser where
  happySomeParser = happyThen (happyParse 39#) (\x -> happyReturn (happyOut179 x))

parseMaybeHaving = happySomeParser where
  happySomeParser = happyThen (happyParse 40#) (\x -> happyReturn (happyOut180 x))

parseMaybeAs = happySomeParser where
  happySomeParser = happyThen (happyParse 41#) (\x -> happyReturn (happyOut181 x))

parseCompoundOperator = happySomeParser where
  happySomeParser = happyThen (happyParse 42#) (\x -> happyReturn (happyOut182 x))

parseSelectCore = happySomeParser where
  happySomeParser = happyThen (happyParse 43#) (\x -> happyReturn (happyOut183 x))

parseResultColumn = happySomeParser where
  happySomeParser = happyThen (happyParse 44#) (\x -> happyReturn (happyOut185 x))

parseJoinSource = happySomeParser where
  happySomeParser = happyThen (happyParse 45#) (\x -> happyReturn (happyOut187 x))

parseSingleSource = happySomeParser where
  happySomeParser = happyThen (happyParse 46#) (\x -> happyReturn (happyOut189 x))

parseJoinOperation = happySomeParser where
  happySomeParser = happyThen (happyParse 47#) (\x -> happyReturn (happyOut190 x))

parseJoinConstraint = happySomeParser where
  happySomeParser = happyThen (happyParse 48#) (\x -> happyReturn (happyOut191 x))

parseMaybeIndexedBy = happySomeParser where
  happySomeParser = happyThen (happyParse 49#) (\x -> happyReturn (happyOut192 x))

parseFromClause = happySomeParser where
  happySomeParser = happyThen (happyParse 50#) (\x -> happyReturn (happyOut193 x))

parseWhereClause = happySomeParser where
  happySomeParser = happyThen (happyParse 51#) (\x -> happyReturn (happyOut195 x))

parseGroupClause = happySomeParser where
  happySomeParser = happyThen (happyParse 52#) (\x -> happyReturn (happyOut197 x))

parseOrderClause = happySomeParser where
  happySomeParser = happyThen (happyParse 53#) (\x -> happyReturn (happyOut199 x))

parseLimitClause = happySomeParser where
  happySomeParser = happyThen (happyParse 54#) (\x -> happyReturn (happyOut201 x))

parseWhenClause = happySomeParser where
  happySomeParser = happyThen (happyParse 55#) (\x -> happyReturn (happyOut203 x))

parseConflictClause = happySomeParser where
  happySomeParser = happyThen (happyParse 56#) (\x -> happyReturn (happyOut205 x))

parseForeignKeyClause = happySomeParser where
  happySomeParser = happyThen (happyParse 57#) (\x -> happyReturn (happyOut207 x))

parseForeignKeyClauseActionOrMatchPart = happySomeParser where
  happySomeParser = happyThen (happyParse 58#) (\x -> happyReturn (happyOut208 x))

parseForeignKeyClauseActionPart = happySomeParser where
  happySomeParser = happyThen (happyParse 59#) (\x -> happyReturn (happyOut210 x))

parseMaybeForeignKeyClauseDeferrablePart = happySomeParser where
  happySomeParser = happyThen (happyParse 60#) (\x -> happyReturn (happyOut211 x))

parseMaybeInitialDeferralStatus = happySomeParser where
  happySomeParser = happyThen (happyParse 61#) (\x -> happyReturn (happyOut212 x))

parseCommitHead = happySomeParser where
  happySomeParser = happyThen (happyParse 62#) (\x -> happyReturn (happyOut213 x))

parseMaybeTransaction = happySomeParser where
  happySomeParser = happyThen (happyParse 63#) (\x -> happyReturn (happyOut214 x))

parseMaybeTransactionType = happySomeParser where
  happySomeParser = happyThen (happyParse 64#) (\x -> happyReturn (happyOut215 x))

parseMaybeDatabase = happySomeParser where
  happySomeParser = happyThen (happyParse 65#) (\x -> happyReturn (happyOut216 x))

parseMaybeSavepoint = happySomeParser where
  happySomeParser = happyThen (happyParse 66#) (\x -> happyReturn (happyOut217 x))

parseMaybeReleaseSavepoint = happySomeParser where
  happySomeParser = happyThen (happyParse 67#) (\x -> happyReturn (happyOut218 x))

parseStatementList = happySomeParser where
  happySomeParser = happyThen (happyParse 68#) (\x -> happyReturn (happyOut219 x))

parseAnyStatement = happySomeParser where
  happySomeParser = happyThen (happyParse 69#) (\x -> happyReturn (happyOut221 x))

parseExplainableStatement = happySomeParser where
  happySomeParser = happyThen (happyParse 70#) (\x -> happyReturn (happyOut222 x))

parseExplain = happySomeParser where
  happySomeParser = happyThen (happyParse 71#) (\x -> happyReturn (happyOut223 x))

parseExplainQueryPlan = happySomeParser where
  happySomeParser = happyThen (happyParse 72#) (\x -> happyReturn (happyOut224 x))

parseAlterTable = happySomeParser where
  happySomeParser = happyThen (happyParse 73#) (\x -> happyReturn (happyOut225 x))

parseAnalyze = happySomeParser where
  happySomeParser = happyThen (happyParse 74#) (\x -> happyReturn (happyOut226 x))

parseAttach = happySomeParser where
  happySomeParser = happyThen (happyParse 75#) (\x -> happyReturn (happyOut227 x))

parseBegin = happySomeParser where
  happySomeParser = happyThen (happyParse 76#) (\x -> happyReturn (happyOut228 x))

parseCommit = happySomeParser where
  happySomeParser = happyThen (happyParse 77#) (\x -> happyReturn (happyOut229 x))

parseCreateIndex = happySomeParser where
  happySomeParser = happyThen (happyParse 78#) (\x -> happyReturn (happyOut230 x))

parseCreateTable = happySomeParser where
  happySomeParser = happyThen (happyParse 79#) (\x -> happyReturn (happyOut231 x))

parseCreateTrigger = happySomeParser where
  happySomeParser = happyThen (happyParse 80#) (\x -> happyReturn (happyOut232 x))

parseCreateView = happySomeParser where
  happySomeParser = happyThen (happyParse 81#) (\x -> happyReturn (happyOut233 x))

parseCreateVirtualTable = happySomeParser where
  happySomeParser = happyThen (happyParse 82#) (\x -> happyReturn (happyOut234 x))

parseDelete = happySomeParser where
  happySomeParser = happyThen (happyParse 83#) (\x -> happyReturn (happyOut235 x))

parseDeleteLimited = happySomeParser where
  happySomeParser = happyThen (happyParse 84#) (\x -> happyReturn (happyOut236 x))

parseDeleteOrDeleteLimited = happySomeParser where
  happySomeParser = happyThen (happyParse 85#) (\x -> happyReturn (happyOut237 x))

parseDetach = happySomeParser where
  happySomeParser = happyThen (happyParse 86#) (\x -> happyReturn (happyOut238 x))

parseDropIndex = happySomeParser where
  happySomeParser = happyThen (happyParse 87#) (\x -> happyReturn (happyOut239 x))

parseDropTable = happySomeParser where
  happySomeParser = happyThen (happyParse 88#) (\x -> happyReturn (happyOut240 x))

parseDropTrigger = happySomeParser where
  happySomeParser = happyThen (happyParse 89#) (\x -> happyReturn (happyOut241 x))

parseDropView = happySomeParser where
  happySomeParser = happyThen (happyParse 90#) (\x -> happyReturn (happyOut242 x))

parseInsert = happySomeParser where
  happySomeParser = happyThen (happyParse 91#) (\x -> happyReturn (happyOut243 x))

parsePragma = happySomeParser where
  happySomeParser = happyThen (happyParse 92#) (\x -> happyReturn (happyOut244 x))

parseReindex = happySomeParser where
  happySomeParser = happyThen (happyParse 93#) (\x -> happyReturn (happyOut245 x))

parseRelease = happySomeParser where
  happySomeParser = happyThen (happyParse 94#) (\x -> happyReturn (happyOut246 x))

parseRollback = happySomeParser where
  happySomeParser = happyThen (happyParse 95#) (\x -> happyReturn (happyOut247 x))

parseSavepoint = happySomeParser where
  happySomeParser = happyThen (happyParse 96#) (\x -> happyReturn (happyOut248 x))

parseSelect = happySomeParser where
  happySomeParser = happyThen (happyParse 97#) (\x -> happyReturn (happyOut249 x))

parseUpdate = happySomeParser where
  happySomeParser = happyThen (happyParse 98#) (\x -> happyReturn (happyOut250 x))

parseUpdateLimited = happySomeParser where
  happySomeParser = happyThen (happyParse 99#) (\x -> happyReturn (happyOut251 x))

parseUpdateOrUpdateLimited = happySomeParser where
  happySomeParser = happyThen (happyParse 100#) (\x -> happyReturn (happyOut252 x))

parseVacuum = happySomeParser where
  happySomeParser = happyThen (happyParse 101#) (\x -> happyReturn (happyOut253 x))

parseUnqualifiedIdentifier = happySomeParser where
  happySomeParser = happyThen (happyParse 102#) (\x -> happyReturn (happyOut254 x))

parseSinglyQualifiedIdentifier = happySomeParser where
  happySomeParser = happyThen (happyParse 103#) (\x -> happyReturn (happyOut256 x))

parseDoublyQualifiedIdentifier = happySomeParser where
  happySomeParser = happyThen (happyParse 104#) (\x -> happyReturn (happyOut257 x))

happySeq = happyDontSeq


data ParseError = ParseError {
      parseErrorMessage :: String,
      parseErrorLineNumber :: Word64
    }
instance Error ParseError where
    strMsg message = ParseError {
                            parseErrorMessage = message,
                            parseErrorLineNumber = 0
                          }
instance Show ParseError where
    show parseError = "Line " ++ (show $ parseErrorLineNumber parseError)
                      ++ " of SQL: " ++ (parseErrorMessage parseError)
data ParseState = ParseState {
      parseStateInput :: String,
      parseStateLineNumber :: Word64,
      parseStateLexingModuleArgument :: Bool
    }
type Parse = ErrorT ParseError (State ParseState)

throwParseError :: String -> Parse a
throwParseError message = do
  state <- getParseState
  let lineNumber = parseStateLineNumber state
      error = ParseError {
                parseErrorMessage = message,
                parseErrorLineNumber = lineNumber
              }
  throwError error

getParseState :: Parse ParseState
getParseState = lift get

putParseState :: ParseState -> Parse ()
putParseState state = lift $ put state


readType :: String -> Either ParseError Type
readType input = runParse parseType input


readMaybeType :: String -> Either ParseError MaybeType
readMaybeType input = runParse parseMaybeType input


readMaybeTypeSize :: String -> Either ParseError MaybeTypeSize
readMaybeTypeSize input = runParse parseMaybeTypeSize input


readTypeSizeField :: String -> Either ParseError TypeSizeField
readTypeSizeField input = runParse parseTypeSizeField input


readLikeType :: String -> Either ParseError LikeType
readLikeType input = runParse parseLikeType input


readEscape :: String -> Either ParseError Escape
readEscape input = runParse parseEscape input


readMaybeSwitchExpression :: String -> Either ParseError MaybeSwitchExpression
readMaybeSwitchExpression input = runParse parseMaybeSwitchExpression input


readCasePair :: String -> Either ParseError CasePair
readCasePair input = runParse parseCasePair input


readElse :: String -> Either ParseError Else
readElse input = runParse parseElse input


readExpression :: String -> Either ParseError Expression
readExpression input = runParse parseExpression input


readMaybeUnique :: String -> Either ParseError MaybeUnique
readMaybeUnique input = runParse parseMaybeUnique input


readMaybeIfNotExists :: String -> Either ParseError MaybeIfNotExists
readMaybeIfNotExists input = runParse parseMaybeIfNotExists input


readMaybeIfExists :: String -> Either ParseError MaybeIfExists
readMaybeIfExists input = runParse parseMaybeIfExists input


readMaybeForEachRow :: String -> Either ParseError MaybeForEachRow
readMaybeForEachRow input = runParse parseMaybeForEachRow input


readMaybeTemporary :: String -> Either ParseError MaybeTemporary
readMaybeTemporary input = runParse parseMaybeTemporary input


readMaybeCollation :: String -> Either ParseError MaybeCollation
readMaybeCollation input = runParse parseMaybeCollation input


readMaybeAscDesc :: String -> Either ParseError MaybeAscDesc
readMaybeAscDesc input = runParse parseMaybeAscDesc input


readMaybeAutoincrement :: String -> Either ParseError MaybeAutoincrement
readMaybeAutoincrement input = runParse parseMaybeAutoincrement input


readMaybeSign :: String -> Either ParseError MaybeSign
readMaybeSign input = runParse parseMaybeSign input


readMaybeColumn :: String -> Either ParseError MaybeColumn
readMaybeColumn input = runParse parseMaybeColumn input


readAlterTableBody :: String -> Either ParseError AlterTableBody
readAlterTableBody input = runParse parseAlterTableBody input


readColumnDefinition :: String -> Either ParseError ColumnDefinition
readColumnDefinition input = runParse parseColumnDefinition input


readDefaultValue :: String -> Either ParseError DefaultValue
readDefaultValue input = runParse parseDefaultValue input


readIndexedColumn :: String -> Either ParseError IndexedColumn
readIndexedColumn input = runParse parseIndexedColumn input


readColumnConstraint :: String -> Either ParseError ColumnConstraint
readColumnConstraint input = runParse parseColumnConstraint input


readTableConstraint :: String -> Either ParseError TableConstraint
readTableConstraint input = runParse parseTableConstraint input


readMaybeConstraintName :: String -> Either ParseError MaybeConstraintName
readMaybeConstraintName input = runParse parseMaybeConstraintName input


readTriggerTime :: String -> Either ParseError TriggerTime
readTriggerTime input = runParse parseTriggerTime input


readTriggerCondition :: String -> Either ParseError TriggerCondition
readTriggerCondition input = runParse parseTriggerCondition input


readModuleArgument :: String -> Either ParseError ModuleArgument
readModuleArgument input = runParse parseModuleArgument input


readTriggerStatement :: String -> Either ParseError TriggerStatement
readTriggerStatement input = runParse parseTriggerStatement input


readQualifiedTableName :: String -> Either ParseError QualifiedTableName
readQualifiedTableName input = runParse parseQualifiedTableName input


readOrderingTerm :: String -> Either ParseError OrderingTerm
readOrderingTerm input = runParse parseOrderingTerm input


readPragmaBody :: String -> Either ParseError PragmaBody
readPragmaBody input = runParse parsePragmaBody input


readPragmaValue :: String -> Either ParseError PragmaValue
readPragmaValue input = runParse parsePragmaValue input


readCreateTableBody
    :: String -> Either ParseError CreateTableBody
readCreateTableBody input
    = runParse parseCreateTableBody input


readInsertHead :: String -> Either ParseError InsertHead
readInsertHead input = runParse parseInsertHead input


readInsertBody :: String -> Either ParseError InsertBody
readInsertBody input = runParse parseInsertBody input


readUpdateHead :: String -> Either ParseError UpdateHead
readUpdateHead input = runParse parseUpdateHead input


readDistinctness :: String -> Either ParseError Distinctness
readDistinctness input = runParse parseDistinctness input


readMaybeHaving :: String -> Either ParseError MaybeHaving
readMaybeHaving input = runParse parseMaybeHaving input


readMaybeAs :: String -> Either ParseError MaybeAs
readMaybeAs input = runParse parseMaybeAs input


readCompoundOperator :: String -> Either ParseError CompoundOperator
readCompoundOperator input = runParse parseCompoundOperator input


readSelectCore :: String -> Either ParseError SelectCore
readSelectCore input = runParse parseSelectCore input


readResultColumn :: String -> Either ParseError ResultColumn
readResultColumn input = runParse parseResultColumn input


readJoinSource :: String -> Either ParseError JoinSource
readJoinSource input = runParse parseJoinSource input


readSingleSource :: String -> Either ParseError SingleSource
readSingleSource input = runParse parseSingleSource input


readJoinOperation :: String -> Either ParseError JoinOperation
readJoinOperation input = runParse parseJoinOperation input


readJoinConstraint :: String -> Either ParseError JoinConstraint
readJoinConstraint input = runParse parseJoinConstraint input


readMaybeIndexedBy :: String -> Either ParseError MaybeIndexedBy
readMaybeIndexedBy input = runParse parseMaybeIndexedBy input


readFromClause :: String -> Either ParseError FromClause
readFromClause input = runParse parseFromClause input


readWhereClause :: String -> Either ParseError WhereClause
readWhereClause input = runParse parseWhereClause input


readGroupClause :: String -> Either ParseError GroupClause
readGroupClause input = runParse parseGroupClause input


readOrderClause :: String -> Either ParseError OrderClause
readOrderClause input = runParse parseOrderClause input


readLimitClause :: String -> Either ParseError LimitClause
readLimitClause input = runParse parseLimitClause input


readWhenClause :: String -> Either ParseError WhenClause
readWhenClause input = runParse parseWhenClause input


readConflictClause :: String -> Either ParseError ConflictClause
readConflictClause input = runParse parseConflictClause input


readForeignKeyClause :: String -> Either ParseError ForeignKeyClause
readForeignKeyClause input = runParse parseForeignKeyClause input


readForeignKeyClauseActionOrMatchPart
    :: String -> Either ParseError ForeignKeyClauseActionOrMatchPart
readForeignKeyClauseActionOrMatchPart input
    = runParse parseForeignKeyClauseActionOrMatchPart input


readForeignKeyClauseActionPart
    :: String -> Either ParseError ForeignKeyClauseActionPart
readForeignKeyClauseActionPart input
    = runParse parseForeignKeyClauseActionPart input


readMaybeForeignKeyClauseDeferrablePart
    :: String -> Either ParseError MaybeForeignKeyClauseDeferrablePart
readMaybeForeignKeyClauseDeferrablePart input
    = runParse parseMaybeForeignKeyClauseDeferrablePart input


readMaybeInitialDeferralStatus
    :: String -> Either ParseError MaybeInitialDeferralStatus
readMaybeInitialDeferralStatus input
    = runParse parseMaybeInitialDeferralStatus input


readCommitHead :: String -> Either ParseError CommitHead
readCommitHead input = runParse parseCommitHead input


readMaybeTransaction :: String -> Either ParseError MaybeTransaction
readMaybeTransaction input = runParse parseMaybeTransaction input


readMaybeTransactionType :: String -> Either ParseError MaybeTransactionType
readMaybeTransactionType input = runParse parseMaybeTransactionType input


readMaybeDatabase :: String -> Either ParseError MaybeDatabase
readMaybeDatabase input = runParse parseMaybeDatabase input


readMaybeSavepoint :: String -> Either ParseError MaybeSavepoint
readMaybeSavepoint input = runParse parseMaybeSavepoint input


readMaybeReleaseSavepoint :: String -> Either ParseError MaybeReleaseSavepoint
readMaybeReleaseSavepoint input = runParse parseMaybeReleaseSavepoint input


readStatementList :: String -> Either ParseError StatementList
readStatementList input = runParse parseStatementList input


readAnyStatement :: String -> Either ParseError AnyStatement
readAnyStatement input = runParse parseAnyStatement input


readExplainableStatement :: String -> Either ParseError ExplainableStatement
readExplainableStatement input = runParse parseExplainableStatement input


readExplain :: String -> Either ParseError Explain
readExplain input = runParse parseExplain input


readExplainQueryPlan :: String -> Either ParseError ExplainQueryPlan
readExplainQueryPlan input = runParse parseExplainQueryPlan input


readAlterTable :: String -> Either ParseError AlterTable
readAlterTable input = runParse parseAlterTable input


readAnalyze :: String -> Either ParseError Analyze
readAnalyze input = runParse parseAnalyze input


readAttach :: String -> Either ParseError Attach
readAttach input = runParse parseAttach input


readBegin :: String -> Either ParseError Begin
readBegin input = runParse parseBegin input


readCommit :: String -> Either ParseError Commit
readCommit input = runParse parseCommit input


readCreateIndex :: String -> Either ParseError CreateIndex
readCreateIndex input = runParse parseCreateIndex input


readCreateTable :: String -> Either ParseError CreateTable
readCreateTable input = runParse parseCreateTable input


readCreateTrigger :: String -> Either ParseError CreateTrigger
readCreateTrigger input = runParse parseCreateTrigger input


readCreateView :: String -> Either ParseError CreateView
readCreateView input = runParse parseCreateView input


readCreateVirtualTable :: String -> Either ParseError CreateVirtualTable
readCreateVirtualTable input = runParse parseCreateVirtualTable input


readDelete :: String -> Either ParseError Delete
readDelete input = runParse parseDelete input


readDeleteLimited :: String -> Either ParseError DeleteLimited
readDeleteLimited input = runParse parseDeleteLimited input


readDeleteOrDeleteLimited :: String -> Either ParseError AnyStatement
readDeleteOrDeleteLimited input = runParse parseDeleteOrDeleteLimited input


readDetach :: String -> Either ParseError Detach
readDetach input = runParse parseDetach input


readDropIndex :: String -> Either ParseError DropIndex
readDropIndex input = runParse parseDropIndex input


readDropTable :: String -> Either ParseError DropTable
readDropTable input = runParse parseDropTable input


readDropTrigger :: String -> Either ParseError DropTrigger
readDropTrigger input = runParse parseDropTrigger input


readDropView :: String -> Either ParseError DropView
readDropView input = runParse parseDropView input


readInsert :: String -> Either ParseError Insert
readInsert input = runParse parseInsert input


readPragma :: String -> Either ParseError Pragma
readPragma input = runParse parsePragma input


readReindex :: String -> Either ParseError Reindex
readReindex input = runParse parseReindex input


readRelease :: String -> Either ParseError Release
readRelease input = runParse parseRelease input


readRollback :: String -> Either ParseError Rollback
readRollback input = runParse parseRollback input


readSavepoint :: String -> Either ParseError Savepoint
readSavepoint input = runParse parseSavepoint input


readSelect :: String -> Either ParseError Select
readSelect input = runParse parseSelect input


readUpdate :: String -> Either ParseError Update
readUpdate input = runParse parseUpdate input


readUpdateLimited :: String -> Either ParseError UpdateLimited
readUpdateLimited input = runParse parseUpdateLimited input


readUpdateOrUpdateLimited :: String -> Either ParseError AnyStatement
readUpdateOrUpdateLimited input = runParse parseUpdateOrUpdateLimited input


readVacuum :: String -> Either ParseError Vacuum
readVacuum input = runParse parseVacuum input


readUnqualifiedIdentifier :: String -> Either ParseError UnqualifiedIdentifier
readUnqualifiedIdentifier input = runParse parseUnqualifiedIdentifier input


readSinglyQualifiedIdentifier
    :: String -> Either ParseError SinglyQualifiedIdentifier
readSinglyQualifiedIdentifier input
    = runParse parseSinglyQualifiedIdentifier input


readDoublyQualifiedIdentifier :: String -> Either ParseError DoublyQualifiedIdentifier
readDoublyQualifiedIdentifier input
    = runParse parseDoublyQualifiedIdentifier input


parseError :: Token -> Parse a
parseError token = throwParseError
                     $ "Parsing error near " ++ (show $ show token) ++ "."


runParse :: (Parse a) -> String -> Either ParseError a
runParse parser input =
    let initialState = ParseState {
                         parseStateInput = input,
                         parseStateLineNumber = 1,
                         parseStateLexingModuleArgument = False
                       }
    in evalState (runErrorT parser) initialState


lexerTakingContinuation :: (Token -> Parse a) -> Parse a
lexerTakingContinuation continuation = do
  state <- getParseState
  (token, rest) <- case parseStateLexingModuleArgument state of
                     False -> lexer $ parseStateInput state
                     True -> lexModuleArgument $ parseStateInput state
  state <- getParseState
  putParseState $ state { parseStateInput = rest }
  continuation token


lexer :: String -> Parse (Token, String)
lexer "" = return (EndOfInputToken, "")
lexer all@('.':c:_) | isDigit c = readNumericLiteral all
lexer ('!':'=':rest) = return (PunctuationBangEquals, rest)
lexer ('%':rest) = return (PunctuationPercent, rest)
lexer ('&':rest) = return (PunctuationAmpersand, rest)
lexer ('(':rest) = return (PunctuationLeftParenthesis, rest)
lexer (')':rest) = return (PunctuationRightParenthesis, rest)
lexer ('*':rest) = return (PunctuationStar, rest)
lexer ('+':rest) = return (PunctuationPlus, rest)
lexer (',':rest) = return (PunctuationComma, rest)
lexer ('-':rest) = return (PunctuationMinus, rest)
lexer ('.':rest) = return (PunctuationDot, rest)
lexer ('/':rest) = return (PunctuationSlash, rest)
lexer (';':rest) = return (PunctuationSemicolon, rest)
lexer ('<':'<':rest) = return (PunctuationLessLess, rest)
lexer ('<':'=':rest) = return (PunctuationLessEquals, rest)
lexer ('<':'>':rest) = return (PunctuationLessGreater, rest)
lexer ('<':rest) = return (PunctuationLess, rest)
lexer ('=':'=':rest) = return (PunctuationEqualsEquals, rest)
lexer ('=':rest) = return (PunctuationEquals, rest)
lexer ('>':'=':rest) = return (PunctuationGreaterEquals, rest)
lexer ('>':'>':rest) = return (PunctuationGreaterGreater, rest)
lexer ('>':rest) = return (PunctuationGreater, rest)
lexer ('|':'|':rest) = return (PunctuationBarBar, rest)
lexer ('|':rest) = return (PunctuationBar, rest)
lexer ('~':rest) = return (PunctuationTilde, rest)
lexer ('\n':rest) = do
  state <- getParseState
  let lineNumber = parseStateLineNumber state
  putParseState $ state { parseStateLineNumber = lineNumber + 1 }
  lexer rest
lexer all@('x':'\'':_) = readBlobLiteral all
lexer all@('X':'\'':_) = readBlobLiteral all
lexer all@('\'':_) = readStringLiteral all
lexer all@('"':_) = readQuotedIdentifier all
lexer all@(c:_)
  | isDigit c = readNumericLiteral all
  | isAlpha c = let (identifierOrKeyword, rest) = readIdentifierOrKeyword all
                    keyword = map toLower identifierOrKeyword
                    identifier = identifierOrKeyword
                in case identifierOrKeyword of
                  _ | keyword == "abort" -> return (KeywordAbort, rest)
                    | keyword == "action" -> return (KeywordAction, rest)
                    | keyword == "add" -> return (KeywordAdd, rest)
                    | keyword == "after" -> return (KeywordAfter, rest)
                    | keyword == "all" -> return (KeywordAll, rest)
                    | keyword == "alter" -> return (KeywordAlter, rest)
                    | keyword == "analyze" -> return (KeywordAnalyze, rest)
                    | keyword == "and" -> return (KeywordAnd, rest)
                    | keyword == "as" -> return (KeywordAs, rest)
                    | keyword == "asc" -> return (KeywordAsc, rest)
                    | keyword == "attach" -> return (KeywordAttach, rest)
                    | keyword == "autoincrement"
                        -> return (KeywordAutoincrement, rest)
                    | keyword == "before" -> return (KeywordBefore, rest)
                    | keyword == "begin" -> return (KeywordBegin, rest)
                    | keyword == "between" -> return (KeywordBetween, rest)
                    | keyword == "by" -> return (KeywordBy, rest)
                    | keyword == "cascade" -> return (KeywordCascade, rest)
                    | keyword == "case" -> return (KeywordCase, rest)
                    | keyword == "cast" -> return (KeywordCast, rest)
                    | keyword == "check" -> return (KeywordCheck, rest)
                    | keyword == "collate" -> return (KeywordCollate, rest)
                    | keyword == "column" -> return (KeywordColumn, rest)
                    | keyword == "commit" -> return (KeywordCommit, rest)
                    | keyword == "conflict" -> return (KeywordConflict, rest)
                    | keyword == "constraint" -> return (KeywordConstraint, rest)
                    | keyword == "create" -> return (KeywordCreate, rest)
                    | keyword == "cross" -> return (KeywordCross, rest)
                    | keyword == "current_date" -> return (KeywordCurrentDate, rest)
                    | keyword == "current_time" -> return (KeywordCurrentTime, rest)
                    | keyword == "current_timestamp"
                        -> return (KeywordCurrentTimestamp, rest)
                    | keyword == "database" -> return (KeywordDatabase, rest)
                    | keyword == "default" -> return (KeywordDefault, rest)
                    | keyword == "deferrable" -> return (KeywordDeferrable, rest)
                    | keyword == "deferred" -> return (KeywordDeferred, rest)
                    | keyword == "delete" -> return (KeywordDelete, rest)
                    | keyword == "desc" -> return (KeywordDesc, rest)
                    | keyword == "detach" -> return (KeywordDetach, rest)
                    | keyword == "distinct" -> return (KeywordDistinct, rest)
                    | keyword == "drop" -> return (KeywordDrop, rest)
                    | keyword == "each" -> return (KeywordEach, rest)
                    | keyword == "else" -> return (KeywordElse, rest)
                    | keyword == "end" -> return (KeywordEnd, rest)
                    | keyword == "escape" -> return (KeywordEscape, rest)
                    | keyword == "except" -> return (KeywordExcept, rest)
                    | keyword == "exclusive" -> return (KeywordExclusive, rest)
                    | keyword == "exists" -> return (KeywordExists, rest)
                    | keyword == "explain" -> return (KeywordExplain, rest)
                    | keyword == "fail" -> return (KeywordFail, rest)
                    | keyword == "for" -> return (KeywordFor, rest)
                    | keyword == "foreign" -> return (KeywordForeign, rest)
                    | keyword == "from" -> return (KeywordFrom, rest)
                    | keyword == "full" -> return (KeywordFull, rest)
                    | keyword == "glob" -> return (KeywordGlob, rest)
                    | keyword == "group" -> return (KeywordGroup, rest)
                    | keyword == "having" -> return (KeywordHaving, rest)
                    | keyword == "if" -> return (KeywordIf, rest)
                    | keyword == "ignore" -> return (KeywordIgnore, rest)
                    | keyword == "immediate" -> return (KeywordImmediate, rest)
                    | keyword == "in" -> return (KeywordIn, rest)
                    | keyword == "index" -> return (KeywordIndex, rest)
                    | keyword == "indexed" -> return (KeywordIndexed, rest)
                    | keyword == "initially" -> return (KeywordInitially, rest)
                    | keyword == "inner" -> return (KeywordInner, rest)
                    | keyword == "insert" -> return (KeywordInsert, rest)
                    | keyword == "instead" -> return (KeywordInstead, rest)
                    | keyword == "intersect" -> return (KeywordIntersect, rest)
                    | keyword == "into" -> return (KeywordInto, rest)
                    | keyword == "is" -> return (KeywordIs, rest)
                    | keyword == "isnull" -> return (KeywordIsnull, rest)
                    | keyword == "join" -> return (KeywordJoin, rest)
                    | keyword == "key" -> return (KeywordKey, rest)
                    | keyword == "left" -> return (KeywordLeft, rest)
                    | keyword == "like" -> return (KeywordLike, rest)
                    | keyword == "limit" -> return (KeywordLimit, rest)
                    | keyword == "match" -> return (KeywordMatch, rest)
                    | keyword == "natural" -> return (KeywordNatural, rest)
                    | keyword == "no" -> return (KeywordNo, rest)
                    | keyword == "not" -> return (KeywordNot, rest)
                    | keyword == "notnull" -> return (KeywordNotnull, rest)
                    | keyword == "null" -> return (KeywordNull, rest)
                    | keyword == "of" -> return (KeywordOf, rest)
                    | keyword == "offset" -> return (KeywordOffset, rest)
                    | keyword == "on" -> return (KeywordOn, rest)
                    | keyword == "or" -> return (KeywordOr, rest)
                    | keyword == "order" -> return (KeywordOrder, rest)
                    | keyword == "outer" -> return (KeywordOuter, rest)
                    | keyword == "plan" -> return (KeywordPlan, rest)
                    | keyword == "pragma" -> return (KeywordPragma, rest)
                    | keyword == "primary" -> return (KeywordPrimary, rest)
                    | keyword == "query" -> return (KeywordQuery, rest)
                    | keyword == "raise" -> return (KeywordRaise, rest)
                    | keyword == "references" -> return (KeywordReferences, rest)
                    | keyword == "regexp" -> return (KeywordRegexp, rest)
                    | keyword == "reindex" -> return (KeywordReindex, rest)
                    | keyword == "release" -> return (KeywordRelease, rest)
                    | keyword == "rename" -> return (KeywordRename, rest)
                    | keyword == "replace" -> return (KeywordReplace, rest)
                    | keyword == "restrict" -> return (KeywordRestrict, rest)
                    | keyword == "right" -> return (KeywordRight, rest)
                    | keyword == "rollback" -> return (KeywordRollback, rest)
                    | keyword == "row" -> return (KeywordRow, rest)
                    | keyword == "savepoint" -> return (KeywordSavepoint, rest)
                    | keyword == "select" -> return (KeywordSelect, rest)
                    | keyword == "set" -> return (KeywordSet, rest)
                    | keyword == "table" -> return (KeywordTable, rest)
                    | keyword == "temp" -> return (KeywordTemp, rest)
                    | keyword == "temporary" -> return (KeywordTemporary, rest)
                    | keyword == "then" -> return (KeywordThen, rest)
                    | keyword == "to" -> return (KeywordTo, rest)
                    | keyword == "transaction" -> return (KeywordTransaction, rest)
                    | keyword == "trigger" -> return (KeywordTrigger, rest)
                    | keyword == "union" -> return (KeywordUnion, rest)
                    | keyword == "unique" -> return (KeywordUnique, rest)
                    | keyword == "update" -> return (KeywordUpdate, rest)
                    | keyword == "using" -> return (KeywordUsing, rest)
                    | keyword == "vacuum" -> return (KeywordVacuum, rest)
                    | keyword == "values" -> return (KeywordValues, rest)
                    | keyword == "view" -> return (KeywordView, rest)
                    | keyword == "virtual" -> return (KeywordVirtual, rest)
                    | keyword == "when" -> return (KeywordWhen, rest)
                    | keyword == "where" -> return (KeywordWhere, rest)
                    | otherwise -> return (Identifier identifier, rest)
  | isSpace c = lexer $ drop 1 all
  | otherwise = throwParseError $ "Unexpected character '" ++ [c] ++ "'."


readStringLiteral :: String -> Parse (Token, String)
readStringLiteral input = do
    let readString' ('\'':('\'':rest)) = do
          (a, b) <- readString' rest
          return ("'" ++ a, b)
        readString' ('\'':rest) = return ("", rest)
        readString' (c:rest) = do
          (a, b) <- readString' rest
          return ([c] ++ a, b)
        readString' "" = throwParseError
                           $ "Missing close-quote in string or blob literal."
    (string, unparsed) <- readString' $ drop 1 input
    return (LiteralString string, unparsed)


readBlobLiteral :: String -> Parse (Token, String)
readBlobLiteral input = do
    (LiteralString blobAsText, unparsed) <- readStringLiteral $ drop 1 input
    if (all isHexDigit blobAsText) && ((length blobAsText `mod` 2) == 0)
      then return (LiteralBlob $ read ("\"" ++ blobAsText ++ "\""), unparsed)
      else throwParseError $ "Invalid blob literal."


readQuotedIdentifier :: String -> Parse (Token, String)
readQuotedIdentifier input = do
    let readString' ('"':('"':rest)) = do
          (a, b) <- readString' rest
          return ("\"" ++ a, b)
        readString' ('"':rest) = return ("", rest)
        readString' (c:rest) = do
          (a, b) <- readString' rest
          return ([c] ++ a, b)
        readString' "" = throwParseError
                           $ "Missing close-quote in quoted identifier."
    (string, unparsed) <- readString' $ drop 1 input
    return (Identifier string, unparsed)


readNumericLiteral :: String -> Parse (Token, String)
readNumericLiteral input =
    let (initialDigitSpan, restInitialDigitSpan) = span isDigit input
        (dotSpan, secondDigitSpan, restSecondDigitSpan)
            = if (length restInitialDigitSpan > 0) && (head restInitialDigitSpan == '.')
                then let (secondDigitSpan, restSecondDigitSpan)
                             = span isDigit $ tail restInitialDigitSpan
                     in (take 1 restInitialDigitSpan,
                         secondDigitSpan,
                         restSecondDigitSpan)
                else ("", "", restInitialDigitSpan)
        (exponentESpan, exponentSignSpan, exponentDigitSpan, restExponent)
            = if (length restSecondDigitSpan > 0)
                 && (toLower (head restSecondDigitSpan) == 'e')
                then let (exponentESpan, restE) = (take 1 restSecondDigitSpan,
                                                   drop 1 restSecondDigitSpan)
                         hasExponentSign
                             = (length restE > 0) && (elem (head restE) "+-")
                         (exponentSignSpan, restSign)
                             = if hasExponentSign
                                 then (take 1 $ drop 1 restE, drop 1 restE)
                                 else ("", restE)
                         (exponentDigitSpan, restExponent) = span isDigit restSign
                     in (exponentESpan,
                         exponentSignSpan,
                         exponentDigitSpan,
                         restExponent)
                else ("", "", "", restSecondDigitSpan)
        floatSpan = initialDigitSpan ++ dotSpan ++ secondDigitSpan
                    ++ exponentESpan ++ exponentSignSpan ++ exponentDigitSpan
        isFollowedByIdentifierCharacter
            = case restExponent of
                "" -> False
                (c:_) | (isAlphaNum c) || (elem c "_$") -> True
                      | otherwise -> False
        (trailingIdentifierSpan, _)
            = span (\c -> (isAlphaNum c) || (elem c "_$")) restExponent
        errorSpan = floatSpan ++ trailingIdentifierSpan
        integerResult = let [(initialDigits, _)] = reads initialDigitSpan
                        in return (LiteralInteger initialDigits, restExponent)
        floatResult = let tweakedFloatSpan = if not $ isDigit $ head floatSpan
                                               then "0" ++ floatSpan
                                               else floatSpan
                          [(double, _)] = reads tweakedFloatSpan
                      in return (LiteralFloat $ fromJust $ mkNonnegativeDouble double,
                                 restExponent)
        errorResult = throwParseError $ "Invalid number token " ++ (show errorSpan)
    in case (initialDigitSpan,
             dotSpan,
             secondDigitSpan,
             exponentESpan,
             exponentSignSpan,
             exponentDigitSpan,
             isFollowedByIdentifierCharacter) of
         (_, _, _, _, _, _, True) -> errorResult
         ((_:_), "", "", "", "", "", _) -> integerResult
         (_, ".", _, _, _, _, _) -> floatResult
         (_, _, _, (_:_), _, (_:_), _) -> floatResult
         _ -> errorResult
        

readIdentifierOrKeyword :: String -> (String, String)
readIdentifierOrKeyword input
    = span (\c -> (isAlphaNum c) || (elem c "_$")) input


lexModuleArgument :: String -> Parse (Token, String)
lexModuleArgument input = do
  let readAtParenthesisDepth _ []
          = throwParseError $ "Unexpected end of input in module argument."
      readAtParenthesisDepth 0 (',':rest) = return (",", rest)
      readAtParenthesisDepth 0 (')':rest)
          = throwParseError $ "Unbalanced right parenthesis in module argument."
      readAtParenthesisDepth 0 (c:rest) = do
        (result, rest) <- readAtParenthesisDepth 0 rest
        return ([c] ++ result, rest)
      readAtParenthesisDepth depth ('(':rest) = do
        (result1, rest) <- readAtParenthesisDepth (depth + 1) rest
        (result2, rest) <- readAtParenthesisDepth depth rest
        return ("(" ++ result1 ++ result2, rest)
      readAtParenthesisDepth depth (')':rest) = return (")", rest)
      readAtParenthesisDepth depth (c:rest) = do
        (result, rest) <- readAtParenthesisDepth depth rest
        return ([c] ++ result, rest)
  (result, rest) <- readAtParenthesisDepth 0 input
  state <- getParseState
  putParseState $ state { parseStateLexingModuleArgument = False }
  return (ModuleArgumentToken result, rest)
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
{-# LINE 1 "<built-in>" #-}
{-# LINE 1 "<command-line>" #-}
{-# LINE 1 "templates/GenericTemplate.hs" #-}
-- Id: GenericTemplate.hs,v 1.26 2005/01/14 14:47:22 simonmar Exp 

{-# LINE 30 "templates/GenericTemplate.hs" #-}


data Happy_IntList = HappyCons Happy_GHC_Exts.Int# Happy_IntList





{-# LINE 51 "templates/GenericTemplate.hs" #-}

{-# LINE 61 "templates/GenericTemplate.hs" #-}

{-# LINE 70 "templates/GenericTemplate.hs" #-}

infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

-- If the current token is 0#, it means we've just accepted a partial
-- parse (a %partial parser).  We must ignore the saved token on the top of
-- the stack in this case.
happyAccept 0# tk st sts (_ `HappyStk` ans `HappyStk` _) =
	happyReturn1 ans
happyAccept j tk st sts (HappyStk ans _) = 
	(happyTcHack j (happyTcHack st)) (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action



happyDoAction i tk st
	= {- nothing -}


	  case action of
		0#		  -> {- nothing -}
				     happyFail i tk st
		-1# 	  -> {- nothing -}
				     happyAccept i tk st
		n | (n Happy_GHC_Exts.<# (0# :: Happy_GHC_Exts.Int#)) -> {- nothing -}

				     (happyReduceArr Happy_Data_Array.! rule) i tk st
				     where rule = (Happy_GHC_Exts.I# ((Happy_GHC_Exts.negateInt# ((n Happy_GHC_Exts.+# (1# :: Happy_GHC_Exts.Int#))))))
		n		  -> {- nothing -}


				     happyShift new_state i tk st
				     where (new_state) = (n Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#))
   where (off)    = indexShortOffAddr happyActOffsets st
         (off_i)  = (off Happy_GHC_Exts.+# i)
	 check  = if (off_i Happy_GHC_Exts.>=# (0# :: Happy_GHC_Exts.Int#))
			then (indexShortOffAddr happyCheck off_i Happy_GHC_Exts.==#  i)
			else False
         (action)
          | check     = indexShortOffAddr happyTable off_i
          | otherwise = indexShortOffAddr happyDefActions st

{-# LINE 130 "templates/GenericTemplate.hs" #-}


indexShortOffAddr (HappyA# arr) off =
	Happy_GHC_Exts.narrow16Int# i
  where
        i = Happy_GHC_Exts.word2Int# (Happy_GHC_Exts.or# (Happy_GHC_Exts.uncheckedShiftL# high 8#) low)
        high = Happy_GHC_Exts.int2Word# (Happy_GHC_Exts.ord# (Happy_GHC_Exts.indexCharOffAddr# arr (off' Happy_GHC_Exts.+# 1#)))
        low  = Happy_GHC_Exts.int2Word# (Happy_GHC_Exts.ord# (Happy_GHC_Exts.indexCharOffAddr# arr off'))
        off' = off Happy_GHC_Exts.*# 2#





data HappyAddr = HappyA# Happy_GHC_Exts.Addr#




-----------------------------------------------------------------------------
-- HappyState data type (not arrays)

{-# LINE 163 "templates/GenericTemplate.hs" #-}

-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state 0# tk st sts stk@(x `HappyStk` _) =
     let (i) = (case Happy_GHC_Exts.unsafeCoerce# x of { (Happy_GHC_Exts.I# (i)) -> i }) in
--     trace "shifting the error token" $
     happyDoAction i tk new_state (HappyCons (st) (sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state (HappyCons (st) (sts)) ((happyInTok (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_0 nt fn j tk st@((action)) sts stk
     = happyGoto nt j tk st (HappyCons (st) (sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@((HappyCons (st@(action)) (_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_2 nt fn j tk _ (HappyCons (_) (sts@((HappyCons (st@(action)) (_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_3 nt fn j tk _ (HappyCons (_) ((HappyCons (_) (sts@((HappyCons (st@(action)) (_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#)) sts of
	 sts1@((HappyCons (st1@(action)) (_))) ->
        	let r = fn stk in  -- it doesn't hurt to always seq here...
       		happyDoSeq r (happyGoto nt j tk st1 sts1 r)

happyMonadReduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
        happyThen1 (fn stk tk) (\r -> happyGoto nt j tk st1 sts1 (r `HappyStk` drop_stk))
       where (sts1@((HappyCons (st1@(action)) (_)))) = happyDrop k (HappyCons (st) (sts))
             drop_stk = happyDropStk k stk

happyMonad2Reduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonad2Reduce k nt fn j tk st sts stk =
       happyThen1 (fn stk tk) (\r -> happyNewToken new_state sts1 (r `HappyStk` drop_stk))
       where (sts1@((HappyCons (st1@(action)) (_)))) = happyDrop k (HappyCons (st) (sts))
             drop_stk = happyDropStk k stk

             (off) = indexShortOffAddr happyGotoOffsets st1
             (off_i) = (off Happy_GHC_Exts.+# nt)
             (new_state) = indexShortOffAddr happyTable off_i




happyDrop 0# l = l
happyDrop n (HappyCons (_) (t)) = happyDrop (n Happy_GHC_Exts.-# (1# :: Happy_GHC_Exts.Int#)) t

happyDropStk 0# l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n Happy_GHC_Exts.-# (1#::Happy_GHC_Exts.Int#)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction


happyGoto nt j tk st = 
   {- nothing -}
   happyDoAction j tk new_state
   where (off) = indexShortOffAddr happyGotoOffsets st
         (off_i) = (off Happy_GHC_Exts.+# nt)
         (new_state) = indexShortOffAddr happyTable off_i




-----------------------------------------------------------------------------
-- Error recovery (0# is the error token)

-- parse error if we are in recovery and we fail again
happyFail  0# tk old_st _ stk =
--	trace "failing" $ 
    	happyError_ tk

{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  0# tk old_st (HappyCons ((action)) (sts)) 
						(saved_tok `HappyStk` _ `HappyStk` stk) =
--	trace ("discarding state, depth " ++ show (length stk))  $
	happyDoAction 0# tk action sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (action) sts stk =
--      trace "entering error recovery" $
	happyDoAction 0# tk action sts ( (Happy_GHC_Exts.unsafeCoerce# (Happy_GHC_Exts.I# (i))) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll :: a
notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions


happyTcHack :: Happy_GHC_Exts.Int# -> a -> a
happyTcHack x y = y
{-# INLINE happyTcHack #-}


-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--	happySeq = happyDoSeq
-- otherwise it emits
-- 	happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.


{-# NOINLINE happyDoAction #-}
{-# NOINLINE happyTable #-}
{-# NOINLINE happyCheck #-}
{-# NOINLINE happyActOffsets #-}
{-# NOINLINE happyGotoOffsets #-}
{-# NOINLINE happyDefActions #-}

{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.
